if (window["000a0180686911e78dd0a45d36bb8c5c"] === undefined) {
    /**
     * 录制布局
     * @enum { number }
     */
    CRVideo_ToolBarUI = {
        /**暂停播放按钮*/
        BTN_Pause: 0,
        /**停止播放按钮*/
        BTN_STOP: 1
    }

    var CRVideo = function() {
        var jsVersion = "4.15.0";
        var setSDKParamObj = { "RunInWebbrowser": 1 };
        var win = window,
            doc = document,
            nav = navigator,
            v = "",
            ie = "",
            w3cdom = typeof doc.getElementById !== "undefined" && typeof doc.getElementsByTagName !== "undefined" && typeof doc.createElement !== "undefined",
            u = nav.userAgent.toLowerCase(),
            p = nav.platform.toLowerCase(),
            windows = p ? /win/.test(p) : /win/.test(u),
            mac = p ? /mac/.test(p) : /mac/.test(u),
            webkit = /webkit/.test(u) ? parseFloat(u.replace(/^.*webkit\/(\d+(\.\d+)?).*$/, "$1")) : false, // returns either the webkit version or false if not webkit
            ff = u.indexOf("firefox") > -1 ? true : false; //是否是火狐
        var userAgent = navigator.userAgent; //取得浏览器的userAgent字符串
        var isIE = userAgent.indexOf("compatible") > -1 && userAgent.indexOf("MSIE") > -1; //判断是否IE<11浏览器
        var isEdge = userAgent.indexOf("Edge") > -1 && !isIE; //判断是否IE的Edge浏览器
        var isIE11 = userAgent.indexOf('Trident') > -1 && userAgent.indexOf("rv:11.0") > -1;
        if (isIE) {
            ie = true;
            var reIE = new RegExp("MSIE (\\d+\\.\\d+);");
            reIE.test(userAgent);
            var fIEVersion = parseFloat(RegExp["$1"]);
            if (fIEVersion == 7) {
                v = "7";
            } else if (fIEVersion == 8) {
                v = "8";
            } else if (fIEVersion == 9) {
                v = "9";
            } else if (fIEVersion == 10) {
                v = "10";
            } else {
                v = "6";
            }
        } else if (isEdge) {
            v = "edge";
            ie = true;
        } else if (isIE11) {
            v = 11;
            ie = true;
        } else {
            v = 0;
            ie = false;
        }
        return { "w3": w3cdom, "wk": webkit, "ie": ie, "ff": ff, "win": windows, "mac": mac, "v": v, "EnableLog2File": true, "EnableLogReport": true, "dblClickFullScreen": true, "jsVersion": jsVersion, "setSDKParamObj": setSDKParamObj };
    }()
    CRVideo.addEventListener = function(target, name, fun) {
        if (target.addEventListener) { //所有主流浏览器，除了 IE 8 及更早 IE版本
            target.addEventListener(name, fun);
        } else if (target.attachEvent) { // IE 8 及更早 IE 版本
            target.attachEvent("on" + name, fun);
        };
    }
    /**
     * @class
     */
    CRVideo.CbProxy = function(name) {
        this.name = name;
        this.callback = null;
    }
    /**
     * 显示容器的基类
     * @class
     */
    CRVideo.Container = function() {

    }

    /**
     * object对象
     */
    CRVideo.Container.prototype.handler = function(value) {
        if (value === undefined) {
            return this._handler;
        } else {
            this._handler = value;
        }
    }
    /**
     * id
     */
    CRVideo.Container.prototype.id = function(value) {
        if (value === undefined) {
            return this._handler.id;
            this.__addCallBack();
        } else {
            this._handler.id = value;
        }

    }

    CRVideo.Container.prototype.__addCallBack = function() {

    }
    /**
     * 容器的宽度
     */
    CRVideo.Container.prototype.width = function(value) {
        if (value === undefined) {
            return parseInt(this._handler.style.width);
        } else {
            this._handler.style.width = value + "px";
        }

    }
    /**
     * 容器的高度
     */
    CRVideo.Container.prototype.height = function(value) {
        if (value === undefined) {
            return parseInt(this._handler.style.height);
        } else {
            this._handler.style.height = value + "px";
        }

    }
    /**
     * 容器的样式
     */
    CRVideo.Container.prototype.style = function(key, value) {
        //this._handler.style.display = "none";
        if (key === undefined) {
            return this._handler.style;
        } else {
            if (value === undefined) {
                return this._handler.style[key];
            } else {
                this._handler.style[key] = value;
            }
        }
    }
    CRVideo._containerList = [];
    /**
     * 影音播放的呈现容器
     * @class
     * @extends CRVideo.Container
     */
    CRVideo.MediaContainer = function() {
        CRVideo._containerList.push(this)
    }
    CRVideo.MediaContainer.prototype = new CRVideo.Container()

    CRVideo.MediaContainer.prototype.__addCallBack = function() {

    }
    /**
     * 保存播放影音画面到图片文件
     * @param {string} pathFileName - 本地绝对路径文件名(支持格式：bmp, png, gif, jpg, jpeg)
     * @return {number} 0成功，非0失败
     */
    CRVideo.MediaContainer.prototype.savePicToFile = function(pathFileName) {
        return this._handler.savePicToFile(pathFileName);
    }
    CRVideo.MediaContainer.prototype.show = function() {
        return this._handler.show();
    }
    CRVideo.MediaContainer.prototype.hide = function() {
        return this._handler.hide();
    }
    /**
     * 保存播放影音画面到图片文件
     * @param {string} format - 支持格式:bmp, png, gif, jpg, jpeg
     * @return {string} Base64字符串
     */
    CRVideo.MediaContainer.prototype.savePicToBase64 = function(format) {
        return this._handler.savePicToBase64(format);
    }
    /**
     * 截图拍照
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {string} 图片数据的safe array，不成功返0长度的array
     */
    CRVideo.MediaContainer.prototype.savePicToArray = function(format) {
        return this._handler.savePicToArray(format);
    }
    /**
     * 获取图像时间戳
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {number} 当前图像数据对应的时间戳
     */
    CRVideo.MediaContainer.prototype.getPicFrameTime = function() {
        return this._handler.getPicFrameTime();
    }
    /**
     * 显示隐藏播放工具条上的界面元素
     * @access public
     * @param {CRVideo_ToolBarUI} UIElement  -  界面元素
     * @param {bool } isVisible   -  是否可见
     */
    CRVideo.MediaContainer.prototype.setToolBarUIElementVisible = function(UIElement, isVisible) {
        this._handler.setToolBarUIElementVisible(UIElement, isVisible);
    }
    /**
     * 设置工具条的高度
     * @access public
     * @param {number} size  -  工具条高度,取值范围(24-48) 
     */
    CRVideo.MediaContainer.prototype.setToolBarSize = function(size) {
        this._handler.setToolBarSize(size);
    }
    /**
     * 禁止调整播放位置
     * @access public
     * @param {number} bDisable  -  是否禁止调整播放位置（1  -- 禁止） 
     */
    CRVideo.MediaContainer.prototype.disableChangePlayPos = function(bDisable) {
        this._handler.disableChangePlayPos(bDisable);
    }
    /**
     * 设置全屏
     * @access public
     * @param {bool} bFullScreen  -  true 全屏
     */
    CRVideo.MediaContainer.prototype.setFullScreen = function(bFullScreen) {
        this._handler.setFullScreen(bFullScreen);
    }
    /**
     * 获取全屏
     * @access public
     * @return {bool} bFullScreen  -  true 全屏
     */
    CRVideo.MediaContainer.prototype.getFullScreen = function() {
        return this._handler.getFullScreen();
    }
    /**
     * 设置图像显示模式
     * @access public
     * @param {int} scaleType  - 0: 等比例缩放留空居中显示;
     * @return 无
     */
    CRVideo.MediaContainer.prototype.setScaleType = function(scaleType) {
        this._handler.setScaleType();
    }

    /**
     * 绘制模式，是否拉伸绘制
     * @param {bool} value - true: 保持比例不拉伸， false:不保持比例进行拉伸
     */
    CRVideo.MediaContainer.prototype.keepAspectRatio = function(value) {
        if (value === undefined) {
            return this._handler.keepAspectRatio;
        } else {
            this._handler.keepAspectRatio = value;
        }
    }
    /**
     * 设置是否支持双击全屏
     * @param {bool} value - true: 支持双击全屏； false:不支持双击全屏
     */
    CRVideo.MediaContainer.prototype.dblClickFullScreen = function(value) {
        if (value === undefined) {
            return this._handler.dblClickFullScreen;
        } else {
            this._handler.dblClickFullScreen = value;
        }
    }
    /**
     * 工具条是否可用
     * @param {number} bDisable -  0:可用; 非0:不可用;
     */
    CRVideo.MediaContainer.prototype.disableToolBar = function(disable) {
        this._handler.disableToolBar(disable);
    }
    /**
     * 视频的呈现容器
     * @class
     * @extends CRVideo.Container
     */
    CRVideo.VideoContainer = function() {
        this._videoID = -1;
        this._usrID = "";
        this._visibleNickName = true;
        CRVideo._containerList.push(this)
    }
    CRVideo.VideoContainer.prototype = new CRVideo.Container()
    // CRVideo.VideoContainer.prototype.__addCallBack = function()
    // {

    // }
    /**
     *叠加视频时，将视频容器放在上层
     *注意：创建及布局UI控件时，底层的先创建先放入DOM树
     * @access public
     */
    CRVideo.VideoContainer.prototype.raise = function() {
        this._handler.raise();
    }
    /**
     * 设置显示的目标用户视频
     * @access public
     * @param {string} userID - 目标用户ID
     * @param {number } videoID - 用户的指定视频设备（-1，代表用户的默认视频设备）
     */
    CRVideo.VideoContainer.prototype.setVideo = function(usrID, videoID) {
        if (videoID == undefined) {
            videoID = -1
        }
        this._usrID = usrID;
        this._videoID = videoID;
        this._handler.setVideo(usrID, videoID);
    }
    /**
     * 获取当前显示的用户
     * @access public
     * @return {string} 用户ID
     */
    CRVideo.VideoContainer.prototype.getUserID = function() {
        return this._handler.getUserID();
    }
    /**
     * 获取当前显示的用户的视频设备
     * @access public
     * @return {string} 视频ID
     */
    CRVideo.VideoContainer.prototype.getVideoID = function() {
        return this._handler.getVideoID();
    }
    /**
     * 拍照
     * @access public
     * @param {string} pathFileName - 本地绝对路径文件名(支持格式：bmp, png, gif, jpg, jpeg)
     * @return {bool} 0:成功； 非0：保存遇到的错误码；
     */
    CRVideo.VideoContainer.prototype.savePic = function(pathFileName) {
        return this._handler.savePic(pathFileName);
    }
    /**
     * 拍照
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {string} Base64为图片数据字符串，不成功则为空
     */
    CRVideo.VideoContainer.prototype.savePicToBase64 = function(format) {
        return this._handler.savePicToBase64(format);
    }
    /**
     * 截图拍照
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {string} 图片数据的safe array，不成功返0长度的array
     */
    CRVideo.VideoContainer.prototype.savePicToArray = function(format) {
        return this._handler.savePicToArray(format);
    }
    /**
     * 获取图像时间戳
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {number} 当前图像数据对应的时间戳
     */
    CRVideo.VideoContainer.prototype.getPicFrameTime = function() {
        return this._handler.getPicFrameTime();
    }
    /**
     * 清理当前图像
     * @access public
     */
    CRVideo.VideoContainer.prototype.clear = function() {
        return this._handler.clear();
    }
    /**在视频窗口上显示一个遮罩图片
     * @param {string} base64PNG - base64格式的png图像数据
     * @param {bool} bScaleToFitVideoUI - true:铺满视频窗口，false:居中显示
     * @access public
     */
    CRVideo.VideoContainer.prototype.setMaskPic = function(base64PNG, bScaleToFitVideoUI) {
        this._handler.setMaskPic(base64PNG, bScaleToFitVideoUI);
    }
    /**设置拍照区域
     * @param {number} p_x - 相对于VideoUI控件的左上角位置
     * @param {number} p_y - 相对于VideoUI控件的左上角位置
     * @param {number} p_w - 拍照的图像大小
     * @param {number} p_h - 拍照的图像大小
     * @access public
     */
    CRVideo.VideoContainer.prototype.setSavePicRect = function(p_x, p_y, p_w, p_h) {
        this._handler.setSavePicRect(p_x, p_y, p_w, p_h);
    }
    /**获取图像宽
     * @access public
     * @return {number} 宽
     */
    CRVideo.VideoContainer.prototype.getPicWidth = function() {
        return this._handler.getPicWidth();
    }
    /**获取图像高
     * @access public
     * @return {number} 高
     */
    CRVideo.VideoContainer.prototype.getPicHeight = function() {
        return this._handler.getPicHeight();
    }
    /**设置显示目标用户的第2、第3档视频
     * @access public
     * @param {string} ◦userID - 目标用户ID
     * @param {string} ◦videoID - 目标摄像头ID
     * @param {number} ◦qualityLv - 视频档位(1:默认档位，2:对应quality2，3:对应quality3，如果2,3未开启时将显示1档的视频流）
     */
    CRVideo.VideoContainer.prototype.setVideo2 = function(usrID, videoID, qualityLv) {
        this._handler.setVideo2(usrID, videoID, qualityLv);
    }
    /**获取当前显示的视频档位
     * @access public
     * @return {number} 视频档位
     */
    CRVideo.VideoContainer.prototype.getQualityLv = function() {
        return this._handler.getQualityLv();
    }
    /**
     * 设置全屏
     * @access public
     * @param {bool} bFullScreen  -  true 全屏
     */
    CRVideo.VideoContainer.prototype.setFullScreen = function(bFullScreen) {
        this._handler.setFullScreen(bFullScreen);
    }
    /**
     * 获取全屏
     * @access public
     * @return {bool} bFullScreen  -  true 全屏
     */
    CRVideo.VideoContainer.prototype.getFullScreen = function() {
        return this._handler.getFullScreen();
    }
    /**
     * 配置工具条高度
     * @access public
     * @param {number} height  -  工具条高度
     */
    CRVideo.VideoContainer.prototype.setToolbarHeight = function(height) {
        this._handler.setToolbarHeight(height);
    }

    /**
     * 配置工具条内容
     * @access public
     * @param
     */
    CRVideo.VideoContainer.prototype.setToolButton = function(id, iconFileName, toolTip) {
        this._handler.setToolButton(id, iconFileName, toolTip);
    }

    /**
     *
     * @access public
     * @param 
     */
    CRVideo.VideoContainer.prototype.lockNickNameText = function(lockNickNameText) {
        this._handler.lockNickNameText(lockNickNameText);
    }
    /**设置图像显示模式
     *
     * @access public
     * @param   {number} type
     */
    CRVideo.VideoContainer.prototype.setScaleType = function(type) {
        this._handler.setScaleType(type);
    }

    /**
     * 设置显示的视频画面是否保持比例
     * @param {bool} value - true: 保持比例不拉伸， false:不保持比例进行拉伸
     */
    CRVideo.VideoContainer.prototype.keepAspectRatio = function(value) {
        if (value === undefined) {
            return this._handler.keepAspectRatio;
        } else {
            this._handler.keepAspectRatio = value;
        }
    }
    /**
     * 设置是否支持双击全屏
     * @param {bool} value - true: 支持双击全屏； false:不支持双击全屏
     */
    CRVideo.VideoContainer.prototype.dblClickFullScreen = function(value) {
        if (value === undefined) {
            return this._handler.dblClickFullScreen;
        } else {
            this._handler.dblClickFullScreen = value;
        }
    }
    /**
     * 检查昵称是否可见
     * @param {bool} value - 0: 可见， 1:不可见
     */
    CRVideo.VideoContainer.prototype.visibleNickName = function(value) {
        if (value === undefined) {
            return this._handler.visibleNickName;
        } else {
            this._handler.visibleNickName = value;
        }
    }
    /**
     * 设置是否显示昵称
     * @access public
     * @param {bool} value - 否显示昵称
     */
    CRVideo.VideoContainer.prototype.setVisibleNickName = function(value) {
        this._visibleNickName = value
        this._handler.visibleNickName = value;
    }
    /**
     * 获取是否显示昵称
     * @access public
     * @return {bool} 否显示昵称
     */
    CRVideo.VideoContainer.prototype.getVisibleNickName = function() {
        return this._handler.visibleNickName;
    }
    /**
     * 检查图像是否为空
     * @return {bool} 图像是否为空
     */
    CRVideo.VideoContainer.prototype.isPicEmpty = function() {
        return this._handler.isPicEmpty;
    }
    /**
     * 屏幕共享播放的呈现容器
     * @class
     * @extends CRVideo.ScreenShareContainer
     */
    CRVideo.ScreenShareContainer = function() {
        CRVideo._containerList.push(this)
    }
    CRVideo.ScreenShareContainer.prototype = new CRVideo.Container()

    CRVideo.ScreenShareContainer.prototype.__addCallBack = function() {

    }
    /**
     * 控件显示
     * @access public
     */
    // CRVideo.ScreenShareContainer.prototype.show  = function()
    // {
    // 	this._handler.show();
    // }
    /**
     * 控件隐藏
     * @access public
     */
    // CRVideo.ScreenShareContainer.prototype.hide  = function()
    // {
    // 	this._handler.hide();
    // }
    /**
     * 拍照
     * @access public
     * @param {string} pathFileName - 本地绝对路径文件名(支持格式：bmp, png, gif, jpg, jpeg)
     * @return {number} 0:成功； 非0：保存遇到的错误码；
     */
    CRVideo.ScreenShareContainer.prototype.savePic = function(pathFileName) {
        return this._handler.savePic(pathFileName);
    }
    /**
     * 拍照
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {string} 以base64编码的图片数据，不成功返回空
     */
    CRVideo.ScreenShareContainer.prototype.savePicToBase64 = function(format) {
        return this._handler.savePicToBase64(format);
    }
    /**
     * 截图拍照
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {string} 图片数据的safe array，不成功返0长度的array
     */
    CRVideo.ScreenShareContainer.prototype.savePicToArray = function(format) {
        return this._handler.savePicToArray(format);
    }
    /**
     * 获取图像时间戳
     * @access public
     * @param {string} format - 图片格式，支持bmp, png, gif, jpg, jpeg
     * @return {number} 当前图像数据对应的时间戳
     */
    CRVideo.ScreenShareContainer.prototype.getPicFrameTime = function() {
        return this._handler.getPicFrameTime();
    }
    /**
     * 清空缓存的图像
     */
    CRVideo.ScreenShareContainer.prototype.clear = function() {
        this._handler.clear();
    }
    /**
     * 检查图像是否为空
     * @return {number} num - 0: 有图像, 1:无图像
     */
    CRVideo.ScreenShareContainer.prototype.isPicEmpty = function() {
        return this._handler.isPicEmpty;
    }
    /**
     * 开启标注模式
     * @param {number} value - 0: 不开启, 1:开启
     */
    CRVideo.ScreenShareContainer.prototype.enableMarked = function(value) {
        if (value === undefined) {
            return this._handler.enableMarked;
        } else {
            this._handler.enableMarked = value;
        }
    }
    /**
     * 设置标注画笔样式
     * @param {num} intRgba： - 颜色，排列方式bgr(8:8:8)
     * @param {num} penType - 画笔类型（1:铅笔, 2:水笔） 
     */
    CRVideo.ScreenShareContainer.prototype.setPenStyle = function(intRgba, penType) {

        this._handler.setPenStyle(intRgba, penType);
    }
    /**
     *是否禁止出现浮动工具条
     * @param {bool} bDisabled - true ：禁止出现浮动工具条; false：允许出现浮动工具条。默认出现。
     */
    CRVideo.ScreenShareContainer.prototype.disableFloatToolbar = function(bDisabled) {
        this._handler.disableFloatToolbar(bDisabled);
    }
    /**
     *获取远端屏幕的实际宽度
     * @return  远端屏幕的实际宽度（number）
     */
    CRVideo.ScreenShareContainer.prototype.getPicWidth = function() {
        return this._handler.getPicWidth();
    }
    /**
     *获取远端屏幕的实际高度
     * @return  远端屏幕的实际高度（number）
     */
    CRVideo.ScreenShareContainer.prototype.getPicHeight = function() {
        return this._handler.getPicHeight();
    }
    /**
     *鼠标是否在控件上
     * @return 鼠标是否在控件上，true- 在控件上； false - 不在控件上 {bool}
     */
    CRVideo.ScreenShareContainer.prototype.isCursorInUI = function() {
        return this._handler.isCursorInUI();
    }
    /**
     *鼠标在屏幕共享UI控件上映射到远端的坐标
     * @return json格式｛"x"=1,"y"=1}
     */
    CRVideo.ScreenShareContainer.prototype.getCursorPosInRemote = function() {
        return JSON.parse(this._handler.getCursorPosInRemote());
    }
    /**
     * 设置全屏
     * @access public
     * @param {bool} bFullScreen  -  true 全屏
     */
    CRVideo.ScreenShareContainer.prototype.setFullScreen = function(bFullScreen) {
        this._handler.setFullScreen(bFullScreen);
    }
    /**
     * 获取全屏
     * @access public
     * @return {bool} bFullScreen  -  true 全屏
     */
    CRVideo.ScreenShareContainer.prototype.getFullScreen = function() {
        return this._handler.getFullScreen();
    }
    /**
     * 配置是否允许双击全屏
     * @access public
     * @param {bool} bVal  -  bVal: true:允许(缺省值)， false：不允许
     */
    CRVideo.ScreenShareContainer.prototype.setDblClickFullScreen = function(bVal) {
        this._handler.setDblClickFullScreen(bVal);
    }
    /**
     * 设置图像显示模式
     * @access public
     * @param {number} type  -  0 ,1 ,2
     */
    CRVideo.ScreenShareContainer.prototype.setScaleType = function(type) {
        this._handler.setScaleType(type);
    }
    /**
     * 
     * @access public
     * @param {number} type  -  
     */
    CRVideo.ScreenShareContainer.prototype.setType = function(type) {
        this._handler.setType(type);
    }
    /**
     * 
     * @access public
     * @param {string} penFormat  - 
     */
    CRVideo.ScreenShareContainer.prototype.setPenProperty = function(penFormat) {
        this._handler.setPenProperty(penFormat);
    }



    /**
     * 获取是否允许双击全屏
     * @access public
     * @return {bool} bVal  -  true 允许， false：不允许
     */
    CRVideo.ScreenShareContainer.prototype.getDblClickFullScreen = function() {
        return this._handler.getDblClickFullScreen();
    }
    /**
     * 绘制模式，是否拉伸绘制
     * @param {bool} value - true: 保持比例不拉伸， false:不保持比例进行拉伸
     */
    CRVideo.ScreenShareContainer.prototype.keepAspectRatio = function(value) {
        if (value === undefined) {
            return this._handler.keepAspectRatio;
        } else {
            this._handler.keepAspectRatio = value;
        }
    }
    /**
     * 开启控制模式
     * @param {bool} value - true: 开启， false:不开启
     */
    CRVideo.ScreenShareContainer.prototype.ctrlOpen = function(value) {
        if (value === undefined) {
            return this._handler.ctrlOpen;
        } else {
            this._handler.ctrlOpen = value;
        }
    }
    /**
     * 白板的呈现容器
     * @class
     * @extends CRVideo.BoardContainer
     */
    CRVideo.BoardContainer = function() {
        CRVideo._containerList.push(this)
    }
    CRVideo.BoardContainer.prototype = new CRVideo.Container()

    CRVideo.BoardContainer.prototype.__addCallBack = function() {

    }
    /**
     *获取会议中所有白板ID的列表
     * @access public
     * @return 白板ID字符串数组 {string[]}
     */
    CRVideo.BoardContainer.prototype.getBoardIDs = function() {
        return (this._handler.getBoardIDs()).split(";");
    }
    /**
     *获取指定白板的信息
     * @access public
     * @param {string} boardID - 白板ID
     * @return json格式的白板信息结构体 {BoardObj}
     */
    CRVideo.BoardContainer.prototype.getBoardInfo = function(boardID) {
        return JSON.parse(this._handler.getBoardInfo(boardID));
    }
    /**
     *获取当前白板ID
     * @access public
     * @return 当前白板ID {string}
     */
    CRVideo.BoardContainer.prototype.getCurBoardID = function() {
        return this._handler.getCurBoardID();
    }
    /**
     *获取当前白板的页号
     * @access public
     * @return 当前白板的页号 {number}
     */
    CRVideo.BoardContainer.prototype.getCurPageNo = function() {
        return this._handler.getCurPageNo();
    }
    /**
     *设置当前白板和页号
     * @access public
     * @param {string} boardID - 白板ID
     * @param {number} pageNo - 页号
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.setCurBoard = function(boardID, pageNo) {
        this._handler.setCurBoard(boardID, pageNo);
    }
    /**
     *撤销当前操作
     * @access public
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.undo = function() {
        this._handler.undo();
    }
    /**
     *恢复当前操作
     * @access public
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.redo = function() {
        this._handler.redo();
    }
    /**
     *清除当前操作
     * @access public
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.clear = function() {
        this._handler.clear();
    }
    /**
     *获取白板是否处于缩放模式
     * @access public
     * @return {bool} 白板是否处于缩放模式；true - 缩放模式
     */
    CRVideo.BoardContainer.prototype.isScaledContents = function() {
        return this._handler.isScaledContents();
    }
    /**
     *设置白板的缩放模式
     * @access public
     * @param {bool} scaleVal - 白板的缩放模式值（true ：缩放模式）
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.setScaledContents = function(scaleVal) {
        this._handler.setScaledContents(scaleVal);
    }
    /**
     *设置画笔颜色值
     * @access public
     * @param {PenColorObj} penColorObj - 画笔颜色值
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.setColor = function(penColorObj) {
        var rgb = parseInt(penColorObj.color.substring(1), 16);
        var a = parseInt(penColorObj.opacity * 255);
        var color = a << 24 | rgb;
        this._handler.setColor(color);
    }
    /**
     *获取画笔颜色值
     * @access public
     * @return {PenColorObj} penColorObj - 画笔颜色值
     */
    CRVideo.BoardContainer.prototype.getColor = function() {
        var penColorObj = {};

        var colorNum = this._handler.getColor();
        if (colorNum < 0) {
            colorNum = -colorNum;
            colorNum = colorNum - 1;
            var str = (Array(32).join("0") + colorNum.toString(2)).slice(-32);
            str = exchange(str);
        } else {
            var str = (Array(32).join("0") + colorNum.toString(2)).slice(-32);
        }

        function exchange(str) {
            var arr = str.split('');
            for (var i = 0; i < arr.length; i++) {
                if (arr[i] == 0) {
                    arr[i] = 1;
                } else {
                    arr[i] = 0;
                }
            }
            str = arr.join("");
            return str;
        }

        var hexStr = parseInt(str.substring(8), 2).toString(16);
        while (hexStr.length < 6) {
            hexStr = "0" + hexStr;
        }
        penColorObj.color = "#" + hexStr;
        penColorObj.opacity = 0;

        return penColorObj;
    }
    /**
     *设置画笔宽度
     * @access public
     * @param {number} width - 画笔宽度
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.setLineWidth = function(width) {
        this._handler.setLineWidth(width);
    }

    /**
     *获取画笔宽度
     * @access public
     * @return {number} width - 画笔宽度
     */
    CRVideo.BoardContainer.prototype.getLineWidth = function() {
        return this._handler.getLineWidth();
    }
    /**
     *设置白板只读
     * @access public
     * @param {bool} bReadOnly - 设置白板只读
     * @return 无返回值
     */
    CRVideo.BoardContainer.prototype.setReadOnly = function(bReadOnly) {
        this._handler.setReadOnly(bReadOnly);
    }

    /**
     *获取白板是否只读
     * @access public
     * @return {bool} width - 白板是否只读
     */
    CRVideo.BoardContainer.prototype.isReadOnly = function() {
        return this._handler.isReadOnly();
    }
}
/**
 * 获取web js版本号
 * @access public
 * @returns {string} 返回云屋SDK js的版本号
 */
CRVideo_GetSDKJsVersion = function() {
    return CRVideo.jsVersion;
}
if (window["000a0180686911e78dd0a45d36bb8c5c"] === undefined) {
    /** 
     * sdk错误码
     * @module cr/error
     */


    //没有错误
    /**
     * 没有错误
     * @static
     */
    CRVideo_NOERR = 0;
    //------------------------------------------
    //
    //基础错误
    //
    //------------------------------------------
    //未知错误
    /**
     * 未知错误
     * @static
     */
    CRVideo_UNKNOWERR = 1;
    //内存不足       
    /**
     * 内存不足
     * @static
     */
    CRVideo_OUTOF_MEM = 2;
    //sdk内部错误   
    /**
     * sdk内部错误
     * @static
     */
    CRVideo_INNER_ERR = 3;
    //不支持的sdk版本 
    /**
     * 不支持的sdk版本
     * @static
     */
    CRVideo_MISMATCHCLIENTVER = 4;
    //参数错误    
    /**
     * 参数错误
     * @static
     */
    CRVideo_MEETPARAM_ERR = 5;
    //无效数据  
    /**
     * 无效数据
     * @static
     */
    CRVideo_ERR_DATA = 6;
    //帐号密码不正确
    /**
     * 帐号密码不正确
     * @static
     */
    CRVideo_ANCTPSWD_ERR = 7;
    //服务异常	
    /**
     * 服务异常
     * @static
     */
    CRVideo_SERVER_EXCEPTION = 8;
    /**
     * 登录状态错误
     * @static
     */
    CRVideo_CRVIDEOSDK_LOGINSTATE_ERROR = 9;


    //登录用户被踢下线	
    /**
     * 登录用户被踢下线
     * @static
     */
    CRVideo_CRVideoSDK_USER_BEEN_KICKOUT = 10;
    /**
     * sdk未初始化
     * @static
     */

    CRVideo_CRVIDEOSDK_NOT_INIT = 11;
    //还没有登录
    /**
     * 还没有登录
     * @static
     */
    CRVideo_CRVIDEOSDK_NOT_LOGIN = 12;
    //base64转换失败
    /**
     * base64转换失败
     * @static
     */
    CRVideo_CRVIDEOSDK_BASE64_COV_ERR = 13;
    /**
     * 启用了第三方鉴权，但没有携带鉴权信息
     * @static
     */
    CRVideo_CRVIDEOSDK_CUSTOMAUTH_NOINFO = 14;
    /**
     * 没有启用第三方鉴权，但携带了鉴权信息
     * @static
     */
    CRVideo_CRVIDEOSDK_CUSTOMAUTH_NOTSUPPORT = 15;
    /**
     * 访问第三方鉴权服务异常
     * @static
     */
    CRVideo_CRVIDEOSDK_CUSTOMAUTH_EXCEPTION = 16;
    /**
     * 第三方鉴权不通过
     * @static
     */
    CRVideo_CRVIDEOSDK_CUSTOMAUTH_FAILED = 17;
    /**
     * token已经过期
     * @static
     */
    CRVideo_CRVIDEOSDK_TOKEN_TIMEOUT = 18;
    /**
     * 鉴权信息错误
     * @static
     */
    CRVideo_CRVIDEOSDK_TOKEN_AUTHINFOERR = 19;
    /**
     * appid不存在
     * @static
     */
    CRVideo_CRVIDEOSDK_TOKEN_APPIDNOTEXIST = 20;
    /**
     * 鉴权校验失败
     * @static
     */
    CRVideo_CRVIDEOSDK_TOKEN_AUTH_FAILED = 21;
    /**
     * 非token鉴权方式
     * @static
     */
    CRVideo_CRVIDEOSDK_TOKEN_NOTTOKENTYPE = 22;


    //------------------------------------------
    //
    //网络错误
    //
    //------------------------------------------
    //网络初始化失败
    /**
     * 网络初始化失败
     * @static
     */
    CRVideo_NETWORK_INITFAILED = 200;
    //没有服务器信息
    /**
     * 没有服务器信息
     * @static
     */
    CRVideo_NO_SERVERINFO = 201;
    //服务器没有响应
    /**
     * 服务器没有响应
     * @static
     */
    CRVideo_NOSERVER_RSP = 202;
    //创建连接失败
    /**
     * 创建连接失败
     * @static
     */
    CRVideo_CREATE_CONN_FAILED = 203;
    //socket异常
    /**
     * socket异常
     * @static
     */
    CRVideo_SOCKETEXCEPTION = 204;
    //网络超时
    /**
     * 网络超时
     * @static
     */
    CRVideo_SOCKETTIMEOUT = 205;
    //连接被关闭
    /**
     * 连接被关闭
     * @static
     */
    CRVideo_FORCEDCLOSECONNECTION = 206;
    //语音引擎初始化失败
    /**
     * 语音引擎初始化失败
     * @static
     */
    CRVideo_VOICEENG_INITFAILED = 208;

    //ssl相关错误
    /**
     * ssl相关错误
     * @static
     */
    CRVideo_CRVIDEOSDK_SSL_ERR = 209;


    //------------------------------------------
    //
    //队列错误
    //
    //------------------------------------------
    //队列ID错误
    /**
     * 队列ID错误
     * @static
     */
    CRVideo_QUE_ID_INVALID = 400;
    //没有用户在排队
    /**
     * 没有用户在排队
     * @static
     */
    CRVideo_QUE_NOUSER = 401;
    //排队用户已取消	
    /**
     * 排队用户已取消
     * @static
     */
    CRVideo_QUE_USER_CANCELLED = 402;
    //队列服务还未开启
    /**
     * 队列服务还未开启
     * @static
     */
    CRVideo_QUE_SERVICE_NOT_START = 403
    //已在其它队列排队(客户只能在一个队列排队)
    /**
     * 已在其它队列排队(客户只能在一个队列排队)
     * @static
     */
    CRVideo_ALREADY_OTHERQUE = 404

    //------------------------------------------
    //
    //呼叫错误
    //
    //------------------------------------------
    //无效的呼叫ID
    /**
     * 无效的呼叫ID
     * @static
     */
    CRVideo_INVALID_CALLID = 600;
    //已在呼叫中
    /**
     * 已在呼叫中
     * @static
     */
    CRVideo_ERR_CALL_EXIST = 601;
    //对方忙
    /**
     * 对方忙
     * @static
     */
    CRVideo_ERR_BUSY = 602;
    //对方不在线
    /**
     * 对方不在线
     * @static
     */
    CRVideo_ERR_OFFLINE = 603;
    //对方无应答
    /**
     * 对方无应答
     * @static
     */
    CRVideo_ERR_NOANSWER = 604;
    //用户不存在
    /**
     * 用户不存在
     * @static
     */
    CRVideo_ERR_USER_NOT_FOUND = 605;
    //对方拒接
    /**
     * 对方拒接
     * @static
     */
    CRVideo_ERR_REFUSE = 606;

    //------------------------------------------
    //
    //会话业务错误
    //
    //------------------------------------------
    //会议不存在或已结束
    /**
     * 会议不存在或已结束
     * @static
     */
    CRVideo_MEETNOTEXIST = 800;
    //会议密码不正确
    /**
     * 会议密码不正确
     * @static
     */
    CRVideo_AUTHERROR = 801;
    //会议终端数量已满（购买的license不够)
    /**
     * 会议终端数量已满（购买的license不够)
     * @static
     */
    CRVideo_MEMBEROVERFLOWERROR = 802;
    //分配会议资源失败
    /**
     * 分配会议资源失败
     * @static
     */
    CRVideo_RESOURCEALLOCATEERROR = 803;
    //会议已加锁
    /**
     * 会议已加锁
     * @static
     */
    CRVideo_MEETROOMLOCKED = 804;
    //余额不足
    /**
     * 余额不足
     * @static
     */
    CRVideo_BALANCELESSERROR = 805;
    //业务权限未开启 
    /**
     * 业务权限未开启 
     * @static
     */
    CRVideo_SEVICE_NOTENABLED = 806;
    //不能再次登录 
    /**
     * 不能再次登录 
     * @static
     */
    CRVideo_ALREADYLOGIN = 807;
    //没有mic权限 
    /**
     * 没有mic权限 
     * @static
     */
    CRVideo_CRVIDEOSDK_MIC_NORIGHT = 808;
    //mic已被使用 
    /**
     * mic已被使用 
     * @static
     */
    CRVideo_CRVIDEOSDK_MIC_BEING_USED = 809;
    //mic相关未知错误 
    /**
     * mic相关未知错误 
     * @static
     */
    CRVideo_CRVIDEOSDK_MIC_UNKNOWERR = 810;
    //没有扬声器权限 
    /**
     * 没有扬声器权限 
     * @static
     */
    CRVideo_CRVIDEOSDK_SPK_NORIGHT = 811;
    //扬声器已被使用 
    /**
     * 扬声器已被使用 
     * @static
     */
    CRVideo_CRVIDEOSDK_SPK_BEING_USED = 812;
    //扬声器相关未知错误 
    /**
     * 扬声器相关未知错误 
     * @static
     */
    CRVideo_CRVIDEOSDK_SPK_UNKNOWERR = 813;
    //抓屏失败
    /**
     * 抓屏失败 
     * @static
     */
    CRVideo_CATCH_SCREEN_ERR = 900;
    //单次录制达到最大时长(8h)
    /**
     * 单次录制达到最大时长(8h) 
     * @static
     */
    CRVideo_RECORD_MAX = 901;
    //磁盘空间不够
    /**
     * 磁盘空间不够 
     * @static
     */
    CRVideo_RECORD_NO_DISK = 902;
    //录像的分辨率超出限制 
    /**
     * 录像的分辨率超出限制
     * @static
     */
    CRVideo_RECORD_SIZE_ERR = 903;
    //配置超出限制 
    /**
     * 配置超出限制
     * @static
     */
    CRVideo_CRVIDEOSDK_CFG_RESTRICTED = 904;
    //录像文件操作出错 
    /**
     * 录像文件操作出错
     * @static
     */
    CRVideo_CRVIDEOSDK_FILE_ERR = 905;
    //录像已开启 
    /**
     * 录像已开启
     * @static
     */
    CRVideo_CRVIDEOSDK_RECORDSTARTED = 906;
    /**
     * 发送信令数据过大
     * @static
     */
    CRVideo_SENDCMD_LARGE = 1100;
    /**
     * 目标用户不存在
     * @static
     */
    CRVideo_SENDDATA_TARGETINVALID = 1102;
    /**
     * 文件错误
     * @static
     */
    CRVideo_SENDFILE_FILEINERROR = 1103;
    /**
     * 无效的发送id
     * @static
     */
    CRVideo_TRANSID_INVALID = 1104;
    /**
     * 状态错误不可上传/取消上传
     * @static
     */
    CRVideo_RECORDFILE_STATE_ERR = 1200;
    /**
     * 网络摄像头url不正确
     * @static
     */
    CRVideo_IPCAM_URLERR = 1300;
    /**
     * 网络摄像头已存在
     * @static
     */
    CRVideo_IPCAM_ALREADYEXIST = 1301;
    /**
     * 网络摄像头达到最大数量
     * @static
     */
    CRVideo_IPCAM_TOOMUCH = 1302;
    /**
     * 文件不存在
     * @static
     */
    CRVideo_CRVIDEOSDK_FILE_NOT_EXIST = 1400;
    /**
     * 文件读失败
     * @static
     */
    CRVideo_CRVIDEOSDK_FILE_READ_ERR = 1401;
    /**
     * 文件写失败
     * @static
     */
    CRVideo_CRVIDEOSDK_FILE_WRITE_ERR = 1402;
    /**
     * 文件操作失败
     * @static
     */
    CRVideo_CRVIDEOSDK_FILE_OPERATOR_ERR = 1403;
    //------------------------------------------
    //
    //web错误
    //
    //------------------------------------------
    //ocx未安装
    /**
     * ocx未安装
     * @static
     */
    CRVideo_WEB_OCX_NOTINSTALLED = 2001;
    //不支持的浏览器
    /**
     * 不支持的浏览器
     * @static
     */
    CRVideo_WEB_BROWER_NOTUPPORTED = 2002;
    //不支持的插件版本
    /**
     * 不支持的插件版本
     * @static
     */
    CRVideo_OCX_VERSION_NOTUPPORTED = 2003;

}
if (window["000a0180686911e78dd0a45d36bb8c5c"] === undefined) {
    /**
     * sdk回调接口
     * @module cr/callback
     */
    //------------------------------------------------------------------------
    //
    //会议创建管理的回调接口
    //
    //-------------------------------------------------------------------------
    /**
     * @typedef {object} CRVideo_MeetInfoObj - 区域
     * @property {number} ID - 会议号，0时代表会议信息为空
     * @property {number} pswd - 会议密码；（空代表会议无密码）
     * @property {number} subject - 会议主题
     * @property {number} pubMeetUrl - 会议公共链接
     */
    /**
     * 登录成功响应
     * @callback CRVideo.CbProxy~CRVideo_LoginSuccess
     * @param {string} usrID - 用户账户
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_LoginSuccess = new CRVideo.CbProxy("CRVideo_LoginSuccess");
    /**
     * 登录失败响应
     * @callback CRVideo.CbProxy~CRVideo_LoginFail
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_LoginFail = new CRVideo.CbProxy("CRVideo_LoginFail");
    /**
     * SDK通知自己掉线
     * @callback CRVideo.CbProxy~CRVideo_LineOff
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_LineOff = new CRVideo.CbProxy("CRVideo_LineOff");
    /**
     * 客户端设置免打扰状态操作成功响应
     * @callback CRVideo.CbProxy~CRVideo_SetDNDStatusSuccess
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_SetDNDStatusSuccess = new CRVideo.CbProxy("CRVideo_SetDNDStatusSuccess");
    /**
     * 客户端设置免打扰状态操作失败响应
     * @callback CRVideo.CbProxy~CRVideo_SetDNDStatusFail
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_SetDNDStatusFail = new CRVideo.CbProxy("CRVideo_SetDNDStatusFail");
    /**
     * 客获取所有用户在线状态成功响应
     * @callback CRVideo.CbProxy~CRVideo_GetUserStatusSuccess
     * @param {string} usersStatus - 用户在线状态信息列表，userID:用户id,userStatus:用户的在线状态(0 离线  1在线空闲  2 在线忙碌  3在线会议中),DNDType:用户免打扰状态(0代表关闭免打扰， 其它值代表开启免打扰)
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_GetUserStatusSuccess = new CRVideo.CbProxy("CRVideo_GetUserStatusSuccess");
    /**
     * 获取所有用户在线状态失败响应
     * @callback CRVideo.CbProxy~CRVideo_GetUserStatusFail
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_GetUserStatusFail = new CRVideo.CbProxy("CRVideo_GetUserStatusFail");
    /**
     * 某个用户状态变化通知
     * @callback CRVideo.CbProxy~CRVideo_NotifyUserStatus
     * @param {string} userStatus - userStatus单个用户在线状态信息
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_NotifyUserStatus = new CRVideo.CbProxy("CRVideo_NotifyUserStatus");
    /**
     * 启动用户状态推送响应
     * @callback CRVideo.CbProxy~CRVideo_StartUserStatusNotifyRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_StartUserStatusNotifyRslt = new CRVideo.CbProxy("CRVideo_StartUserStatusNotifyRslt");
    /**
     * 结束用户状态推送响应
     * @callback CRVideo.CbProxy~CRVideo_StopUserStatusNotifyRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_StopUserStatusNotifyRslt = new CRVideo.CbProxy("CRVideo_StopUserStatusNotifyRslt");
    /**
     * 创建会议成功响应
     * @callback CRVideo.CbProxy~CRVideo_CreateMeetingSuccess
     * @param {CRVideo_MeetInfoObj} meetObj - 会议信息
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_CreateMeetingSuccess = new CRVideo.CbProxy("CRVideo_CreateMeetingSuccess");
    /**
     * 创建会议失败响应
     * @callback CRVideo.CbProxy~CRVideo_CreateMeetingFail
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_CreateMeetingFail = new CRVideo.CbProxy("CRVideo_CreateMeetingFail");
    /**
     * 结束会议响应
     * @callback CRVideo.CbProxy~CRVideo_DestroyMeetingRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_DestroyMeetingRslt = new CRVideo.CbProxy("CRVideo_DestroyMeetingRslt");
    /**
     * 呼叫他人操作成功响应
     * @callback CRVideo.CbProxy~CRVideo_CallSuccess
     * @param {string} callID - 呼叫全局标识
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_CallSuccess = new CRVideo.CbProxy("CRVideo_CallSuccess");
    /**
     * 呼叫他人操作失败响应
     * @callback CRVideo.CbProxy~CRVideo_CallFail
     * @param {string} callID - 呼叫全局标识
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_CallFail = new CRVideo.CbProxy("CRVideo_CallFail");
    /**
     * 接受他人呼叫操作成功响应
     * @callback CRVideo.CbProxy~CRVideo_AcceptCallSuccess
     * @param {string} callID - 呼叫全局标识
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_AcceptCallSuccess = new CRVideo.CbProxy("CRVideo_AcceptCallSuccess");
    /**
     * 接受他人呼叫操作失败响应
     * @callback CRVideo.CbProxy~CRVideo_AcceptCallFail
     * @param {string} callID - 呼叫全局标识
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_AcceptCallFail = new CRVideo.CbProxy("CRVideo_AcceptCallFail");
    /**
     * 拒绝他人的呼叫成功响应
     * @callback CRVideo.CbProxy~CRVideo_RejectCallSuccess
     * @param {string} callID - 呼叫全局标识
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_RejectCallSuccess = new CRVideo.CbProxy("CRVideo_RejectCallSuccess");
    /**
     * 拒绝他人的呼叫失败响应
     * @callback CRVideo.CbProxy~CRVideo_RejectCallFail
     * @param {string} callID - 呼叫全局标识
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_RejectCallFail = new CRVideo.CbProxy("CRVideo_RejectCallFail");
    /**
     * 挂断呼叫操作成功响应
     * @callback CRVideo.CbProxy~CRVideo_HangupCallSuccess
     * @param {string} callID - 呼叫全局标识
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_HangupCallSuccess = new CRVideo.CbProxy("CRVideo_HangupCallSuccess");
    /**
     * 挂断呼叫操作失败响应
     * @callback CRVideo.CbProxy~CRVideo_HangupCallFail
     * @param {string} callID - 呼叫全局标识
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_HangupCallFail = new CRVideo.CbProxy("CRVideo_HangupCallFail");
    /**
     * SDK通知自己被呼叫
     * @callback CRVideo.CbProxy~CRVideo_NotifyCallIn
     * @param {string} callID - 呼叫全局标识
     * @param {CRVideo_MeetInfoObj} meetObj - 会议信息
     * @param {string} callerID - 呼叫人员的标识ID
     * @param {string} usrExtDat - 自定义扩展参数
     */
    var CRVideo_NotifyCallIn = new CRVideo.CbProxy("CRVideo_NotifyCallIn");

    /**
     * SDK通知自己视频呼叫被对方接受
     * @callback CRVideo.CbProxy~CRVideo_NotifyCallAccepted
     * @param {string} callID - 呼叫全局标识
     * @param {CRVideo_MeetInfoObj} meetObj - 会议信息
     * @param {string} usrExtDat - 自定义扩展参数
     */
    var CRVideo_NotifyCallAccepted = new CRVideo.CbProxy("CRVideo_NotifyCallAccepted");
    /**
     * SDK通知自己呼叫被对方拒绝
     * @callback CRVideo.CbProxy~CRVideo_NotifyCallRejected
     * @param {string} callID - 呼叫全局标识
     * @param {number} sdkErr - 呼叫被对方拒绝的原因代码,定义见cr/error
     * @param {string} usrExtDat - 自定义扩展参数
     */
    var CRVideo_NotifyCallRejected = new CRVideo.CbProxy("CRVideo_NotifyCallRejected");
    /**
     * SDK通知自己呼叫被挂断
     * @callback CRVideo.CbProxy~CRVideo_NotifyCallHungup
     * @param {string} callID - 呼叫全局标识
     * @param {string} usrExtDat - 自定义扩展参数
     */
    var CRVideo_NotifyCallHungup = new CRVideo.CbProxy("CRVideo_NotifyCallHungup");
    /**
     * 邀请/取消邀请第三方结果
     * @callback CRVideo.CbProxy~CRVideo_CallMorePartyRslt
     * @param {string} callID - 呼叫全局标识
     * @param {string} usrExtDat - 自定义扩展参数
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_CallMorePartyRslt = new CRVideo.CbProxy("CRVideo_CallMorePartyRslt");
    /**
     * 功能 取消第3方呼叫操作结果
     * @callback CRVideo.CbProxy~CRVideo_CancelCallMorePartyRslt
     * @param {string} callID - 呼叫全局标识
     * @param {number} sdkErr - 呼叫取消第三方操作的错误码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_CancelCallMorePartyRslt = new CRVideo.CbProxy("CRVideo_CancelCallMorePartyRslt");
    /**
     * 通知第3方呼叫状态改变
     * @callback CRVideo.CbProxy~CRVideo_CancelCallMorePartyRslt
     * @param {string} callID - 呼叫全局标识
     * @param {number} status - 状态，0振铃，1接通，2拒绝，3未应答，4挂断
     */
    var CRVideo_NotifyCallMorePartyStatus = new CRVideo.CbProxy("CRVideo_NotifyCallMorePartyStatus");

    /**
     * 发送数据时，SDK通知发送结果
     * @callback CRVideo.CbProxy~CRVideo_SendCmdRlst
     * @param {string} taskID - 发送任务id
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_SendCmdRlst = new CRVideo.CbProxy("CRVideo_SendCmdRlst");
    /**
     * 发送数据时，SDK通知发送结果
     * @callback CRVideo.CbProxy~CRVideo_SendBufferRlst
     * @param {string} taskID - 发送任务id
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_SendBufferRlst = new CRVideo.CbProxy("CRVideo_SendBufferRlst");
    /**
     * 发送文件时，SDK通知发送结果
     * @callback CRVideo.CbProxy~CRVideo_SendFileRlst
     * @param {string} taskID - 发送任务id
     * @param {number} fileName - 文件名
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_SendFileRlst = new CRVideo.CbProxy("CRVideo_SendFileRlst");
    /**
     * 发送数据时，SDK通知发送进度
     * @callback CRVideo.CbProxy~CRVideo_SendProgress
     * @param {string} taskID - 发送任务id
     * @param {number} sendedLen  - 已发送的数据长度
     * @param {number} totalLen   - 需要发送的总长度
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_SendProgress = new CRVideo.CbProxy("CRVideo_SendProgress");
    /**
     * 取消发送响应
     * @callback CRVideo.CbProxy~CRVideo_CancelSendRlst
     * @param {string} taskID - 发送任务id
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_CancelSendRlst = new CRVideo.CbProxy("CRVideo_CancelSendRlst");
    /**
     * SDK通知收到小块数据
     * @callback CRVideo.CbProxy~CRVideo_NotifyCmdData
     * @param {string} sourceUserId - 数据来源
     * @param {string} data - 数据
     */
    var CRVideo_NotifyCmdData = new CRVideo.CbProxy("CRVideo_NotifyCmdData");
    /**
     * SDK通知收到大块数据
     * @callback CRVideo.CbProxy~CRVideo_NotifyBufferData
     * @param {string} sourceUserId - 数据来源
     * @param {string} data - 数据
     */
    var CRVideo_NotifyBufferData = new CRVideo.CbProxy("CRVideo_NotifyBufferData");
    /**
     * SDK通知收到文件数据（收到的文件生成在系统临时目录下，请尽快移走对应文件）
     * @callback CRVideo.CbProxy~CRVideo_NotifyFileData
     * @param {string} sourceUserId - 数据来源
     * @param {string} tmpFile - 临时文件，不需要时，请移除或删除对应文件
     * @param {string} orgFileName  - 源始文件名
     */
    var CRVideo_NotifyFileData = new CRVideo.CbProxy("CRVideo_NotifyFileData");
    /**
     * SDK通知取消发送文件数据
     * @callback CRVideo.CbProxy~CRVideo_NotifyCancelSend
     * @param {number} taskID - 取消的任务id
     */
    var CRVideo_NotifyCancelSend = new CRVideo.CbProxy("CRVideo_NotifyCancelSend");
    /**
    * SDK通知token  	

    * @callback CRVideo.CbProxy~CRVideo_NotifyTokenWillExpire
    */
    var CRVideo_NotifyTokenWillExpire = new CRVideo.CbProxy("CRVideo_NotifyTokenWillExpire");

    /**
     * 发送邀请成功
     * @callback CRVideo.CbProxy~CRVideo_InviteSuccess
     * @param {string}  inviteID - 邀请ID
     * @param {string}  cookie - 自定义数据 （在回调时，回传给调用者）
     *
     */
    var CRVideo_InviteSuccess = new CRVideo.CbProxy("CRVideo_InviteSuccess");

    /**
         * 发送邀请失败
         * @callback CRVideo.CbProxy~CRVideo_InviteFail
         * @param {string} inviteID - 邀请ID
         * @param {number} sdkErr  - 错误码
    	 * * @param {string}  cookie- 自定义数据 （在回调时，回传给调用者）
         
         */
    var CRVideo_InviteFail = new CRVideo.CbProxy("CRVideo_InviteFail");

    /**
     * 取消自己发送的邀请成功
     * @callback CRVideo.CbProxy~CRVideo_CancelInviteSuccess
     * @param {string}  inviteID - 邀请ID
     * @param {string}  cookie - 自定义数据 （在回调时，回传给调用者）
     *
     */
    var CRVideo_CancelInviteSuccess = new CRVideo.CbProxy("CRVideo_CancelInviteSuccess");

    /**
         * 取消自己发送的邀请失败
         * @callback CRVideo.CbProxy~CRVideo_CancelInviteFail
         * @param {string} inviteID - 邀请ID
         * @param {number} sdkErr  - 错误码
    	 * * @param {string}  cookie- 自定义数据 （在回调时，回传给调用者）
         
         */
    var CRVideo_CancelInviteFail = new CRVideo.CbProxy("CRVideo_CancelInviteFail");

    /**
     * 接受对方的邀请成功
     * @callback CRVideo.CbProxy~CRVideo_AcceptInviteSuccess
     * @param {string}  inviteID - 邀请ID
     * @param {string}  cookie - 自定义数据 （在回调时，回传给调用者）
     *
     */
    var CRVideo_AcceptInviteSuccess = new CRVideo.CbProxy("CRVideo_AcceptInviteSuccess");

    /**
         * 接受对方的邀请失败
         * @callback CRVideo.CbProxy~CRVideo_AcceptInviteFail
         * @param {string} inviteID - 邀请ID
         * @param {number} sdkErr  - 错误码
    	 * * @param {string}  cookie- 自定义数据 （在回调时，回传给调用者）
         
         */
    var CRVideo_AcceptInviteFail = new CRVideo.CbProxy("CRVideo_AcceptInviteFail");

    /**
     * 拒绝对方的邀请成功
     * @callback CRVideo.CbProxy~CRVideo_RejectInviteSuccess
     * @param {string}  inviteID - 邀请ID
     * @param {string}  cookie - 自定义数据 （在回调时，回传给调用者）
     */
    var CRVideo_RejectInviteSuccess = new CRVideo.CbProxy("CRVideo_RejectInviteSuccess");

    /**
     * 拒绝对方的邀请失败
     * @callback CRVideo.CbProxy~CRVideo_RejectInviteFail
     * @param {string} inviteID - 邀请ID
     * @param {number} sdkErr  - 错误码
     * * @param {string}  cookie- 自定义数据 （在回调时，回传给调用者  
     */
    var CRVideo_RejectInviteFail = new CRVideo.CbProxy("CRVideo_RejectInviteFail");

    /**通知有人邀请
     * 
     * @callback CRVideo.CbProxy~CRVideo_NotifyInviteIn
     * @param {string}  inviteID- 邀请ID
     * @param {string}  inviterUsrID- 邀请者用户ID
     * @param {string}   usrExtDat- 用户扩展数据
     */
    var CRVideo_NotifyInviteIn = new CRVideo.CbProxy("CRVideo_NotifyInviteIn");

    /**通知邀请被接受
     * 
     * @callback CRVideo.CbProxy~CRVideo_NotifyInviteAccepted
     * @param {string}  inviteID- 邀请ID
     * @param {string}   usrExtDat- 用户扩展数据
     */
    var CRVideo_NotifyInviteAccepted = new CRVideo.CbProxy("CRVideo_NotifyInviteAccepted");

    /**通知邀请被拒绝
     * 
     * @callback CRVideo.CbProxy~CRVideo_NotifyInviteRejected
     * @param {string}  inviteID- 邀请ID
     * @param {string}  reason -邀请被拒绝原因
     * @param {string}   usrExtDat- 用户扩展数据
     */
    var CRVideo_NotifyInviteRejected = new CRVideo.CbProxy("CRVideo_NotifyInviteRejected");

    /**通知邀请被取消
     * 
     * @callback CRVideo.CbProxy~CRVideo_NotifyInviteCanceled
     * @param {string}  inviteID- 邀请ID
     * @param {string}  reason - 邀请被取消原因
     * @param {string}   usrExtDat- 用户扩展数据
     */
    var CRVideo_NotifyInviteCanceled = new CRVideo.CbProxy("CRVideo_NotifyInviteCanceled");

    /**
     * 获取会议列表成功响应
     * @callback CRVideo.CbProxy~CRVideo_GetMeetingsSuccess
     * @param {CRVideo_MeetInfoObj} jsonMeetings - 会议列表信息
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_GetMeetingsSuccess = new CRVideo.CbProxy("CRVideo_GetMeetingsSuccess");
    /**
     * 获取会议列表成功响应
     * @callback CRVideo.CbProxy~CRVideo_GetMeetingsFail
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_GetMeetingsFail = new CRVideo.CbProxy("CRVideo_GetMeetingsFail");






    //------------------------------------------------------------------------
    //
    //会议管理类的回调接口
    //
    //-------------------------------------------------------------------------
    /**
     * 进入会议完成响应
     * @callback CRVideo.CbProxy~CRVideo_EnterMeetingRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_EnterMeetingRslt = new CRVideo.CbProxy("CRVideo_EnterMeetingRslt");
    /**
     * 某用户进入了会议
     * @callback CRVideo.CbProxy~CRVideo_UserEnterMeeting
     * @param {string} usrID - 进入会议的用户ID
     */
    var CRVideo_UserEnterMeeting = new CRVideo.CbProxy("CRVideo_UserEnterMeeting");

    /**
     * 某用户离开了会议
     * @callback CRVideo.CbProxy~CRVideo_UserLeftMeeting
     * @param {number} id - 离开会议的用户ID
     */
    var CRVideo_UserLeftMeeting = new CRVideo.CbProxy("CRVideo_UserLeftMeeting");

    /**
     * 通知结束视频会议结果
     * @callback CRVideo.CbProxy~CRVideo_StopMeetingRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_StopMeetingRslt = new CRVideo.CbProxy("CRVideo_StopMeetingRslt");
    /**
     * 会议已被结束
     * @callback CRVideo.CbProxy~CRVideo_MeetingStopped
     */
    var CRVideo_MeetingStopped = new CRVideo.CbProxy("CRVideo_MeetingStopped");
    /**
     * SDK通知从会议里掉线了
     * @callback CRVideo.CbProxy~CRVideo_MeetingDropped
     *  @param {number} MEETING_DROPPED_REASON - 
     */
    var CRVideo_MeetingDropped = new CRVideo.CbProxy("CRVideo_MeetingDropped");

    /**
     * SDK通知我的网络变化
     * @callback CRVideo.CbProxy~CRVideo_NetStateChanged
     * @param {number} level - 网络状况等级(0~10，10分为最佳网络)
     */
    var CRVideo_NetStateChanged = new CRVideo.CbProxy("CRVideo_NetStateChanged");
    /**
     * SDK通知本地音频设备有变化
     * @callback CRVideo.CbProxy~CRVideo_AudioDevChanged
     */
    var CRVideo_AudioDevChanged = new CRVideo.CbProxy("CRVideo_AudioDevChanged");
    /**
     * SDK通知打开本地音频状态变化
     * @callback CRVideo.CbProxy~CRVideo_AudioStatusChanged
     * @param {string} userID - 会话中设备的所有者ID
     * @param {CRVideo_ASTATUS} oldStatus - oldStatus 旧状态
     * @param {CRVideo_ASTATUS} newStatus - newStatus 新状态
     */
    var CRVideo_AudioStatusChanged = new CRVideo.CbProxy("CRVideo_AudioStatusChanged");
    /**
     * SDK通知用户的说话声音强度更新
     * @callback CRVideo.CbProxy~CRVideo_MicEnergyUpdate
     * @param {string} userID - 用户ID
     * @param {number} oldLevel - 原来的说话声音强度
     * @param {number} newLevel - 现在的说话声音强度
     */
    var CRVideo_MicEnergyUpdate = new CRVideo.CbProxy("CRVideo_MicEnergyUpdate");
    /**
     * SDK通知打开本地视频状态变化
     * @callback CRVideo.CbProxy~CRVideo_VideoStatusChanged
     * @param {string} userID - 会话中设备的所有者ID
     * @param {CRVideo_VSTATUS} oldStatus - oldStatus 旧状态
     * @param {CRVideo_VSTATUS} newStatus - newStatus 新状态
     */
    var CRVideo_VideoStatusChanged = new CRVideo.CbProxy("CRVideo_VideoStatusChanged");

    /**
     * SDK通知用户的视频设备打开结果
     * @callback CRVideo.CbProxy~CRVideo_OpenVideoDevRslt
     * @param {number} videoID - 设备ID
     * @param {bool} isSucceed - 
     */
    var CRVideo_OpenVideoDevRslt = new CRVideo.CbProxy("CRVideo_OpenVideoDevRslt");
    /**
     * SDK通知用户的视频设备有变化
     * @callback CRVideo.CbProxy~CRVideo_VideoDevChanged
     * @param {string} userID - 设备变化的用户ID
     */
    var CRVideo_VideoDevChanged = new CRVideo.CbProxy("CRVideo_VideoDevChanged");
    /**
     * SDK通知用户的视频默认设备有变化
     * @callback CRVideo.CbProxy~CRVideo_DefVideoChanged
     * @param {string} userID - 设备变化的用户ID
     * @param {number} videoID - 默认设备id
     */
    var CRVideo_DefVideoChanged = new CRVideo.CbProxy("CRVideo_DefVideoChanged");
    /**
     * SDK通知语音PCM数据
     * @callback CRVideo.CbProxy~CRVideo_NotifyAudioPCMDat
     * @param {number} aSide - 声道类型
     * @param {string} base64PcmDat - PCM数据(base64格式)
     */
    var CRVideo_NotifyAudioPCMDat = new CRVideo.CbProxy("CRVideo_NotifyAudioPCMDat");



    /**
     * 上传录制文件错误通知
     * @callback CRVideo.CbProxy~CRVideo_UploadRecordFileErr
     * @param {string} fileName - 本地文件路径
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_UploadRecordFileErr = new CRVideo.CbProxy("CRVideo_UploadRecordFileErr");

    /**
     * SDK通知录制文件状态更改
     * @callback CRVideo.CbProxy~CRVideo_NotifyRecordFileStateChanged
     * @param {string} fileName - 本地文件路径
     * @param {number} state - 状态 0 未上传 1 上传中 2已上传
     */
    var CRVideo_NotifyRecordFileStateChanged = new CRVideo.CbProxy("CRVideo_NotifyRecordFileStateChanged");
    /**
     * SDK通知上传录制文件进度
     * @callback CRVideo.CbProxy~CRVideo_NotifyRecordFileUploadProgress
     * @param {string} fileName - 文件名
     * @param {number} percent - 进度0-100
     */
    var CRVideo_NotifyRecordFileUploadProgress = new CRVideo.CbProxy("CRVideo_NotifyRecordFileUploadProgress");


    /**
     * 开启屏幕共享的响应事件
     * @callback CRVideo.CbProxy~CRVideo_StartScreenShareRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_StartScreenShareRslt = new CRVideo.CbProxy("CRVideo_StartScreenShareRslt");
    /**
     * 停止屏幕共享的响应事件
     * @callback CRVideo.CbProxy~CRVideo_StopScreenShareRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_StopScreenShareRslt = new CRVideo.CbProxy("CRVideo_StopScreenShareRslt");
    /**
     * 开启屏幕标注的响应事件
     * @callback CRVideo.CbProxy~CRVideo_StartScreenMarkRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_StartScreenMarkRslt = new CRVideo.CbProxy("CRVideo_StartScreenMarkRslt");
    /**
     * 停止屏幕标注的响应事件
     * @callback CRVideo.CbProxy~CRVideo_StopScreenMarkRslt
     * @param {number} sdkErr - 操作失败代码,定义见cr/error
     */
    var CRVideo_StopScreenMarkRslt = new CRVideo.CbProxy("CRVideo_StopScreenMarkRslt");
    /**
     * 通知他人开启了屏幕共享
     * @callback CRVideo.CbProxy~CRVideo_NotifyScreenShareStarted
     * @param {string} userID - 开启共享的用户的userID
     */
    var CRVideo_NotifyScreenShareStarted = new CRVideo.CbProxy("CRVideo_NotifyScreenShareStarted");
    /**
     * 通知他人停止了屏幕共享
     * @callback CRVideo.CbProxy~CRVideo_NotifyScreenShareStopped
     */
    var CRVideo_NotifyScreenShareStopped = new CRVideo.CbProxy("CRVideo_NotifyScreenShareStopped");
    /**
     * 通知他人开启了标注
     * @callback CRVideo.CbProxy~CRVideo_NotifyScreenMarkStarted
     * @param {string} userID - 开启共享的用户的userID
     */
    var CRVideo_NotifyScreenMarkStarted = new CRVideo.CbProxy("CRVideo_NotifyScreenMarkStarted");
    /**
     * 通知他人停止了标注
     * @callback CRVideo.CbProxy~CRVideo_NotifyScreenMarkStopped
     */
    var CRVideo_NotifyScreenMarkStopped = new CRVideo.CbProxy("CRVideo_NotifyScreenMarkStopped");
    /**
     * @typedef {object} CRVideo_Rect - 区域
     * @property {number} left - 区域右上角x坐标
     * @property {number} top - 区域右上角y坐标
     * @property {number} width - 区域宽度
     * @property {number} height - 区域高度
     */
    /**
     * 通知对端屏幕图像有变化
     * @callback CRVideo.CbProxy~CRVideo_NotifyScreenShareData
     * @param {string} userID - 用户ID
     * @param {CRVideo_Rect} rect - 变化的区域；（可以只重绘这块区域）
     */
    var CRVideo_NotifyScreenShareData = new CRVideo.CbProxy("CRVideo_NotifyScreenShareData");

    /**
     * SDK通知远程控制权限给予了某人
     * @callback CRVideo.CbProxy~CRVideo_NotifyGiveCtrlRight
     * @param {string} operId - 操作的用户ID
     * @param {string} targetId - 控制权限给予了谁
     */
    var CRVideo_NotifyGiveCtrlRight = new CRVideo.CbProxy("CRVideo_NotifyGiveCtrlRight");
    /**
     * SDK通知收回远程控制
     * @callback CRVideo.CbProxy~CRVideo_NotifyReleaseCtrlRight
     * @param {string} operId - 操作的用户ID
     * @param {string} targetId - 收回了谁的控制权限
     */
    var CRVideo_NotifyReleaseCtrlRight = new CRVideo.CbProxy("CRVideo_NotifyReleaseCtrlRight");
    /**
     * 发送IM消息，SDK通知使用者发送结果
     * @callback CRVideo.CbProxy~CRVideo_SendIMmsgRlst
     * @param {string} taskID - 发送任务id
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_SendIMmsgRlst = new CRVideo.CbProxy("CRVideo_SendIMmsgRlst");
    /**
     * SDK通知收到IM消息
     * @callback CRVideo.CbProxy~CRVideo_NotifyIMmsg
     * @param {string} fromUserID - 消息来源
     * @param {string} text - 消息内容
     * @param {number} sendTime - 消息发送时间戳，从1970开始算起
     */
    var CRVideo_NotifyIMmsg = new CRVideo.CbProxy("CRVideo_NotifyIMmsg");
    /**
     * @typedef {object} CRVideo_SubPage - 队列状态信息
     * @property {number} userID - 用户ID
     * @property {number} boardID - 白板id
     */
    /**
     * SDK通知功能切换
     * @callback CRVideo.CbProxy~CRVideo_NotifySwitchToPage
     * @param {CRVideo_MAIN_PAGE_TYPE} mainPage  - 功能类型
     * @param {string} pageID - 子页面标识
     */
    var CRVideo_NotifySwitchToPage = new CRVideo.CbProxy("CRVideo_NotifySwitchToPage");
    /**
     * SDK通知视频分屏模式切换
     * @callback CRVideo.CbProxy~CRVideo_NotifyVideoWallMode
     * @param {CRVideo_VIDEOLAYOUTMODE} model  - 分屏模式
     */
    var CRVideo_NotifyVideoWallMode = new CRVideo.CbProxy("CRVideo_NotifyVideoWallMode");
    /**
     * SDK通知主视频更改
     * @callback CRVideo.CbProxy~CRVideo_NotifyMainVideoChanged
     */
    var CRVideo_NotifyMainVideoChanged = new CRVideo.CbProxy("CRVideo_NotifyMainVideoChanged");
    /**
     * @typedef {object} CRVideo_Board - 白板信息
     * @property {string} userID - 用户ID
     * @property {number} boardID - 白板id
     * @property {string} title - 白板名称
     * @property {number} width - 白板宽度
     * @property {number} height - 白板高度
     */
    /**
     * SDK入会后通知会议中已经存在的白板列表
     * @callback CRVideo.CbProxy~CRVideo_NotifyInitBoards
     * @param {CRVideo_Board[]} BoardObjs - 已经创建好的白板列表, json结构体请参见BoardObjs说明
     */
    var CRVideo_NotifyInitBoards = new CRVideo.CbProxy("CRVideo_NotifyInitBoards");
    /**
     * 初始化白板页数据
     * @callback CRVideo.CbProxy~CRVideo_NotifyInitBoardPageDat
     * @param {string} boardID - 白板标识
     * @param {number} subPage - boardPageNo - 白板页序号
     * @param {string} imgID - 页背景文件ID（空代表无背景）
     * @param {string[]} elementDatas - 此页的所有图元, 详见json结构之BoardElementObjs
     * @param {string} operatorID - 初始化用户（为空时，代表入会时后台事件）
     */
    var CRVideo_NotifyInitBoardPageDat = new CRVideo.CbProxy("CRVideo_NotifyInitBoardPageDat");
    /**
     * SDK通知创建白板
     * @callback CRVideo.CbProxy~CRVideo_NotifyCreateBoard
     * @param {CRVideo_SubPage} jsonBoard - 白板信息，详见json格式之BoardObj
     * @param {string} operatorID - 创建白板的用户ID
     */
    var CRVideo_NotifyCreateBoard = new CRVideo.CbProxy("CRVideo_NotifyCreateBoard");
    /**
     * SDK通知关闭白板
     * @callback CRVideo.CbProxy~CRVideo_NotifyCloseBoard
     * @param {string} boardID - 白板标识
     * @param {string} operatorID - 关闭白板的用户ID
     */
    var CRVideo_NotifyCloseBoard = new CRVideo.CbProxy("CRVideo_NotifyCloseBoard");
    /**
     * SDK通知白板背景
     * @callback CRVideo.CbProxy~CRVideo_NotifyBoardBkImage
     * @param {CRVideo_SubPage} subPage - 白板信息
     * @param {string} imgFileID  - 背景图片文件，通过downloadNetDiskFile可下载到本地显示。
     * @param {string} operatorID  - 操作用户ID
     */
    var CRVideo_NotifyBoardBkImage = new CRVideo.CbProxy("CRVideo_NotifyBoardBkImage");
    /**
     * SDK通知添加图元信息
     * @callback CRVideo.CbProxy~CRVideo_NotifyAddBoardElement
     * @param {string} boardID - 白板标识
     * @param {number} subPage - boardPageNo - 白板页序号
     * @param {string[]} element - 图元信息, 详见json结构之BoardElementObj
     * @param {string} operatorID  - 添加图元的用户ID
     */
    var CRVideo_NotifyAddBoardElement = new CRVideo.CbProxy("CRVideo_NotifyAddBoardElement");
    /**
     * SDK通知图元信息被修改
     * @callback CRVideo.CbProxy~CRVideo_NotifyModifyBoardElement
     * @param {string} boardID - 白板标识
     * @param {number} subPage - boardPageNo - 白板页序号
     * @param {string[]} element - 图元信息, 详见json结构之BoardElementObj
     * @param {string} operatorID  - 添加图元的用户ID
     */
    var CRVideo_NotifyModifyBoardElement = new CRVideo.CbProxy("CRVideo_NotifyModifyBoardElement");
    /**
     * SDK通知删除图元
     * @callback CRVideo.CbProxy~CRVideo_NotifyDelBoardElement
     * @param {string} boardID - 白板标识
     * @param {number} subPage - boardPageNo - 白板页序号
     * @param {string[]} elementIDs - 图元id列表，以 “;”分隔
     * @param {string} operatorID  - 删除图元的用户ID
     */
    var CRVideo_NotifyDelBoardElement = new CRVideo.CbProxy("CRVideo_NotifyDelBoardElement");
    /**
     * SDK通知设置鼠标热点消息
     * @callback CRVideo.CbProxy~CRVideo_NotifyMouseHotSpot
     * @param {string} boardID - 白板标识
     * @param {number} x - 屏幕横坐标
     * @param {number} y - 屏幕纵坐标
     * @param {string} operatorID  - 操作者的用户ID
     */
    var CRVideo_NotifyMouseHotSpot = new CRVideo.CbProxy("CRVideo_NotifyMouseHotSpot");
    /**
     * SDK通知获取网盘容量信息结果
     * @callback CRVideo.CbProxy~CRVideo_GetNetDiskSummaryRslt
     * @param {number} diskLimit - 网盘总容量
     * @param {number} diskUsed - 网盘已用容量
     */
    var CRVideo_GetNetDiskSummaryRslt = new CRVideo.CbProxy("CRVideo_GetNetDiskSummaryRslt");
    /**
     * SDK通知获取网盘文件列表
     * @callback CRVideo.CbProxy~CRVideo_GetNetDiskFileListRslt
     * @param {string[]} fileList - 网盘文件列表，json格式，定义见NetDiskObjs
     */
    var CRVideo_GetNetDiskFileListRslt = new CRVideo.CbProxy("CRVideo_GetNetDiskFileListRslt");
    /**
     * SDK通知网盘空间已满，容量不足
     * @callback CRVideo.CbProxy~CRVideo_NotifyNetDiskIsFull
     */
    var CRVideo_NotifyNetDiskIsFull = new CRVideo.CbProxy("CRVideo_NotifyNetDiskIsFull");
    /**
     * SDK通知删除网盘文件结果
     * @callback CRVideo.CbProxy~CRVideo_NotifyNetDiskFileDeleteRslt
     * @param {string} fileID - 网盘文件id
     * @param {number} isSucceed - 是否成功 1 成功 0 失败
     */
    var CRVideo_NotifyNetDiskFileDeleteRslt = new CRVideo.CbProxy("CRVideo_NotifyNetDiskFileDeleteRslt");
    /**
     * SDK通知网盘上传或下载进度
     * @callback CRVideo.CbProxy~CRVideo_NotifyNetDiskTransforProgress
     * @param {string} fileID - 网盘文件id
     * @param {number} percent - 进度0-100
     * @param {number} isUpload -  是否是上传 1 上传 0 下载
     */
    var CRVideo_NotifyNetDiskTransforProgress = new CRVideo.CbProxy("CRVideo_NotifyNetDiskTransforProgress");
    /**
     * SDK通知影音文件打开
     * @callback CRVideo.CbProxy~CRVideo_NotifyMediaOpened
     * @param {number} totalTime - 影音时长(秒)
     * @param {number} w - 宽度
     * @param {number} h - 高度
     */
    var CRVideo_NotifyMediaOpened = new CRVideo.CbProxy("CRVideo_NotifyMediaOpened");
    /**
     * SDK通知影音开始播放
     * @callback CRVideo.CbProxy~CRVideo_NotifyMediaStart
     * @param {string} userid - 操作者的用户id
     */
    var CRVideo_NotifyMediaStart = new CRVideo.CbProxy("CRVideo_NotifyMediaStart");
    /**
     * SDK通知影音播放停止
     * @callback CRVideo.CbProxy~CRVideo_NotifyMediaStop
     * @param {string} userid - 操作者的用户id
     * @param {CRVideo_STOP_REASON} reason - 播放停止原因
     */
    var CRVideo_NotifyMediaStop = new CRVideo.CbProxy("CRVideo_NotifyMediaStop");
    /**
     * SDK通知影音播放暂停
     * @callback CRVideo.CbProxy~CRVideo_NotifyMediaPause
     * @param {string} userid - 操作者的用户id
     * @param {number} pause - 是否暂停 1暂停 0播放
     */
    var CRVideo_NotifyMediaPause = new CRVideo.CbProxy("CRVideo_NotifyMediaPause");
    /**
     * SDK通知播放进度已设置完成
     * @callback CRVideo.CbProxy~CRVideo_NotifyPlayPosSetted
     * @param {number} setPTS - 播放进度
     */
    var CRVideo_NotifyPlayPosSetted = new CRVideo.CbProxy("CRVideo_NotifyPlayPosSetted");
    /**
     * SDK通知文档转换进度
     * @callback CRVideo.CbProxy~CRVideo_NotifyCoverStateChange
     * @param {string} jsonState - 通知内容，json格式： {"state":0,"param":0}
     */
    var CRVideo_NotifyCoverStateChange = new CRVideo.CbProxy("CRVideo_NotifyCoverStateChange");
    /**
     * SDK通知文档转换失败
     * @callback CRVideo.CbProxy~CRVideo_NotifyCoverFailed
     * @param {number} coverErr - 失败原因：coverErr=0，代表传输失败;coverErr=1，代表转换失败
     */
    var CRVideo_NotifyCoverFailed = new CRVideo.CbProxy("CRVideo_NotifyCoverFailed");
    /**
     * SDK通知文档转换成功
     * @callback CRVideo.CbProxy~CRVideo_NotifyCoverSuccess
     * @param {string} 转换结果， json格式，定义见CoverRsltObjs
     */
    var CRVideo_NotifyCoverSuccess = new CRVideo.CbProxy("CRVideo_NotifyCoverSuccess");
    /**
     * SDK通知白板当前页号
     * @callback CRVideo.CbProxy~CRVideo_NotifyBoardCurPageNo
     * @param {string} boardID   - 当前的白板ID
     * @param {number} pageNo - 当前白板的页号
     * @param {number} pagePos1 - 扩展参数，当前白板页内X方向滚动条位置
     * @param {number} pagePos2 - 扩展参数，当前白板页内Y方向滚动条位置
     * @param {string} operatorID
     */
    var CRVideo_NotifyBoardCurPageNo = new CRVideo.CbProxy("CRVideo_NotifyBoardCurPageNo");
    /**
     * SDK通知请求分享
     */
    var CRVideo_NotifyRequestShare = new CRVideo.CbProxy("CRVideo_NotifyRequestShare");
    /**
     * SDK通知取消分享
     */
    var CRVideo_NotifyCancelShareRequestion = new CRVideo.CbProxy("CRVideo_NotifyCancelShareRequestion");
    /**
     * SDK通知拒绝分享
     */
    var CRVideo_NotifyRejectShareRequestion = new CRVideo.CbProxy("CRVideo_NotifyRejectShareRequestion");
    /**
     * SDK通知查询文档列表结果 
     * @param {string} dir   - 查询的目录
     * @param {number} sdkErr - 0代表成功，非0参见CRVideo_ERR_DEF
     * @param {CRVideo_ListDocFileRslt} rslt - 成功时的查询的结果，参见json格式之CRVideo_ListDocFileRslt
     */
    var CRVideo_ListNetDiskDocFileRslt = new CRVideo.CbProxy("CRVideo_ListNetDiskDocFileRslt");
    /**
     * SDK通知查询文档转换结果
     * @param {string} svrPathFileName - 查询的文档名
     * @param {number} sdkErr - 0代表成功，非0参见CRVideo_ERR_DEF
     * @param {CRVideo_GetDocPageInfoRslt} rslt -成功时的查询的结果
     */
    var CRVideo_GetNetDiskDocFilePageInfoRslt = new CRVideo.CbProxy("CRVideo_GetNetDiskDocFilePageInfoRslt");
    /**
     * SDK通知文档删除结果
     *  @param {string} svrPathFileName - 查询的文档名
     *  @param {number} sdkErr - 0代表成功，非0参见CRVideo_ERR_DEF
     */
    var CRVideo_DeleteNetDiskDocFileRslt = new CRVideo.CbProxy("CRVideo_DeleteNetDiskDocFileRslt");
    /**
     * SDK通知文档传输进度
     * @param {string}  svrPathFileName 传输的文档，或页文件名
     * @param {number} percent 传输进度（等于100代表传输完成）
     */
    var CRVideo_NotifyNetDiskDocFileTrsfProgress = new CRVideo.CbProxy("CRVideo_NotifyNetDiskDocFileTrsfProgress");


    /**
     * SDK通知本地录制、本地直播状态变化
     * @callback CRVideo.CbProxy~CRVideo_LocMixerStateChanged
     * @param {string} mixerID   - 混图器唯一标识
     * @param {number} state    - 态定义请参见 详见 CRVideo_MIXER_STATE
     *  
     */
    var CRVideo_LocMixerStateChanged = new CRVideo.CbProxy("CRVideo_LocMixerStateChanged");
    /**
     * @typedef {object} CRVideo_MixerOutputInfoObj -  录制文件、直播信息通知 
     * @property {number} state   - 状态，请见后面描述 CRVideo_OUTPUT_STATE;
     * @property {number} duration  - 录录像文件时长，单位：毫秒。
     * @property {number} fileSize    - 录像文件大小
     * @property {number} errCode   - 错误码
     */
    /**
     * SDK通知本地录制文件、本地直播信息
     ** @callback CRVideo.CbProxy~CRVideo_LocMixerOutputInfo
     * @param {string} mixerID   - 混图器唯一标识
     * @param {string} nameOrUrl - 录像名称、或直播url
     * @param {string} outputInfo - json结构的字符串请参见CRVideo_MixerOutputInfoObj
     */
    var CRVideo_LocMixerOutputInfo = new CRVideo.CbProxy("CRVideo_LocMixerOutputInfo");
    /**
     * SDK通知本地录制文件、本地直播信息
     ** @callback CRVideo.CbProxy~CRVideo_SvrMixerStateChanged
     * @param {number} state 状态值请参考 CRVideo_MIXER_STATE
     * @param {number} err - 错误值 
     * @param {string} operatorID  - 引起变化的用户id
     */
    var CRVideo_SvrMixerStateChanged = new CRVideo.CbProxy("CRVideo_SvrMixerStateChanged");
    /**
     * SDK通知云端录制、云端直播内容变化
     ** @callback CRVideo.CbProxy~CRVideo_SvrMixerCfgChanged
     */
    var CRVideo_SvrMixerCfgChanged = new CRVideo.CbProxy("CRVideo_SvrMixerCfgChanged");
    /**
     * SDK通知云端录制文件、云端直播信息变化
     ** @callback CRVideo.CbProxy~CRVideo_SvrMixerOutputInfo
     * @param {string} outputInfo - json结构字符串，请参见CRVideo_MixerOutputInfoObj
     */
    var CRVideo_SvrMixerOutputInfo = new CRVideo.CbProxy("CRVideo_SvrMixerOutputInfo");

    /**
     * SDK通知设置会议成员昵称的结果 
     ** @callback CRVideo.CbProxy~CRVideo_SetNickNameRsp
     * @param {number} sdkErr -操作结果码, 0代表设置成功, 非0代表设置失败
     * @param {string} userid - 用户id
     * @param {string} newname - 新的昵称 
     */
    var CRVideo_SetNickNameRsp = new CRVideo.CbProxy("CRVideo_SetNickNameRsp");
    /**
     * SDK通知某用户改变了昵称(改昵称的用户自身不会接收到此通知)
     ** @callback CRVideo.CbProxy~CRVideo_NotifyNickNameChanged
     * @param {string} userID - 改变昵称的某用户id
     * @param {string} oldname - 改变昵称的某用户昵称(改变之前的昵称)
     * @param {string} newname - 改变昵称的某用户昵称(改变之后的昵称)
     */
    var CRVideo_NotifyNickNameChanged = new CRVideo.CbProxy("CRVideo_NotifyNickNameChanged");
    /**
     * SDK通知视频分屏模式切换2
     * @callback CRVideo.CbProxy~CRVideo_NotifyVideoWallMode2
     * @param {CRVideo_VIDEOLAYOUTMODE} model  - 分屏模式
     */
    var CRVideo_NotifyVideoWallMode2 = new CRVideo.CbProxy("CRVideo_NotifyVideoWallMode2");
    /**
     * SDK通知成功获取到会议属性
     * @callback CRVideo.CbProxy~CRVideo_GetMeetingAllAttrsSuccess
     * @param attrs 会议属性,json结构体请参见 CRVideo_MeetingAttrObjs
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_GetMeetingAllAttrsSuccess = new CRVideo.CbProxy("CRVideo_GetMeetingAllAttrsSuccess");
    /**
     * SDK通知获取会议属性失败
     * @callback CRVideo.CbProxy~CRVideo_GetMeetingAllAttrsFail
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_GetMeetingAllAttrsFail = new CRVideo.CbProxy("CRVideo_GetMeetingAllAttrsFail");

    /**
     * SDK通知成功获取到会议属性
     * @callback CRVideo.CbProxy~CRVideo_GetMeetingAttrsSuccess
     * @param attrs 会议属性,json结构体请参见 CRVideo_MeetingAttrObjs
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_GetMeetingAttrsSuccess = new CRVideo.CbProxy("CRVideo_GetMeetingAttrsSuccess");
    /**
     * SDK通知获取会议属性失败
     * @callback CRVideo.CbProxy~CRVideo_GetMeetingAttrsFail
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_GetMeetingAttrsFail = new CRVideo.CbProxy("CRVideo_GetMeetingAttrsFail");


    /**
     * SDK通知设置会议属性结果
     * @callback CRVideo.CbProxy~CRVideo_SetMeetingAttrsRslt
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_SetMeetingAttrsRslt = new CRVideo.CbProxy("CRVideo_SetMeetingAttrsRslt");
    /**
     * SDK通知增加或更新会议属性结果
     * @callback CRVideo.CbProxy~CRVideo_AddOrUpdateMeetingAttrsRslt
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_AddOrUpdateMeetingAttrsRslt = new CRVideo.CbProxy("CRVideo_AddOrUpdateMeetingAttrsRslt");
    /**
     * SDK通知删除会议属性结果
     * @callback CRVideo.CbProxy~
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_DelMeetingAttrsRslt = new CRVideo.CbProxy("CRVideo_DelMeetingAttrsRslt");
    /**
     * SDK通知:清除会议属性结果
     * @callback CRVideo.CbProxy~
     * @param err 错误码 （错误码为CRVIDEOSDK_NOERR表示没有错误）
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_ClearMeetingAttrsRslt = new CRVideo.CbProxy("CRVideo_ClearMeetingAttrsRslt");
    /**
     * @typedef {object} CRVideo_UsrMeetingAttrObjs- 用户属性列表
     * [
    	"uid":bob,
    	{"key":"x1", "value":"y1"},
    	{"key":"x2", "value":"y2"},
    ]

     * @property {string} uid  - 用户id
     */
    /**
     * SDK通知:获取房间内用户属性成功
     * @callback CRVideo.CbProxy~
     * @param attrsMap 会议属性，json结构体请参见 UsrMeetingAttrObjs
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_GetUserAttrsSuccess = new CRVideo.CbProxy("CRVideo_GetUserAttrsSuccess");
    /**
     * SDK通知:获取房间内用户属性失败
     * @callback CRVideo.CbProxy~
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_GetUserAttrsFail = new CRVideo.CbProxy("CRVideo_GetUserAttrsFail");
    /**
     * SDK通知:设置用户属性结果
     * @callback CRVideo.CbProxy~
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_SetUserAttrsRslt = new CRVideo.CbProxy("CRVideo_SetUserAttrsRslt");
    /**
     * SDK通知::增加或者更新用户属性结果
     * @callback CRVideo.CbProxy~
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_AddOrUpdateUserAttrsRslt = new CRVideo.CbProxy("CRVideo_AddOrUpdateUserAttrsRslt");
    /**
     * SDK通知:::删除特定用户属性结果
     * @callback CRVideo.CbProxy~
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_DelUserAttrsRslt = new CRVideo.CbProxy("CRVideo_DelUserAttrsRslt");
    /**
     * SDK通知:::清除所有用户属性结果
     * @callback CRVideo.CbProxy~
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_ClearAllUserAttrsRslt = new CRVideo.CbProxy("CRVideo_ClearAllUserAttrsRslt");
    /**
     * SDK通知:::清除特定用户属性结果
     * @callback CRVideo.CbProxy~
     * @param err 
     * @param  cookie string 可为空字符串。详细介绍见 关键词
     */
    var CRVideo_ClearUserAttrsRslt = new CRVideo.CbProxy("CRVideo_ClearUserAttrsRslt");
    /**
     * @typedef {object} CRVideo_MeetingAttrObjs- 会议属性列表
     * [
    	{"key":"x1", "value":"y1"},
    	{"key":"x2", "value":"y2"},
    ]

     * @property {string} key  - 
     * @property {string} value  - 
     
    /**
     * SDK通知:::通知会议属性发生改变
     * @callback CRVideo.CbProxy~CRVideo_NotifyMeetingAttrsChanged
     * @param adds - 增加房间属性集，CRVideo_MeetingAttrObj类型
     * @param updates - 变化的房间属性集，CRVideo_MeetingAttrObj类型
     * @param delKeys - 被删除的房间属性列表，json格式，如:["key1", "key2"] 
     */

    var CRVideo_NotifyMeetingAttrsChanged = new CRVideo.CbProxy("CRVideo_NotifyMeetingAttrsChanged");

    /**
     * SDK通知:::通知成员属性发生改变
     * @param uid - 属性发生改变的成员id
     * @param adds - 增加的属性 CRVideo_MeetingAttrObj类型
     * @param updates - 变化的属性 CRVideo_MeetingAttrObj类型
     * @param delKeys - 被删除的用户属性列表，json格式，如:["key1", "key2"]
     */
    var CRVideo_NotifyUserAttrsChanged = new CRVideo.CbProxy("CRVideo_NotifyUserAttrsChanged");

    /**
     * SDK通知:通知发送房间内自定义广播消息结果
     * @callback CRVideo.CbProxy~
     * @param err - errcode (错误码为CRVIDEOSDK_NOERR表示没有错误)
     * @param cookie - 可为空字符串。详细介绍见[关键词]
     */
    var CRVideo_SendMeetingCustomMsgRslt = new CRVideo.CbProxy("CRVideo_SendMeetingCustomMsgRslt");

    /**
     * SDK通知::通知收到房间内自定义广播消息
     * @callback CRVideo.CbProxy~
     * @param uid - 房间内广播消息的发送者的用户id
     * @param jsonDat - json串，广播内容
     */
    var CRVideo_NotifyMeetingCustomMsg = new CRVideo.CbProxy("CRVideo_NotifyMeetingCustomMsg");

    /**
     * SDK通知::开启云端录制失败
     * @callback CRVideo.CbProxy~
     * @param err 错误码
     */
    var CRVideo_StartSvrMixerFailed = new CRVideo.CbProxy("CRVideo_StartSvrMixerFailed");

    //------------------------------------------------------------------------
    //
    //队列类的回调接口
    //
    //-------------------------------------------------------------------------
    /**
     * 队列初始化操作结果
     * @callback CRVideo.CbProxy~CRVideo_InitQueueDatRslt
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_InitQueueDatRslt = new CRVideo.CbProxy("CRVideo_InitQueueDatRslt");
    /**
     * @typedef {object} CRVideo_QueStatus - 队列状态
     * @property {number} queID - 队列id
     * @property {number} agent_num - 坐席数量
     * @property {number} wait_num - 排队客户数量
     * @property {number} srv_num - 正在服务的客户数量
     */
    /**
     * 队列状态变化通知
     * @callback CRVideo.CbProxy~CRVideo_QueueStatusChanged
     * @param {CRVideo_QueStatus} queStatus  -队列状态
     */
    var CRVideo_QueueStatusChanged = new CRVideo.CbProxy("CRVideo_QueueStatusChanged");
    /**
     * @typedef {object} CRVideo_QueInfo - 队列信息
     * @property {number} queID - 队列id
     * @property {number} name - 队列名称
     * @property {string} desc - 队列描述
     * @property {number} prio - 优先级，值越小优先级越高
     */
    /**
     * 排队信息变化通知
     * @callback CRVideo.CbProxy~CRVideo_QueuingInfoChanged
     * @param {CRVideo_QueInfo} queuingInfo - 队列信息
     */
    var CRVideo_QueuingInfoChanged = new CRVideo.CbProxy("CRVideo_QueuingInfoChanged");
    /**
     * 开始排队操作结果
     * @callback CRVideo.CbProxy~CRVideo_StartQueuingRslt
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {string} cookie - 自定义用户数据
     */
    var CRVideo_StartQueuingRslt = new CRVideo.CbProxy("CRVideo_StartQueuingRslt");
    /**
     * 停止排队操作结果
     * @callback CRVideo.CbProxy~CRVideo_StopQueuingRslt
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {string} cookie - 自定义用户数
     */
    var CRVideo_StopQueuingRslt = new CRVideo.CbProxy("CRVideo_StopQueuingRslt");
    /**
     * 开始服务队列操作结果
     * @callback CRVideo.CbProxy~CRVideo_StartServiceRslt
     * @param {number} queID  - 服务的队列ID
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {string} cookie - 自定义用户数
     */
    var CRVideo_StartServiceRslt = new CRVideo.CbProxy("CRVideo_StartServiceRslt");
    /**
     * 停止服务队列操作结果
     * @callback CRVideo.CbProxy~CRVideo_StopServiceRslt
     * @param {number} queID  - 服务的队列ID
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {string} cookie - 自定义用户数
     */
    var CRVideo_StopServiceRslt = new CRVideo.CbProxy("CRVideo_StopServiceRslt");
    /**
     * 响应分配客户操作结果
     * @callback CRVideo.CbProxy~CRVideo_ResponseAssignUserRslt
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {string} cookie - 自定义用户数
     */
    var CRVideo_ResponseAssignUserRslt = new CRVideo.CbProxy("CRVideo_ResponseAssignUserRslt");
    /**
     * @typedef {object} CRVideo_QueUser - 队列用户信息
     * @property {number} queID - 队列ID
     * @property {string} usrID - 用户ID
     * @property {string} name - 用户昵称
     * @property {string} queuingTime - 已排队时长(秒)
     * @property {string} param - 用户呼叫时的私有数据
     */
    /**
     * 系统自动安排客户
     * @callback CRVideo.CbProxy~CRVideo_AutoAssignUser
     * @param {CRVideo_QueUser} user - 队列用户信息
     * 如果想停止系统的自动分配，请通setDNDStatus设置免打扰功能
     */
    var CRVideo_AutoAssignUser = new CRVideo.CbProxy("CRVideo_AutoAssignUser");
    /**
     * 请求分配客户操作结果
     * @callback CRVideo.CbProxy~CRVideo_ReqAssignUserRslt
     * @param {number} sdkErr - 操作结果代码,定义见cr/error
     * @param {CRVideo_QueUser} user  - 队列用户信息
     * @param {string} cookie - 自定义用户数
     */
    var CRVideo_ReqAssignUserRslt = new CRVideo.CbProxy("CRVideo_ReqAssignUserRslt");
    /**
     * 系统取消已经安排的客户
     * @callback CRVideo.CbProxy~CRVideo_CancelAssignUser
     * @param {string} queID - 服务的队列
     * @param {string} userid - 用户id
     */
    var CRVideo_CancelAssignUser = new CRVideo.CbProxy("CRVideo_CancelAssignUser");

    /**
     * 通知有新用户进入队列排队
     * @param {string} queID - 服务的队列
     * @param {string} userid - 用户id
     */
    var CRVideo_UserEnter = new CRVideo.CbProxy("CRVideo_UserEnter");

    /**
     * 通知有用户离开队列
     * @param {string} queID - 服务的队列
     * @param {string} userid - 用户id
     * @param {string} inService - 是否是因为被别的坐席服务而离开队列
     */
    var CRVideo_UserLeave = new CRVideo.CbProxy("CRVideo_UserLeave");

     /**
     * 踢人结果
     * @param {number} sdkErr - 操作失败代码，定义见[ERR_DEF](Constant.md#CRVIDEOSDK_ERR_DEF) 
     * @param {string} userID - 被踢人UserID 
     */
    var CRVideo_KickoutRslt = new CRVideo.CbProxy("CRVideo_KickoutRslt");

    /**
     * 通知用户文件状态更改
     * @callback CRVideo.CbProxy~CRVideo_FileStateChanged
     * @param {string} fileName	 - 文件名
     * @param {CRVideo_HTTP_TRANSFER_STAT} state - 状态
     */
    var CRVideo_FileStateChanged = new CRVideo.CbProxy("CRVideo_FileStateChanged");
    /**
     * 通知用户文件http响应头
     * @callback CRVideo.CbProxy~CRVideo_FileHttpRspHeader
     * @param {string} fileName	 - 文件名
     * @param {string} rspHeader - http响应头
     */
    var CRVideo_FileHttpRspHeader = new CRVideo.CbProxy("CRVideo_FileHttpRspHeader");
    /**
     * 通知用户文件http响应结果
     * @callback CRVideo.CbProxy~CRVideo_FileHttpRspContent
     * @param {string} fileName	 - 文件名
     * @param {string} rspHeader - http响应结果
     */
    var CRVideo_FileHttpRspContent = new CRVideo.CbProxy("CRVideo_FileHttpRspContent");
    /**
     * 系统取消已经安排的客户
     * @callback CRVideo.CbProxy~CRVideo_FileProgress
     * @param {string} fileName	 - 文件名
     * @param {number} finisedSize - 已传输大小
     * @param {number} totalSize - 文件大小
     */
    var CRVideo_FileProgress = new CRVideo.CbProxy("CRVideo_FileProgress");
    /**
     * 通知用户文件传输结束
     * @callback CRVideo.CbProxy~CRVideo_FileFinished
     * @param {string} fileName -文件名
     * @param {CRVideo_HTTP_TRANSFER_RESULT} rslt - 传输结果
     */
    var CRVideo_FileFinished = new CRVideo.CbProxy("CRVideo_FileFinished");
    /**
     * 通知屏幕共享大小改变
     * @callback CRVideo.CbProxy~CRVideo_NotifyShareRectChanged
     * @param {string} w -宽度
     * @param {number} h - 高度
     */
    var CRVideo_NotifyShareRectChanged = new CRVideo.CbProxy("CRVideo_NotifyShareRectChanged");
    /**
     * SDK通知白板中是否可以使用撤销功能
     * @callback CRVideo.CbProxy~CRVideo_UndoEnableChange
     * @param {bool} 是否可以使用撤销功能，为true才可以使用
     */
    var CRVideo_UndoEnableChange = new CRVideo.CbProxy("CRVideo_UndoEnableChange");
    /**
     * SDK通知白板中是否可以使用恢复功能
     * @callback CRVideo.CbProxy~CRVideo_RedoEnableChange
     * @param {bool} 是否可以使用恢复功能，为true才可以使用
     */
    var CRVideo_RedoEnableChange = new CRVideo.CbProxy("CRVideo_RedoEnableChange");
}
if (window["000a0180686911e78dd0a45d36bb8c5c"] === undefined) {
    //---------------------------------------
    //
    //私有对象
    //
    //---------------------------------------
    //ocx对象


    CRVideo_Is_ActiveXObject = !!window.ActiveXObject || "ActiveXObject" in window;

    CRVideo_Version_OCX = '303000'
    /**
     * 录制布局
     * @enum { number }
     */
    CRVideo_RECORD_VLAYOUT = {
        /**表格类型*/
        REC_VLAYOUT_GRID: 1,
        /**画中画类型(只有在录两个视频时有效)*/
        REC_VLAYOUT_PIP: 2
    }
    /**
     * 录制视频类型
     * @enum { number }
     */
    CRVideo_RECORD_VIDEO_TYPE = {
        /**无*/
        REC_VCONTENT_NULL: 0,
        /**录制屏幕*/
        RECORD_VIDEO_TYPE_SCREEN: 1,
        /**录制摄像头*/
        REC_VCONTENT_VIDEOS: 3
    }
    /**
     * 录制音频类型
     * @enum { number }
     */
    CRVideo_RECORD_AUDIO_TYPE = {
        /**无*/
        REC_AUDIO_TYPE_NULL: 0,
        /**录制本地*/
        REC_AUDIO_TYPE_LOC: 1,
        /**录制他人*/
        REC_AUDIO_TYPE_OTHER: 2,
        /**录制所有*/
        REC_AUDIO_TYPE_ALL: 3
    }
    /**
     * 视频尺寸定义
     * @enum { number }
     */
    CRVideo_VIDEO_SHOW_SIZE = {
        VIDEO_SZ_80: 1,
        VIDEO_SZ_128: 2,
        VIDEO_SZ_160: 3,
        VIDEO_SZ_192: 4,
        VIDEO_SZ_256: 5,
        VIDEO_SZ_288: 6,
        VIDEO_SZ_320: 7,
        VIDEO_SZ_360: 8,
        VIDEO_SZ_400: 9,
        VIDEO_SZ_480: 10,
        VIDEO_SZ_576: 11,
        VIDEO_SZ_720: 12,
        VIDEO_SZ_1080: 13,
    }
    /**
     * 视频尺寸定义
     * @enum { number }
     */
    CRVideo_VIDEO_WH_RATE = {
        /**16:9宽高比*/
        RATE_16_9: 0,
        /**4:3宽高比*/
        RATE_4_3: 1,
        /**1:1宽高比*/
        RATE_1_1: 1,
    }
    /**
     * 视频图像格式
     * @enum { number }
     */
    CRVideo_VIDEO_FORMAT = {
        /**yuv420p*/
        VFMT_YUV420P: 0,
        /**32-bit ARGB format (0xAARRGGBB)*/
        VFMT_ARGB32: 1,
    }
    /**
     * 麦克风状态
     * @enum { number }
     */
    CRVideo_ASTATUS = {
        /**音频状态未知*/
        AUNKNOWN: 0,
        /**没有麦克风设备*/
        ANULL: 1,
        /**麦克风处于关闭状态（软开关）*/
        ACLOSE: 2,
        /**麦克风处于打开状态（软开关）*/
        AOPEN: 3,
        /**向服务器发送打开消息中*/
        AOPENING: 4,
    }
    /**
     * 视频状态
     * @enum { number }
     */
    CRVideo_VSTATUS = {
        /**视频状态未知*/
        VUNKNOWN: 0,
        /**没有视频设备*/
        VNULL: 1,
        /**视频处于关闭状态（软开关）*/
        VCLOSE: 2,
        /**视频处于打开状态（软开关）*/
        VOPEN: 3,
        /**向服务器发送打开消息中	*/
        VOPENING: 4,
    }
    /**
     * 录制的内容类型
     * @enum { number }
     */
    CRVideo_REC_DATATYPE = {
        /**录制所有*/
        REC_AV_DEFAULT: 0,
        /**录制本地音频*/
        REC_AUDIO_LOC: 1,
        /**录制其它音频*/
        REC_AUDIO_OTHER: 2,
        /**录制视频*/
        REC_VIDEO: 4
    }
    /**
     * 录制类型
     * @enum { number }
     */
    CRVideo_REC_VCONTENT_TYPE = {
        /**摄像头*/
        RECVTP_VIDEO: 0,
        /**图像*/
        RECVTP_PIC: 1,
        /**屏幕共享*/
        RECVTP_SCREEN: 2,
        /**影音*/
        RECVTP_MEDIA: 3,
        /**时间戳水印*/
        RECVTP_TIMESTAMP: 4, //时间戳水印，_itemDat中应有：resourceid=xxx;
        /**远端共享的屏幕*/
        RECVTP_REMOTE_SCREEN: 5,
        /*白板*/
        RECVTP_WBOARD: 6,
        /*文本*/
        RECVTP_TEXT: 7
    }
    /**
     * 录制的状态
     * @enum { number }
     */
    CRVideo_RECORD_STATE = {
        /**录制未启动*/
        NO_RECORD: 0,
        /**录制正在开启*/
        STARTING: 1,
        /**正在录制*/
        RECORDING: 2,
        /**录制已暂停*/
        PAUSED: 3,
        /**录制正在结束*/
        STOPPING: 4,
    }

    /**
     * 视频墙分屏模式
     * @enum { number }
     */
    CRVideo_VIDEOLAYOUTMODE = {
        /**互看*/
        VLO_1v1_M: 0,
        /**1分屏*/
        VLO_WALL1_M: 1,
        /**2分屏*/
        VLO_WALL2: 2,
        /**4分屏*/
        VLO_WALL4: 3,
        /**5分屏*/
        VLO_WALL5_M: 4,
        /**6分屏*/
        VLO_WALL6_M: 5,
        /**9分屏*/
        VLO_WALL9: 6,
        /**13分屏*/
        VLO_WALL13_M: 7,
        /**16分屏*/
        VLO_WALL16: 8,
        /**25分屏*/
        VLO_WALL25: 9
    }
    /**
     * 影音结束原因（STOP_REASON）
     * @enum { number }
     */
    CRVideo_STOP_REASON = {
        /**文件关闭*/
        MEDIA_CLOSE: 0,
        /**播放到文件尾部*/
        MEDIA_FINI: 1,
        /**打开文件失败*/
        MEDIA_FILEOPEN_ERR: 2,
        /**文件格式错误*/
        MEDIA_FORMAT_ERR: 3,
        /**影音格式不支持*/
        MEDIA_UNSUPPORT: 4,
        /**其他异常*/
        MEDIA_EXCEPTION: 5
    }
    /**
     * 屏幕共享的编码类型
     * @enum { number }
     */
    CRVideo_ENCODE_TYPE = {
        /**云屋科技私有编码格式（清晰度更高，带宽大）*/
        ENC_CLOUDROOM: 0,
        /**(清晰度差一些，带宽小)*/
        ENC_H264: 1
    }
    /**
     * 鼠标键类型
     * @enum { number }
     */
    CRVideo_MOUSE_KEY_TYPE = {
        /**无*/
        MOUSEKEY_NULL: 0,
        /**鼠标左键*/
        MOUSEKEY_L: 1,
        /**鼠标中键*/
        MOUSEKEY_M: 2,
        /**鼠标右键*/
        MOUSEKEY_R: 3,
        /**鼠标滚轮*/
        MOUSEKEY_WHEEL: 4,
        /**鼠标侧键*/
        MOUSEKEY_X: 5
    }
    /**
     * 鼠标事件类型
     * @enum { number }
     */
    CRVideo_MOUSE_MSG_TYPE = {
        /**鼠标移动*/
        MOUSE_MOVE: 0,
        /**鼠标键按下*/
        MOUSE_DOWN: 1,
        /**鼠标键弹起*/
        MOUSE_UP: 2,
        /**鼠标双击*/
        MOUSE_DBCLICK: 3
    }
    /**
     * 键盘事件类型
     * @enum { number }
     */
    CRVideo_KEY_MSG_TYPE = {
        /**键值按下*/
        KEYT_DWON: 0,
        /**键值弹起*/
        KEYT_UP: 1

    }

    /**
     * 功能类型
     * @enum { number }
     */
    CRVideo_MAIN_PAGE_TYPE = {
        /**视频墙*/
        MAINPAGE_VIDEOWALL: 0,
        /**共享*/
        MAINPAGE_SHARE: 1,
        /**白板*/
        MAINPAGE_WHITEBOARD: 2

    }
    /**
     * Http文件传输状态
     * @enum { number }
     */
    CRVideo_HTTP_TRANSFER_STAT = {
        /**未开始*/
        HTTPFS_NULL: 0,
        /**排队中*/
        HTTPFS_QUEUE: 1,
        /**传输中*/
        HTTPFS_TRANSFERING: 2,
        /**传输完成*/
        HTTPFS_FINISHED: 3

    }
    /**
     * Http文件传输结果
     * @enum { number }
     */
    CRVideo_HTTP_TRANSFER_RESULT = {
        /**成功*/
        HTTPR_Success: 0,
        /**内部错误*/
        HTTPR_InnerErr: 1,
        /**参数错误*/
        HTTPR_ParamErr: 2,
        /**网络不通/地址不对*/
        HTTPR_NetworkFail: 3,
        /**超时失败*/
        HTTPR_NetworkTimeout: 4,
        /**文件操作失败*/
        HTTPR_FileOperationFail: 5,
        /**不支持的路径*/
        HTTPR_PathNotSupprot: 6,
        /**文件正在传输*/
        HTTPR_FileTransfering: 7,
        /**http错误码启始*/
        HTTPR_HTTPERR_BEGIN: 1000,
        /**http错误码结束*/
        HTTPR_HTTPERR_END: 1999

    }
    /**
     * 混图内容类型 
     * @enum { number }
     */
    CRVideo_MIXER_VCONTENT_TYPE = {
        /**摄像头*/
        MIXVTP_VIDEO: 0,
        /**图片*/
        MIXVTP_PIC: 1,
        /**屏幕*/
        MIXVTP_SCREEN: 2,
        /**影音共享*/
        MIXVTP_MEDIA: 3,
        /**时间戳*/
        MIXVTP_TIMESTAMP: 4,
        /**远端共享的屏幕*/
        MIXVTP_REMOTE_SCREEN: 5,
        /**白板*/
        MIXVTP_WBOARD: 6,
        /**文本*/
        MIXVTP_TEXT: 7

    }
    /**
     * 混图器状态 
     * @enum { number }
     */
    CRVideo_MIXER_STATE = {
        /**没有创建*/
        MIXER_NULL: 0,
        /**正在开启*/
        MIXER_STARTING: 1,
        /**正在运行*/
        MIXER_RUNNING: 2,
        /**正在结束*/
        MIXER_STOPPING: 4
    }
    /**
     * 混图器输出类型 
     * @enum { number }
     */
    CRVideo_MIXER_OUTPUT_TYPE = {
        /**录像文件*/
        MIXOT_FILE: 0,
        /**直播流*/
        MIXOT_LIVE: 1
    }
    /**
     * 输出对象状态 
     * @enum { number }
     */
    CRVideo_OUTPUT_STATE = {
        /**输出对象已创建*/
        OUTPUT_CREATED: 0,
        /**输出目标信息更新; 可以从结构中取得：duration, fileSize参数；*/
        OUTPUT_WRITING: 1,
        /**输出对象已关闭; 可以从结构中取得：duration, fileSize参数；*/
        OUTPUT_CLOSED: 2,
        /**:输出对象异常；可以从结构中取得：err参数；*/
        OUTPUT_ERR: 3
    }
    /**
     * 写日志的级别
     * @enum { number }
     */
    CRVideo_E_LOG_LEVEL_DEF = {
        LOGLEVEL_DEBUG: 0,
        LOGLEVEL_INFO: 1,
        LOGLEVEL_WARN: 2,
        LOGLEVEL_ERR: 3,
        LOGLEVEL_CRIT: 4
    };
    /**
     * SDK初始化
     * @access public
     * @param {string} oemID -开发商ID,没有特别要求可填"CLOUDROOM"
     * @param {string} sdkUsePath -  sdk配置、临时文件存放位置，可为空
     * @param {number} statCallSer -  是否启用callSer模块 0为不启用，1为启用,默认为1
     * @param {number} statMediaSer -  是否启用mediaSer模块 0为不启用，1为启用,默认为1
     * @param {number} statHttp -  是否启用http模块 0为不启用，1为启用,默认为0

     * @returns {number} 返回错误码（错误码为CRVideo_NOERR表示没有错误）
     */
    CRVideo_Init2 = function(sdkUsePath, statCallSer, statMediaSer, statHttp) {
        if (statCallSer === undefined) {
            if (CRVideo.setSDKParamObj["NoCall"] === undefined) {
                CRVideo.setSDKParamObj["NoCall"] = 0;
            } else {
                //nothing
            }
        } else {
            statCallSer == 0 ? (CRVideo.setSDKParamObj["NoCall"] = 1) : (CRVideo.setSDKParamObj["NoCall"] = 0);
        }
        if (statMediaSer === undefined) {
            if (CRVideo.setSDKParamObj["NoMediaDatToSvr"] === undefined) {
                CRVideo.setSDKParamObj["NoMediaDatToSvr"] = 0;
            } else {
                //nothing
            }
        } else {
            statMediaSer == 0 ? (CRVideo.setSDKParamObj["NoMediaDatToSvr"] = 1) : (CRVideo.setSDKParamObj["NoMediaDatToSvr"] = 0);
        }
        if (statHttp === undefined) {
            statHttp = 0
        }
        return CRVideo_Init("", sdkUsePath, statCallSer, statMediaSer, statHttp);
    }
    CRVideo_Init = function(oemID, sdkUsePath, statCallSer, statMediaSer, statHttp) {
        if (statCallSer === undefined) {
            if (CRVideo.setSDKParamObj["NoCall"] === undefined) {
                CRVideo.setSDKParamObj["NoCall"] = 0;
            } else {
                //nothing
            }
        } else {
            statCallSer == 0 ? (CRVideo.setSDKParamObj["NoCall"] = 1) : (CRVideo.setSDKParamObj["NoCall"] = 0);
        }
        if (statMediaSer === undefined) {
            if (CRVideo.setSDKParamObj["NoMediaDatToSvr"] === undefined) {
                CRVideo.setSDKParamObj["NoMediaDatToSvr"] = 0;
            } else {
                //nothing
            }
        } else {
            statMediaSer == 0 ? (CRVideo.setSDKParamObj["NoMediaDatToSvr"] = 1) : (CRVideo.setSDKParamObj["NoMediaDatToSvr"] = 0);
        }
        if (statHttp === undefined) {
            statHttp = 0
        }
        try {
            if (CRVideo._isinit) {
                if (!CRVideo.ie) {
                    document.body.appendChild(CRVideo._handler)
                }
                return 0
            }
            if (CRVideo_Is_ActiveXObject) {
                CRVideo.mediaHide = document.createElement("input");
                CRVideo.mediaHide.id = "mediaInput";
                CRVideo.mediaHide.type = "text";
                CRVideo.mediaHide.name = "mediaInput";
                CRVideo.mediaHide.style.width = "1px";
                CRVideo.mediaHide.style.height = "1px";
                CRVideo.mediaHide.style.overflow = "hidden";
                CRVideo.mediaHide.style.outline = "none";
                CRVideo.mediaHide.style.border = "none";
                CRVideo.mediaHide.style.fontSize = "8px";
                document.body.appendChild(CRVideo.mediaHide);
                CRVideo.mediaHideObject = document.getElementById("mediaInput");
            }
            if (!CRVideo.ie) {
                CRVideo._crSdk = document.getElementById("crVideoObjG");

                CRVideo._crScreenShare = document.getElementById("crScreenShareObjG");
                CRVideo._crBoard = document.getElementById("crBoardObjG");

            } else {
                CRVideo._crSdk = document.getElementById("crVideoObj");

                CRVideo._crScreenShare = document.getElementById("crScreenShareObj");
                CRVideo._crBoard = document.getElementById("crBoardObj");

            }
            var versionStr = CRVideo._crSdk.Version
            var versionArr = versionStr.split(' ')
            versionArr = versionArr[0].split('.');
            version = versionArr[0] * 100 * 100 + versionArr[1] * 100 + versionArr[2]

            if (CRVideo_Version_OCX > version) {
                return CRVideo_OCX_VERSION_NOTUPPORTED;
            }

            // 关联回调事件
            if (!CRVideo.ie) {
                //-----------------------------
                //会议创建管理的回调
                //-----------------------------
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'loginSuccess', CRVideo_LoginSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'loginFail', CRVideo_LoginFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'lineOff', CRVideo_LineOff);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'setDNDStatusSuccess', CRVideo_SetDNDStatusSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'setDNDStatusFail', CRVideo_SetDNDStatusFail);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getUserStatusSuccess', CRVideo_GetUserStatusSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getUserStatusFail', CRVideo_GetUserStatusFail);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyUserStatus', CRVideo_NotifyUserStatus);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'startUserStatusNotifyRslt', CRVideo_StartUserStatusNotifyRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'stopUserStatusNotifyRslt', CRVideo_StopUserStatusNotifyRslt);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'createMeetingSuccess', CRVideo_CreateMeetingSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'createMeetingFail', CRVideo_CreateMeetingFail);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'destroyMeetingRslt', CRVideo_DestroyMeetingRslt);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getMeetingsSuccess', CRVideo_GetMeetingsSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getMeetingsFail', CRVideo_GetMeetingsFail);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'callSuccess', CRVideo_CallSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'callFail', CRVideo_CallFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'acceptCallSuccess', CRVideo_AcceptCallSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'acceptCallFail', CRVideo_AcceptCallFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'rejectCallSuccess', CRVideo_RejectCallSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'rejectCallFail', CRVideo_RejectCallFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'hangupCallSuccess', CRVideo_HangupCallSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'hangupCallFail', CRVideo_HangupCallFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCallIn', CRVideo_NotifyCallIn);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCallAccepted', CRVideo_NotifyCallAccepted);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCallRejected', CRVideo_NotifyCallRejected);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCallHungup', CRVideo_NotifyCallHungup);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'callMorePartyRslt', CRVideo_CallMorePartyRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'cancelCallMorePartyRslt', CRVideo_CancelCallMorePartyRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCallMorePartyStatus', CRVideo_NotifyCallMorePartyStatus);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'sendCmdRlst', CRVideo_SendCmdRlst);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'sendBufferRlst', CRVideo_SendBufferRlst);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'sendFileRlst', CRVideo_SendFileRlst);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'sendProgress', CRVideo_SendProgress);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'cancelSendRlst', CRVideo_CancelSendRlst);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCmdData', CRVideo_NotifyCmdData);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyBufferData', CRVideo_NotifyBufferData);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyFileData', CRVideo_NotifyFileData);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCancelSend', CRVideo_NotifyCancelSend);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyTokenWillExpire', CRVideo_NotifyTokenWillExpire);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'inviteSuccess', CRVideo_InviteSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'inviteFail', CRVideo_InviteFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'cancelInviteSuccess', CRVideo_CancelInviteSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'cancelInviteFail', CRVideo_CancelInviteFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'acceptInviteSuccess', CRVideo_AcceptInviteSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'acceptInviteFail', CRVideo_AcceptInviteFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'rejectInviteSuccess', CRVideo_RejectInviteSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'rejectInviteFail', CRVideo_RejectInviteFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyInviteIn', CRVideo_NotifyInviteIn);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyInviteAccepted', CRVideo_NotifyInviteAccepted);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyInviteRejected', CRVideo_NotifyInviteRejected);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyInviteCanceled', CRVideo_NotifyInviteCanceled);

                //-----------------------------
                //会议管理的回调接口
                //-----------------------------
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'enterMeetingRslt', CRVideo_EnterMeetingRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'userEnterMeeting', CRVideo_UserEnterMeeting);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'userLeftMeeting', CRVideo_UserLeftMeeting);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'stopMeetingRslt', CRVideo_StopMeetingRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'meetingStopped', CRVideo_MeetingStopped);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'meetingDropped', CRVideo_MeetingDropped);



                __crVideo_RegisterCallBack(CRVideo._crSdk, 'netStateChanged', CRVideo_NetStateChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'audioDevChanged', CRVideo_AudioDevChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'audioStatusChanged', CRVideo_AudioStatusChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'micEnergyUpdate', CRVideo_MicEnergyUpdate);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'videoStatusChanged', CRVideo_VideoStatusChanged);


                __crVideo_RegisterCallBack(CRVideo._crSdk, 'openVideoDevRslt', CRVideo_OpenVideoDevRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'videoDevChanged', CRVideo_VideoDevChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'defVideoChanged', CRVideo_DefVideoChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyAudioPCMDat', CRVideo_NotifyAudioPCMDat);



                __crVideo_RegisterCallBack(CRVideo._crSdk, 'uploadRecordFileErr', CRVideo_UploadRecordFileErr);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyRecordFileStateChanged', CRVideo_NotifyRecordFileStateChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyRecordFileUploadProgress', CRVideo_NotifyRecordFileUploadProgress);


                __crVideo_RegisterCallBack(CRVideo._crSdk, 'startScreenShareRslt', CRVideo_StartScreenShareRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'stopScreenShareRslt', CRVideo_StopScreenShareRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'startScreenMarkRslt', CRVideo_StartScreenMarkRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'stopScreenMarkRslt', CRVideo_StopScreenMarkRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyScreenShareStarted', CRVideo_NotifyScreenShareStarted);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyScreenShareStopped', CRVideo_NotifyScreenShareStopped);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyScreenMarkStarted', CRVideo_NotifyScreenMarkStarted);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyScreenMarkStopped', CRVideo_NotifyScreenMarkStopped);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyScreenShareData', CRVideo_NotifyScreenShareData);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyGiveCtrlRight', CRVideo_NotifyGiveCtrlRight);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyReleaseCtrlRight', CRVideo_NotifyReleaseCtrlRight);


                //-----------------------------
                //屏幕共享接口
                //-----------------------------
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyShareRectChanged', CRVideo_NotifyShareRectChanged);



                __crVideo_RegisterCallBack(CRVideo._crSdk, 'sendIMmsgRlst', CRVideo_SendIMmsgRlst);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyIMmsg', CRVideo_NotifyIMmsg);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifySwitchToPage', CRVideo_NotifySwitchToPage);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyVideoWallMode', CRVideo_NotifyVideoWallMode);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMainVideoChanged', CRVideo_NotifyMainVideoChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyInitBoards', CRVideo_NotifyInitBoards);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyInitBoardPageDat', CRVideo_NotifyInitBoardPageDat);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCreateBoard', CRVideo_NotifyCreateBoard);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCloseBoard', CRVideo_NotifyCloseBoard);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyBoardBkImage', CRVideo_NotifyBoardBkImage);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyAddBoardElement', CRVideo_NotifyAddBoardElement);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyModifyBoardElement', CRVideo_NotifyModifyBoardElement);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyDelBoardElement', CRVideo_NotifyDelBoardElement);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMouseHotSpot', CRVideo_NotifyMouseHotSpot);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getNetDiskSummaryRslt', CRVideo_GetNetDiskSummaryRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getNetDiskFileListRslt', CRVideo_GetNetDiskFileListRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyNetDiskIsFull', CRVideo_NotifyNetDiskIsFull);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyNetDiskFileDeleteRslt', CRVideo_NotifyNetDiskFileDeleteRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyNetDiskTransforProgress', CRVideo_NotifyNetDiskTransforProgress);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMediaOpened', CRVideo_NotifyMediaOpened);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMediaStart', CRVideo_NotifyMediaStart);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMediaStop', CRVideo_NotifyMediaStop);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMediaPause', CRVideo_NotifyMediaPause);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyPlayPosSetted', CRVideo_NotifyPlayPosSetted);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCoverStateChange', CRVideo_NotifyCoverStateChange);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCoverFailed', CRVideo_NotifyCoverFailed);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCoverSuccess', CRVideo_NotifyCoverSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyBoardCurPageNo', CRVideo_NotifyBoardCurPageNo);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyRequestShare', CRVideo_NotifyRequestShare);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyCancelShareRequestion', CRVideo_NotifyCancelShareRequestion);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyRejectShareRequestion', CRVideo_NotifyRejectShareRequestion);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'listNetDiskDocFileRslt', CRVideo_ListNetDiskDocFileRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getNetDiskDocFilePageInfoRslt', CRVideo_GetNetDiskDocFilePageInfoRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'deleteNetDiskDocFileRslt', CRVideo_DeleteNetDiskDocFileRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyNetDiskDocFileTrsfProgress', CRVideo_NotifyNetDiskDocFileTrsfProgress);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'locMixerStateChanged', CRVideo_LocMixerStateChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'locMixerOutputInfo', CRVideo_LocMixerOutputInfo);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'svrMixerStateChanged', CRVideo_SvrMixerStateChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'svrMixerCfgChanged', CRVideo_SvrMixerCfgChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'svrMixerOutputInfo', CRVideo_SvrMixerOutputInfo);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'setNickNameRsp', CRVideo_SetNickNameRsp);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyNickNameChanged', CRVideo_NotifyNickNameChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyVideoWallMode2', CRVideo_NotifyVideoWallMode2);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getMeetingAllAttrsSuccess', CRVideo_GetMeetingAllAttrsSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getMeetingAllAttrsFail', CRVideo_GetMeetingAllAttrsFail);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getMeetingAttrsSuccess', CRVideo_GetMeetingAttrsSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getMeetingAttrsFail', CRVideo_GetMeetingAttrsFail);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'setMeetingAttrsRslt', CRVideo_SetMeetingAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'addOrUpdateMeetingAttrsRslt', CRVideo_AddOrUpdateMeetingAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'delMeetingAttrsRslt', CRVideo_DelMeetingAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'clearMeetingAttrsRslt', CRVideo_ClearMeetingAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getUserAttrsSuccess', CRVideo_GetUserAttrsSuccess);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'getUserAttrsFail', CRVideo_GetUserAttrsFail);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'setUserAttrsRslt', CRVideo_SetUserAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'addOrUpdateUserAttrsRslt', CRVideo_AddOrUpdateUserAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'delUserAttrsRslt', CRVideo_DelUserAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'clearAllUserAttrsRslt', CRVideo_ClearAllUserAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'clearUserAttrsRslt', CRVideo_ClearUserAttrsRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMeetingAttrsChanged', CRVideo_NotifyMeetingAttrsChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyUserAttrsChanged', CRVideo_NotifyUserAttrsChanged);

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'sendMeetingCustomMsgRslt', CRVideo_SendMeetingCustomMsgRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'notifyMeetingCustomMsg', CRVideo_NotifyMeetingCustomMsg);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'startSvrMixerFailed', CRVideo_StartSvrMixerFailed);


                //-----------------------------
                //队列类的回调接口
                //-----------------------------
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'initQueueDatRslt', CRVideo_InitQueueDatRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'queueStatusChanged', CRVideo_QueueStatusChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'queuingInfoChanged', CRVideo_QueuingInfoChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'startQueuingRslt', CRVideo_StartQueuingRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'stopQueuingRslt', CRVideo_StopQueuingRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'startServiceRslt', CRVideo_StartServiceRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'stopServiceRslt', CRVideo_StopServiceRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'responseAssignUserRslt', CRVideo_ResponseAssignUserRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'autoAssignUser', CRVideo_AutoAssignUser);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'reqAssignUserRslt', CRVideo_ReqAssignUserRslt);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'cancelAssignUser', CRVideo_CancelAssignUser);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'userEnter', CRVideo_UserEnter);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'userLeave', CRVideo_UserLeave);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'kickoutRslt', CRVideo_KickoutRslt);
                

                //-----------------------------
                //http管理接口
                //-----------------------------

                __crVideo_RegisterCallBack(CRVideo._crSdk, 'fileStateChanged', CRVideo_FileStateChanged);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'fileHttpRspHeader', CRVideo_FileHttpRspHeader);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'fileHttpRspContent', CRVideo_FileHttpRspContent);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'fileProgress', CRVideo_FileProgress);
                __crVideo_RegisterCallBack(CRVideo._crSdk, 'fileFinished', CRVideo_FileFinished);

                //-----------------------------
                //Board管理接口
                //-----------------------------
                __crVideo_RegisterCallBack(CRVideo._crBoard, 'undoEnableChange', CRVideo_UndoEnableChange);
                __crVideo_RegisterCallBack(CRVideo._crBoard, 'redoEnableChange', CRVideo_RedoEnableChange);


            }

            // var setSDKParams = {"RunInWebbrowser":1, "NoCall":0,"NoMediaDatToSvr":0}
            // if(statCallSer == 0)
            // {
            // 	setSDKParams["NoCall"] = 1
            // }
            // if(statMediaSer == 0)
            // {
            // 	setSDKParams["NoMediaDatToSvr"] = 1
            // }
            CRVideo._crSdk.setSDKParams(JSON.stringify(CRVideo.setSDKParamObj));
            CRVideo._crSdk.enableLogReport(CRVideo.EnableLogReport);
            CRVideo._crSdk.enableLog2File(CRVideo.EnableLog2File);
            if (oemID == "") {
                var r = CRVideo._crSdk.init_2(sdkUsePath);
            } else if (oemID === "CLOUDROOM") {
                var r = CRVideo._crSdk.init(oemID, sdkUsePath);
            }
            if (r == 0) {
                CRVideo._isinit = true;
                var nuinit_fun = function() {
                    if (CRVideo._isinit) {
                        CRVideo._crSdk.logout();
                        CRVideo._crSdk.uninit();
                        CRVideo._isinit = false;
                    }
                }
                if (window.addEventListener) { //所有主流浏览器，除了 IE 8 及更早 IE版本
                    window.addEventListener("beforeunload", nuinit_fun);
                } else if (window.attachEvent) { // IE 8 及更早 IE 版本
                    window.attachEvent("onbeforeunload", nuinit_fun);
                };

            }

            if (statHttp) {
                CRVideo._crSdk.startMgr();
            }
            return r
        } catch (e) {
            return CRVideo_WEB_OCX_NOTINSTALLED;
        }

    }
    //回调包装 将json字符转换成json对象
    function __crVideo_CallBack() {
        var proxy = this["proxy"];
        if (proxy && proxy.callback && typeof(proxy.callback) == "function") {
            var numargs = arguments.length;
            var args = [];
            var i = 0;
            for (i = 0; i < numargs; i++) {
                var arg = arguments[i]
                if (arg && typeof(arg) == 'string') {
                    try {
                        //console.log(arg);
                        var json_arg = JSON.parse(arg);
                        var json_type = typeof(json_arg)
                        if (json_type == 'object' || json_type == 'array') {
                            arg = json_arg
                        }
                    } catch (e) {
                        //console.log(e);
                    }
                }
                args.push(arg);

            }
            if (CRVideo.ff) {
                setTimeout(proxy.callback.apply(null, args), 2000);
            } else {
                proxy.callback.apply(null, args);
            }


        }
    }
    // 注册回调事件
    function __crVideo_RegisterCallBack(obj, name, proxy) {

        if (CRVideo_Is_ActiveXObject) {
            var handler;
            try {
                handler = document.createElement("script");
            } catch (ex) {
                handler = document.createElement('<script>');
            }
            handler.type = "text/javascript"
            var functionName = proxy.name;
            //handler.appendChild(document.createTextNode("function "+obj.id+"::"+name+"(){console.log(arguments.length)}"));
            var funStr = 'try' +
                '\n{' +
                '\n    if(' + functionName + '.callback && typeof(' + functionName + '.callback) == "function")' +
                '\n    {' +
                '\n        var numargs = arguments.length;' +
                '\n        var args = [];' +
                '\n        for (i = 0; i < numargs; i++)' +
                '\n        {' +
                '\n           var arg =  arguments[i]' +
                '\n           if(arg && typeof(arg) == "string")' +
                '\n           {' +
                '\n              try' +
                '\n                {' +
                '\n                    //console.log(arg);' +
                '\n                    var json_arg = JSON.parse(arg);' +
                '\n                    var json_type = typeof(json_arg)' +
                '\n                    if(json_type == "object"|| json_type == "array")' +
                '\n                    {' +
                '\n                        arg = json_arg' +
                '\n                    }' +
                '\n                }catch(e)' +
                '\n                {' +
                '\n                    //console.log(e);' +
                '\n                }' +
                '\n           }' +
                '\n        args.push(arg);' +
                '\n        }' +
                '\n        ' + functionName + '.callback.apply(null,args);' +
                '\n    }' +
                '\n}catch(ex)' +
                '\n{' +
                '\n    throw new Error("' + functionName + '("+ex.toString()+")");' +
                '\n}'

            handler.appendChild(document.createTextNode("function " + obj.id + "::" + name + "(){\n" + funStr + "\n}"));
            CRVideo._handler.appendChild(handler);
            //window[obj.id+"::"+name] = callbackFun

        } else {
            obj[name] = __crVideo_CallBack.bind({
                "proxy": proxy
            });
        }
    }
    /**
     * SDK反初始化
     * @access public
     */
    CRVideo_Uninit = function() {
        CRVideo._crSdk.uninit();
        if (CRVideo_Is_ActiveXObject) {
            CRVideo.mediaHideObject = null;
        }
        CRVideo._isinit = false;
        CRVideo._crSdk = null;
        CRVideo._crScreenShare = null;
        CRVideo._crBoard = null;
    }
    /**
     * 设置是否开启日志
     * @access public SDK中日志功能默认是打开的,这个接口在init之前或者之后均可调用
     * @param {number} bEnable - 1表示开启日志，0表示不开启日志
     */
    CRVideo_EnableLog2File = function(bEnable) {
        CRVideo.EnableLog2File = bEnable;
    }
    /**
     *  设置是否开启日志上报
     * @access public SDK中日志上报默认是打开的,这个接口在init之前可调用
     * @param {number} bEnable - 1表示开启上报，0表示不开启上报
     */
    CRVideo_EnableLogReport = function(bEnable) {
        CRVideo.EnableLogReport = bEnable;
    }
    /**
     *  设置SDK参数 
     * @access public 这个接口在init之前调用有效
     * @param {object} jsonVal - jsonVal json格式, 如：{ "NoCall" : 1 }
     */
    CRVideo_SetSDKParams = function(jsonVal) {
        //1.标准json格式参数 2.有默认字段则改默认字段中的值 3，新字段，加入到默认obj中
        if (typeof jsonVal == 'object' && jsonVal) {
            var jsonStr = JSON.stringify(jsonVal);
            var json = JSON.parse(jsonStr);

            for (var key in json) {
                CRVideo.setSDKParamObj[key] = json[key]; //change or add
            }
        }
    }


    /**
     * 文件上传的流量控制(SDK默认不开启流控,目前对文件上传控制的功能有：录制文件上传、网盘文件上传。)
     * @access public
     * @param {number} maxbps - 每秒上传的最大字节数，小于等于0表示不开启流控
     * @returns 无
     */
    CRVideo_SetFileUploadRate = function(maxbps) {
        CRVideo._crSdk.setFileUploadRate(maxbps);
    }

    /**
     * 文件下载的流量控制
     * @access public
     * @param {number} maxBytePerSec - 每秒下载的最大字节数。-1代表不进行流控
     * @returns 无
     */
    CRVideo_SetFileDownloadRate = function(maxBytePerSec) {
        CRVideo._crSdk.setFileDownloadRate(maxBytePerSec);
    }
    /**
     * 检查插件是否运行在ie的保护模式下
     * @access public
     * @returns {bool} true - ie保护模式下； false - 非ie或非保护模式
     */
    CRVideo_IsIEProtectedMode = function() {
        return CRVideo._crSdk.isIEProtectedMode();
    }
    /**
     * 获取ie的保护模式下可读写的路径
     * @access public
     * @returns {string} 路径
     */
    CRVideo_GetWriteablePathInIEProtectedMode = function() {
        return CRVideo._crSdk.getWriteablePathInIEProtectedMode();
    }
    /**
     * 
     * @access public
     * @param {string} accessKey - 
     * @returns 无
     */
    CRVideo_SetAliyunOssAccountInfo = function(accessKey, accessSecret) {
        CRVideo._crSdk.setAliyunOssAccountInfo(accessKey, accessSecret);
    }
    /**
     * 获取Plugin版本号
     * @access public
     * @returns {string} 返回Plugin版本号
     */
    CRVideo_PluginVersion = function() {
        return CRVideo._crSdk.Version;
    }
    /**
     * 获取sdk所在的目录
     * @access public
     * @returns {string} 返回sdk所在的目录
     */
    CRVideo_SdkPath = function() {
        return CRVideo._crSdk.sdkPath;
    }
    /**
     * 设置服务器地址
     * @access public
     * @param {string} serverList -  服务器地址,多个服务器地址使用冒号隔开（如：www.cloudroom.com:8080;183.60.47.52:8080;）;
     */
    CRVideo_SetServerAddr = function(serverList) {
        CRVideo._crSdk.serverAddr = serverList;
    }
    /**
     * 获取服务器地址
     * @access public
     * @returns {string} 返回服务器地址
     */
    CRVideo_GetServerAddr = function() {
        return CRVideo._crSdk.serverAddr;
    }
    /**
     * 往日志文件中写入内容
     * @access public
     * @param {number} level - 0:SDKLEVEL_DEBUG; 1:SDKLEVEL_INFO; 2:SDKLEVEL_WARN; 3:SDKLEVEL_ERR; 4:SDKLEVEL_CRIT
     * @param {string} log - 日志内容
     * @returns 无
     */
    CRVideo_WriteLog = function(level, log) {
        CRVideo._crSdk.writeLog(level, log);
    }
    /**
     * @typedef {object} CRVideo_NetworkProxyObj -  
     * @property {string} addr - 图像宽度
     *  @property {string} port  - 图像高度
     * @property {string} name  - 图像帧率，取值范围:1-30(值越大,cpu要求更高，录像推荐15帧，直播推存25帧)
     *@property {string} pswd  - 录制视频文件的最高码率，当图像变化小时，实际码率会低于此值。
     *@property {number} type  -
     */
    /**
     * 设置网络代理
     * @access public
     * @param {CRVideo_NetworkProxyObj} proxy - json格式（字段:addr，port， name， pswd，type）
     * @returns 无
     */
    CRVideo_SetNetworkProxy = function(proxy) {
        CRVideo._crSdk.setNetworkProxy(JSON.stringify(proxy));
    }

    /**
     * 登录
     * 操作成功则回调CRVideo_LoginSuccess,失败则回调CRVideo_LoginFail
     * @access public
     * @param {string} appID - appID用于区分不同的项目，每个项目都有属于自己的唯一的appID，不同appID的项 目完全独立，无法相互通信。appID请联系云屋销售获取，并开通相关套餐和功能权 限。
     * @param {string} md5_appSecret - appID对应的密码(md5加密传给sdk)，可登录云屋管理后台修改。
     * @param {string} nickName - 昵称
     * @param {string} userID - 用户ID。和云屋系统无关，业务方自由填写，保证唯一性即可（同一appID下，具有 唯一性即可）
     * @param {string} userAuthCode -  默认填空。只有开启第三方认证才需要填写。（开启第三方认证时，云屋SDK服务器 将连接提前配好的业务方服务器进行实时验证。）
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_Login = function(appID, md5_appSecret, nickName, userID, userAuthCode, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        if (userAuthCode === undefined) {
            userAuthCode = "";
        }
        // if(!CRVideo.ie || CRVideo.v == 10.0)
        // {
        // 	document.body.appendChild(CRVideo._handler)
        // }
        CRVideo._crSdk.login(appID, md5_appSecret, nickName, userID, userAuthCode, cookie);
    }
    /**
     * 注销本次登陆
     * @access public
     */
    CRVideo_Logout = function() {
        if (CRVideo._isinit) {
            CRVideo._containerList = []
            CRVideo._crSdk.logout();
            // if(!CRVideo.ie || CRVideo.v == 10.0)
            // {
            // 	document.body.removeChild(CRVideo._handler)
            // }
        }

    }
    /**
     * 设置免打扰状态。
     * 操作成功则回调CRVideo_SetDNDStatusSuccess,失败则回调CRVideo_SetDNDStatusFail。
     * @access public
     * @param {number} DNDStatus - 0代表关闭免打扰， 其它值代表开启免打扰，含义自由定义
     * @param {string} cookie -  自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_SetDNDStatus = function(DNDStatus, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.setDNDStatus(DNDStatus, cookie);
    }

    /** 获取用户在线状态,将获取企业下所有用户在线状态（包括呼叫会议状态、免打扰状态）
     *  操作成功则回调成功事件getUserStatusSuccess  失败则回调getUserStatusFail
     *  @access public
     *  @param {number} cookie - 自定义数据(在回调时，回传给调用者)，不需要时传空字符串
     */
    CRVideo_GetUserStatus = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.getUserStatus(cookie);
    }

    /** 开启用户的状态推送
     *  开启后，企业下所有用户状态有变化时(包括呼叫会议状态、免打扰状态)，都会收到通知
     *	开启后，用户量越大消息量越大，所以请按需开启
     *  在startUserStatusNotify前，应该先通过getUserStatus获取所有用户状态
     *  @access public
     *  @param {number} cookie - 自定义数据(在回调时，回传给调用者)，不需要时传空字符串
     */
    CRVideo_StartUserStatusNotify = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.startUserStatusNotify(cookie);
    }
    /** 关闭用户的状态推送
     *  @access public
     *  @param {number} cookie - 自定义数据(在回调时，回传给调用者)，不需要时传空字符串
     */
    CRVideo_StopUserStatusNotify = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.stopUserStatusNotify(cookie);
    }
    /**
     * 创建会议
     * 操作成功则回调CRVideo_CreateMeetingSuccess,失败则回调CRVideo_CreateMeetingFail。
     * @access public
     * @param {string} meetSubject - 会议主题（字符长度最大值50）
     * @param {number} needPswd - 是否创建会议密码（=0时：会议无密码，>0时：密码由系统自动生成）
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_CreateMeeting = function(meetSubject, needPswd, cookie) {
        if (needPswd === undefined) {
            needPswd = 0;
        }
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.createMeeting(meetSubject, needPswd, cookie);
    }
    /**
     * 销毁视频会议
     * 回调CRVideo_DestroyMeetingRslt
     * @access public
     * @param {number} meetID - 会议id
     * @param {string} cookie - 自定义数据(在响应消息中回传给调用者)，不需要时传空字符串
     */
    CRVideo_DestroyMeeting = function(meetID, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.destroyMeeting(meetID, cookie);
    }
    /**
     * 发起呼叫，邀请用户参加视频会话。
     * 操作成功则回调CRVideo_CallSuccess,失败则回调CRVideo_CallFail。
     * 呼叫时，对方迟迟不响应，30秒后系统自动结束呼叫。
     * @access public
     * @param {string} calledUserID -  被叫用户的账户ID
     * @param {CRVideo_MeetInfoObj} meetObj - 会议信息
     * @param {string} usrExtDat - 自定义扩展参数
     * @param {string} cookie - 自定义数据(在回调时，回传给调用者)
     * @returns {string} 返回本次呼叫标识码（呼叫ID）
     */
    CRVideo_Call = function(calledUserID, meetObj, usrExtDat, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        return CRVideo._crSdk.call(calledUserID, JSON.stringify(meetObj), usrExtDat, cookie);
    }
    /**
     * 接受对方发起的视频请求，开始进入视频会话
     * 操作成功则回调CRVideo_AcceptCallSuccess,失败则回调CRVideo_AcceptCallFail。
     * @access public
     * @param {string} callID  -  呼叫ID
     * @param {CRVideo_MeetInfoObj} meetObj - 会议信息
     * @param {string} usrExtDat - 自定义扩展参数
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_AcceptCall = function(callID, meetObj, usrExtDat, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        CRVideo._crSdk.acceptCall(callID, JSON.stringify(meetObj), usrExtDat, cookie);
    }
    /**
     * 拒绝对方的视频请求
     * 操作成功则回调CRVideo_RejectCallSuccess,失败则回调CRVideo_RejectCallFail。
     * @access public
     * @param {string} callID  - 呼叫ID
     * @param {string} usrExtDat - 自定义扩展参数
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_RejectCall = function(callID, usrExtDat, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        CRVideo._crSdk.rejectCall(callID, usrExtDat, cookie);
    }
    /**
     * 挂断正在进行的视频呼叫或视频通话
     * 操作成功则回调CRVideo_HangupCallSuccess,失败则回调CRVideo_HangupCallFail。
     * @access public
     * @param {string} callID  - 呼叫ID
     * @param {string} usrExtDat - 自定义扩展参数
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_HungupCall = function(callID, usrExtDat, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        CRVideo._crSdk.hungupCall(callID, usrExtDat, cookie);
    }
    /**
     * 发送小块数据(一次性发送不会有进度通知,发送结果事件CRVideo_SendCmdRlst,CRVideo_SendCmd不能被CRVideo_CancelSend)
     * @access public
     * @param {string} targetUserId  - 目标用户ID
     * @param {string} data - 发送的数据
     * @returns {string} 分配的任务ID
     */
    CRVideo_SendCmd = function(targetUserId, data) {
        return CRVideo._crSdk.sendCmd(targetUserId, data);
    }
    /**
     * 发送大块数据(分块发送，进度通知事件CRVideo_SendProgress,发送结果事件CRVideo_SendBufferRlst,取消发送CRVideo_CancelSend)
     * @access public
     * @param {string} targetUserId  - 目标用户ID
     * @param {string} data - 发送的数据
     * @returns {string} 分配的任务ID
     */
    CRVideo_SendBuffer = function(targetUserId, data) {
        return CRVideo._crSdk.sendBuffer(targetUserId, data);
    }
    /**
     * 发送文件(分块发送，进度通知事件CRVideo_SendProgress,发送结果事件CRVideo_SendFileRlst,取消发送CRVideo_CancelSend)
     * @access public
     * @param {string} targetUserId  - 目标用户ID
     * @param {string} fileName - 本地路径文件名
     * @returns {string} 分配的任务ID
     */
    CRVideo_SendFile = function(targetUserId, fileName) {
        return CRVideo._crSdk.sendFile(targetUserId, fileName);
    }
    /**
     * 取消数据发送
     * 操作完成则回调CRVideo_CancelSendRlst。
     * @access public
     * @param {string} taskID - 任务ID
     */
    CRVideo_CancelSend = function(targetUserId) {
        return CRVideo._crSdk.cancelSend(targetUserId);
    }
    /**
     * 取消数据发送
     * 操作完成则回调CRVideo_CancelSendRlst。
     * @access public
     * @param {string} taskID - 任务ID
     */
    /**
     * 给视频文件添加打点信息
     * @access public
     * @param {string} videoFilePathName  视频文件路径名
     * @param {num} msecond - 视频播放的位置(毫秒)
     * @param {string} markText - 打点信息
     */
    CRVideo_SetMarkText = function(videoFilePathName, msecond, markText) {
        if (markText == undefined) {
            markText = "";
        }
        CRVideo._crSdk.setMarkText(videoFilePathName, msecond, markText);
    }
    /**
     * 移除视频文件某处打点信息
     * @access public
     * @param {string} videoFilePathName  视频文件路径名
     * @param {num} msecond - 视频播放的位置(毫秒)
     */
    CRVideo_RemoveMarkText = function(videoFilePathName, msecond) {
        CRVideo._crSdk.removeMarkText(videoFilePathName, msecond);
    }
    /**
     * 获取所有的视频打点信息
     * @access public
     * @param {string} videoFilePathName  视频文件路径名
     * @returns {json} 打点信息集合字符串
     */
    CRVideo_GetAllMarks = function(videoFilePathName) {
        return CRVideo._crSdk.getAllMarks(videoFilePathName);
    }
    /**
     * 获取视频文件对应的打点文件
     * @access public
     * @param {} videoFilePathName  视频文件路径名
     * @returns {string} 打点文件的文件路径名
     */
    CRVideo_GetVideoMarkFile = function(videoFilePathName) {
        return CRVideo._crSdk.getVideoMarkFile(videoFilePathName);
    }
    /**
     * 尝试读取磁盘文件
     * @access public
     * @param {string} diskPathFileName  磁盘文件路径名
     * @returns {number} sdkErr
     */
    CRVideo_TryReadFile = function(diskPathFileName) {
        return CRVideo._crSdk.tryReadFile(diskPathFileName);
    }
    /**
     * 读取磁盘文件
     * @access public
     * @param {string} diskPathFileName  磁盘文件路径名
     * @returns {string} base64编码格式的文件数据
     */
    CRVideo_ReadFileAsBase64 = function(diskPathFileName) {
        return CRVideo._crSdk.readFileAsBase64(diskPathFileName);
    }
    /**
     * 写文件到指定的路径
     * @access public
     * @param {string} diskPathFileName  目的文件路径名
     * @param {string} base64Dat  base64编码格式的文件数据
     * @returns {number} sdkErr
     */
    CRVideo_WriteBase64ToFile = function(diskPathFileName, base64Dat) {
        return CRVideo._crSdk.writeBase64ToFile(diskPathFileName, base64Dat);
    }
    /**
     * 获取用户打开的全路径文件名
     * @access public
     * @param  {string}  title 打开文件框的标题
     * @param  {string}  directory 打开对话框初始路径， 不设初始值时请传空
     * @param  {string}  filter 文件类型过滤器（可为空），示例：Images (*.png *.xpm *.jpg);;Text files (*.txt)
     * @returns {string} 空串表示用户取消， 否则返回用户选择的文件路径文件名
     */
    CRVideo_GetOpenFileName = function(title, directory, filter) {
        if (filter === undefined) {
            filter = "";
        }
        return CRVideo._crSdk.getOpenFileName(title, directory, filter);
    }
    /**
     * 获取用户保存的全路径文件名
     * @access public
     * @param  {string}  title 打开文件框的标题
     * @param  {string}  directory 打开对话框初始路径， 不设初始值时请传空
     * @param  {string}  filter 文件类型过滤器（可为空），示例：Images (*.png *.xpm *.jpg);;Text files (*.txt)
     * @returns {string} 空串表示用户取消， 否则返回用户保存的文件路径文件名
     */
    CRVideo_GetSaveFileName = function(title, directory, filter) {
        if (filter === undefined) {
            filter = "";
        }
        return CRVideo._crSdk.getSaveFileName(title, directory, filter);
    }
    /**
     * 获取文件大小
     * @access public
     * @param  {string}  title 指定文件的文件名
     * @returns {string} 返回文件长度
     */
    CRVideo_GetFileSize = function(title) {
        return CRVideo._crSdk.getFileSize(title);
    }
    /**
     * 删除指定文件
     * @access public
     * @param  {string}  title 要删除文件的文件名
     * @returns {string} CRVIDEOSDK_ERR_DEF类型的错误码，若无错误则返回CRVIDEOSDK_NOERR
     */
    CRVideo_DeleteFile = function(title) {
        return CRVideo._crSdk.deleteFile(title);
    }
    /**
     * @typedef {object} CRVideo_GetMeetingsParam -  获取会议列表的参数,json结构体
     * @property {number} QueryMode - 0:查询全部， 1:查询我创建的会议
     */
    /**
     * 获取视频会议列表 
     * @access public
     * @param  {CRVideo_GetMeetingsParam}  json  -  获取视频会议列表的参数,json结构体
     * @param  {string}  cookie  -  自定义数据(在响应消息中回传给调用者)，不需要时传空字符串
     * @returns 无
     */
    CRVideo_GetMeetings2 = function(json, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.getMeetings2(JSON.stringify(json), cookie);
    }
    /**
     * @typedef {object} CRVideo_CreatInfoObj -  - 创建会议信息,json结构体
     * @property {string} meetSubject - 会议名称
     * @property {number} needPswd -  是否创建密码（0:会议无密码，1:系统为会议室创建一个密码）
     * @property {number} isRegular - 是否固定会议；（0:普通会议，会议室无人30分钟后，自动消毁; 1:固定会议，会议室一直存在直到用户主动消毁它）
     */
    /**
     * 创建视频会议 
     * @access public
     * @param  {CRVideo_CreatInfoObj}  json  - 创建会议信息，json结构体定义请参见creatInfoObj
     * @param  {string}  cookie  -  自定义数据(在响应消息中回传给调用者)，不需要时传空字符串
     * @returns 无
     */
    CRVideo_CreateMeeting2 = function(json, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.createMeeting2(JSON.stringify(json), cookie);
    }
    /**
     * 获取企业下指定用户的在线状态（包括呼叫会议状态、免打扰状态）
     * @access public
     * @param  {string}   usrID  - 
     * @param  {string}  cookie  -  自定义数据(在响应消息中回传给调用者)，不需要时传空字符串
     * @returns 无
     */
    CRVideo_GetOneUserStatus = function(usrID, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.getOneUserStatus(usrID, cookie);
    }
    /**
     * 移动文件
     * @access public
     * @param  {string}   srcDiskFileName  - 
     * @param  {string}  dstDiskFileName  -  
     * @returns {number} 错误码
     */
    CRVideo_MoveFile = function(srcDiskFileName, dstDiskFileName) {
        return CRVideo._crSdk.moveFile(srcDiskFileName, dstDiskFileName);
    }
    /**
     * @access public
     *  
     * @returns {number} 错误码
     */
    CRVideo_GetUserAuthErrCode = function() {
        return CRVideo._crSdk.getUserAuthErrCode();
    }
    /**
     * 
     * @access public
     *  
     * @returns {string} 错误描述
     */
    CRVideo_GetUserAuthErrDesc = function() {
        return CRVideo._crSdk.getUserAuthErrDesc();
    }
    /**
	 * 
	 * @access public
	 * @param  {string}   token  - 
   	 * @param  {string}  nickName  -  
		* @param  {string}  userID  -  
		* @param  {string}  userAuthCode  -  
		* @param  {string}  cookie  - 
	 
	 */
    CRVideo_LoginByToken = function(token, nickName, userID, userAuthCode, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.loginByToken(token, nickName, userID, userAuthCode, cookie);
    }
    /**
     * 
     * @access public
      
    	* @param  {string}  token  - 
     
     */
    CRVideo_UpdateToken = function(token) {
        CRVideo._crSdk.updateToken(token);
    }
    /**
     * 发送邀请
     * @access public
     * @param  {string}   invitedUserID  - 受邀者用户ID
     * @param  {string}  usrExtDat  -  用户扩展数据
     * @param  {string}  cookie  -  
     * @returns {string} 返回inviteID(每个邀请对应的唯一ID)
     */
    CRVideo_Invite = function(invitedUserID, usrExtDat, cookie) {
        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        if (cookie === undefined) {
            cookie = "";
        }
        return CRVideo._crSdk.invite(invitedUserID, usrExtDat, cookie);
    }
    /**
     * 接受对方的邀请
     * @access public
     * @param  {string}   inviteID  - 邀请ID
     * @param  {string}  usrExtDat  -  用户扩展数据
     * @param  {string}  cookie  -  
     * 
     */
    CRVideo_AcceptInvite = function(inviteID, usrExtDat, cookie) {
        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.acceptInvite(inviteID, usrExtDat, cookie);
    }
    /**
     * 拒绝对方的邀请
     * @access public
     * @param  {string}   inviteID  - 邀请ID
     * @param  {string}  usrExtDat  -  用户扩展数据
     * @param  {string}  cookie  -  
     * 
     */
    CRVideo_RejectInvite = function(inviteID, usrExtDat, cookie) {

        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.rejectInvite(inviteID, usrExtDat, cookie);
    }
    /**
     * 取消自己发送的邀请
     * @access public
     * @param  {string}   inviteID  - 邀请ID
     * @param  {string}  usrExtDat  -  用户扩展数据
     * @param  {string}  cookie  -  
     * 
     */
    CRVideo_CancelInvite = function(inviteID, usrExtDat, cookie) {

        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.cancelInvite(inviteID, usrExtDat, cookie);
    }
    /**
     * 呼叫成功，双方开始进入本次视频会话
     * 操作完成则回调CRVideo_EnterMeetingRslt。
     * @access public
     * @param {number} meetID  - 视频会话ID
     * @param {string} pswd - 本次会议中的密码（系统自动生成，在呼叫回调中取得）
     * @param {string} userID  - 用户id
     * @param {string} nickName - 昵称
     * @param {string} reserve - 保留字段，填空
     */
    CRVideo_EnterMeeting = function(meetID, pswd, userID, nickName, reserve) {
        if (reserve === undefined) {
            reserve = "";
        }

        CRVideo._crSdk.enterMeeting(meetID, pswd, userID, nickName, reserve);
    }
    /**
     * 呼叫成功，双方开始进入本次视频会话
     * 操作完成则回调CRVideo_EnterMeetingRslt。
     * @access public
     * @param {number} meetID  - 视频会话ID
     * @param {string} userID  - 用户id
     * @param {string} nickName - 昵称
     */
    CRVideo_EnterMeeting2 = function(meetID, userID, nickName) {
        CRVideo._crSdk.enterMeeting2(meetID, userID, nickName);
    }
    /**
     * 判断某个用户是否在会话中
     * @access public
     * @param {string} userID - 用户的id
     * @returns {bool} 如果用户存在则返回true,否则返回false
     */
    CRVideo_IsUserInMeeting = function(userID) {
        return CRVideo._crSdk.isUserInMeeting(userID);
    }
    /**
     * 结束会议
     * 响应事件CRVideo_StopMeetingRslt，会话被他人结束回调事件CRVideo_MeetingStopped
     * @access public
     * @param {number} meetID - 会议id
     * @param {string} reserve - 保留字段， 填空
     */
    CRVideo_StopMeeting = function(meetID, reserve) {
        if (reserve === undefined) {
            reserve = "";
        }
        CRVideo._crSdk.stopMeeting(meetID, reserve);
    }
    /**
     * 获取会议列表
     * 响应事件CRVideo_GetMeetingsSuccess，会话被他人结束回调事件CRVideo_GetMeetingsFail
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     * @access public
     */
    CRVideo_GetMeetings = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.getMeetings(cookie);
    }
    /**
     * 离开会话
     * 他人离开会话的回调事件CRVideo_UserLeftMeeting
     * @access public
     */
    CRVideo_ExitMeeting = function() {
        CRVideo._crSdk.exitMeeting();
    }
    /**
     * @typedef {object} CRVideo_MemberInfo - 成员信息
     * @property {string} userID - 用户ID
     * @property {string} nickname - 昵称
     * @property {CRVideo_ASTATUS} audioStatus - 音频状态,数值参考麦克风状态
     * @property {CRVideo_VSTATUS} videoStatus - 视频状态,数值参考视频状态定义
     */
    /**
     * 获取所有用户的信息
     * @access public
     * @return {CRVideo_MemberInfo[]} 返回含多个成员信息
     */
    CRVideo_GetAllMembers = function() {
        return CRVideo._crSdk.getAllMembers();
    }
    /**
     * 获取指定用户的信息
     * @access public
     * @param {string} userID - 用户ID
     * @return {CRVideo_MemberInfo} info - 返回用户userID的成员信息

     */
    CRVideo_GetMemberInfo = function(userID) {
        return CRVideo._crSdk.getMemberInfo(userID);
    }
    /**
     * 获取某个用户的昵称
     * @access public
     * @param {string} userID	 - 用户ID
     * @returns {string} 返回用户userID的昵称
     */
    CRVideo_GetMemberNickName = function(userID) {
        return CRVideo._crSdk.getMemberNickName(userID);
    }


    /**
     * 获取系统上的麦克风设备列表
     * @access public
     * @returns {string[]} 返回麦克风设备字符串列表
     */
    CRVideo_GetAudioMicNames = function() {
        return CRVideo._crSdk.getAudioMicNames().split("\n");;
    }
    /**
     * 获取系统上的扬声器设备列表
     * @access public
     * @returns {string[]} 返回扬声器设备列表
     */
    CRVideo_GetAudioSpkNames = function() {
        return CRVideo._crSdk.getAudioSpkNames().split("\n");
    }
    /**
     * @typedef {object} CRVideo_AudioCfg - 音频参数
     * @property {string} micName - 麦克风设备名称(空代表系统默认设备)
     * @property {string} speakerName - 扬声器名称（空代表系统默认设备)
     * @property {number} echoCancelDelay - 回声延时(ms) ，-1，自动检测（缺省值）；0：配置指定的回声延时，如:40； （对于一些定制的设备，有准确的回声延时，可在此配置）
     * @property {number} echoSuppression - 是否开启回声抑制，0，(缺省值）不开启；1开启（开启后回声消除更强，但会影响音质）
     * @property {number} privEC - 是否开启云屋私有回声消息0：不开启；1：开启
     * @property {number} privAgc - 是否开启云屋私有语音自动增益0：不开启(缺省值）；1：开启
     */
    /**
     * 获取音频参数
     * @access public
     * @returns {CRVideo_AudioCfg} 返回cfg对象
     */
    CRVideo_GetAudioCfg = function() {
        return JSON.parse(CRVideo._crSdk.getAudioCfg());
    }
    /**
     * 系统音频参数设置
     * @access public
     * @param {CRVideo_AudioCfg} cfg - 设置参数
     */
    CRVideo_SetAudioCfg = function(cfg) {
        CRVideo._crSdk.setAudioCfg(JSON.stringify(cfg));
    }

    /**
     * 设置麦克风音量大小
     * @access public
     * @param {number} level - 音量等级（ 取值范围：0~255）
     * @returns {bool} 设置成功则返回true,否则返回false
     */
    CRVideo_SetMicVolume = function(level) {
        return CRVideo._crSdk.micVolume = level;
    }

    /**
     * 获取麦克风音量
     * @access public
     * @returns {number} 返回麦克风音量（0~255）
     */
    CRVideo_GetMicVolume = function() {
        return CRVideo._crSdk.micVolume;
    }
    /**
     * 设置本地扬声器音量
     * @access public
     * @param {number} level - 音量等级（ 取值范围：0~255）
     * @returns {bool} 设置成功则返回true,否则返回false
     */
    CRVideo_SetSpeakerVolume = function(value) {
        return CRVideo._crSdk.speakerVolume = value;
    }
    /**
     * 获取本地扬声器音量
     * @access public
     * @returns {number} 返回扬声器音量（0~255）
     */
    CRVideo_GetSpeakerVolume = function() {
        return CRVideo._crSdk.speakerVolume;
    }
    /**
     * 设置扬声器是否静音
     * @access public
     * @param {number} value - 1,静音，0，不静音
     * @returns {bool} 设置成功则返回true,否则返回false
     */
    CRVideo_SetSpeakerMute = function(value) {
        return CRVideo._crSdk.speakerMute = value;
    }
    /**
     * 获取扬声器是否静音
     * @access public
     * @returns {number} 扬声器是否静音， 1,静音，0，不静音
     */
    CRVideo_GetSpeakerMute = function() {
        return CRVideo._crSdk.speakerMute;
    }
    /**
     * 获取用户说话声音大小
     * @access public
     * @param {string} userID - 登录成功后分配的userID
     * @returns {number} 返回音量（0~10）
     */
    CRVideo_GetMicEnergy = function(userID) {
        return CRVideo._crSdk.getMicEnergy(userID);
    }
    /**
     * 打开自己的麦克风
     * 打开自已的麦克风时，先会进入到AOPENING状态，等服务器处理后才会进入AOPEN状态，此时说话才能被采集到；
     * @param {string} userID - 用户的ID
     * @access public
     */
    CRVideo_OpenMic = function(userid) {
        CRVideo._crSdk.openMic(userid);
    }
    /**
     * 关闭自己的麦克风
     * 关麦操作是立即生效的，本地会立即停止采集；
     * @access public
     * @param {string} userID - 登录成功后分配的userID
     */
    CRVideo_CloseMic = function(userid) {
        CRVideo._crSdk.closeMic(userid);
    }
    /**
     * 获取用户的麦状态
     * 麦克风设备状态
     * @access public
     * @param {string} userID - 登录成功后分配的userID
     * @returns {CRVideo_ASTATUS} 返回麦克风状态
     */
    CRVideo_GetAudioStatus = function(userID) {
        return CRVideo._crSdk.getAudioStatus(userID);
    }
    /**
     * 关闭所有用户的麦克风
     * @access public
     */
    CRVideo_SetAllAudioClose = function() {
        CRVideo._crSdk.setAllAudioClose();
    }
    /**
     * @typedef {object} CRVideo_VideoCfg - 视频参数
     * @property {string} size - 视频尺寸,"640*360"
     * @property {number} fps - 帧率：视频帧率(5~30)
     * @property {number} maxbps - 视频码率（1~100*1000*1000）;(未配置则使用内部默认值，请参见VIDEO_SHOW_SIZE)
     * @property {number} qp_min - 最佳质量(18~51, 越小质量越好) (未配置则使用内部默认值25)
     * @property {number} qp_max - 最差质量(18~51, 越大质量越差) (未配置则使用内部默认值36)
     
     */
    /**
     * 系统视频参数设置
     * @access public
     * @param {CRVideo_VideoCfg} cfg - 设置参数
     * @returns {bool} 返回值 true false
     */
    CRVideo_SetVideoCfg = function(cfg) {
        return CRVideo._crSdk.setVideoCfg(JSON.stringify(cfg));
    }
    /**
     * 开始获取语音pcm数据
     * @access public
     * @param {number} aSide - 声道类型 0:麦克风，1:扬声器
     * @param {number} getType - 获取方式 0:回调方式，1:保存为文件
     * @param {string} jsonParam - 当getType=0 表示回调方式, jsonParam可配置回调的数据大小(320-32000)，如: {"EachSize":320};当getType=1 表示保存为文件，jsonParam可配置文件名,如: { "FileName" : "e:\\test.pcm" }
     * @returns {number} 返回值 整形数值，1：正常，0：失败
     */
    CRVideo_StartGetAudioPCM = function(aSide, getType, jsonParam) {
        return CRVideo._crSdk.startGetAudioPCM(aSide, getType, JSON.stringify(jsonParam));
    }
    /**
     * 停止获取语音pcm数据
     * @access public
     * @param {number} aSide - 声道类型 0:麦克风，1:扬声器
     * @param 无返回值
     */
    CRVideo_StopGetAudioPCM = function(aSide) {
        CRVideo._crSdk.stopGetAudioPCM(aSide);
    }
    /**
     * 获取视频参数
     * @access public
     * @returns {CRVideo_VideoCfg} 返回cfg对象
     */
    CRVideo_GetVideoCfg = function() {
        return JSON.parse(CRVideo._crSdk.getVideoCfg());
    }
    /**
     * 获取用户的摄像头状态
     * @access public
     * @param {string} userID - 用户ID
     * @returns {CRVideo_VSTATUS} 麦克风摄像头状态
     */
    CRVideo_GetVideoStatus = function(userID) {
        return CRVideo._crSdk.getVideoStatus(userID);
    }

    /**
     * 打开用户的摄像头，以便本地、远端显示视频图像
     * @access public
     * @param {string} userID - 用户ID
     */
    CRVideo_OpenVideo = function(userID) {
        CRVideo._crSdk.openVideo(userID);
    }
    /**
     * 关闭用户的摄像头
     * @access public
     * @param {string} userID - 用户ID
     */
    CRVideo_CloseVideo = function(userID) {
        CRVideo._crSdk.closeVideo(userID);
    }
    /**
     * @typedef {object} CRVideo_VideoImgObj - 视频参数
     * @property {number} format - 视频尺寸，请参见：CRVideo_VIDEO_FORMAT
     * @property {string} dat - 图像数据Base64编码
     * @property {number} width - 图像宽度
     * @property {number} height - 图像高度
     */
    /**
     * 获取指定用户的最新图像
     * @access public
     * @property {string} userID - 用户ID
     * @property {number} videoID - 设备id
     * @returns {CRVideo_VideoImgObj} 返回frame视频数据
     */
    CRVideo_GetVideoImg = function(userID, videoID) {
        return CRVideo._crSdk.getVideoImg(userID, videoID);
    }

    /**
     * 设置默认的摄像头
     * @access public
     * @param {string} userID - 用户ID
     * @param {number} videoID - 摄像头ID
     */
    CRVideo_SetDefaultVideo = function(userID, videoID) {
        CRVideo._crSdk.setDefaultVideo(userID, videoID);
    }
    /**
     * 获取指定用户的默认摄像头
     * 如果用户没有摄像头，返回0；
     * @access public
     * @param {string} userID - 用户ID
     * @returns {number} 返回摄像头ID
     */
    CRVideo_GetDefaultVideo = function(userID) {
        return CRVideo._crSdk.getDefaultVideo(userID);
    }
    /**
     * 查询用户是否启用多摄像头
     * @access public
     * @param {string} userID - 用户ID
     * @returns {bool} 返回用户是否多摄像头
     */
    CRVideo_GetEnableMutiVideo = function(userID) {
        return CRVideo._crSdk.getEnableMutiVideo(userID);
    }
    /**
     * 设置用户是否打开多摄像头
     * @access public
     * @param {string} userID - 登录成功后分配的userID
     * @param {bool} enable - 是否打开多摄像头
     */
    CRVideo_SetEnableMutiVideo = function(userID, enable) {
        CRVideo._crSdk.setEnableMutiVideo(userID, enable);
    }
    /**
     * @typedef {object} CRVideo_VideoDeviceInfo - 视频设备信息
     * @property {string} userID - 用户ID
     * @property {string} videoID - 设备id
     * @property {string} videoName - 设备名称
     */
    /**
     * 获取用户所有的摄像头信息
     * @access public
     * @returns {CRVideo_VideoDeviceInfo[]} 返回设备列表
     */
    CRVideo_GetAllVideoInfo = function(userID) {
        return JSON.parse(CRVideo._crSdk.getAllVideoInfo(userID));
    }
    /**
     * @typedef {object} CRVideo_VideoIDsObj - 视频设备对象
     * @property {string} userID - 用户ID
     * @property {string} videoID - 设备id
     */
    /**
     * 获取会议内所有可观看的摄像头
     * 只有摄像头打开才能被获取到,能获取到自已的和会议里其他人的；
     * @access public
     * @returns {CRVideo_VideoIDsObj[]} 对象VideoIDArray
     */
    CRVideo_GetWatchableVideos = function() {
        return CRVideo._crSdk.getWatchableVideos();
    }
    /**
     * 开启或关闭摄像头降噪处理；
     * @access public
     * @param {bool} bDenoise - 取值true时，开启降噪处理
     * @returns 无
     */
    CRVideo_SetVideoDenoise = function(bDenoise) {
        CRVideo._crSdk.setVideoDenoise(bDenoise);
    }
    /**
     * 获取是否开启摄像头降噪
     * @access public
     * 返回值 true:降噪已开启，false:降噪未开启
     */
    CRVideo_GetVideoDenoise = function() {
        return CRVideo._crSdk.getVideoDenoise();
    }
    /**
     * 获取是否开启摄像头降噪
     * @access public
     * 返回值 true:降噪已开启，false:降噪未开启
     */
    CRVideo_GetVideoDenoise = function() {
        return CRVideo._crSdk.getVideoDenoise();
    }
    /**
     * 添加网络摄像头（sdk最大支持5个)
     * 添加成功后与本地摄像头处理一致；getAllVideoInfo接口可以识别哪些是网络摄像头。
     * @access public
     * @param {string} url 网络摄像头url，支持协议:rtmp,rtsp
     * 返回值 sdkErr 操作结果码, 0代成功, 非0代表入会失败，取值参考CRVideo_ERR_DEF
     */
    CRVideo_AddIPCam = function(url) {
        return CRVideo._crSdk.addIPCam(url);
    }
    /**
     * 移除网络摄像头
     * @access public
     * @param {string} url 网络摄像头url
     * 返回值 无
     */
    CRVideo_DelIPCam = function(url) {
        CRVideo._crSdk.delIPCam(url);
    }
    /**
     * 暂未定义
     * @access public
     * @param {string} picID -
     * @param {object} jsonval -
     */
    CRVideo_SetPicResource = function(picID, jsonval) {
        CRVideo._crSdk.setPicResource(picID, JSON.stringify(jsonval))
    }
    /**
     * @typedef {object} CRVideo_ScreenShareCfgObj - 屏幕共享配置对象
     * @property {number} encodeType - 编码类型,详见屏幕共享的编码类型CRVideo_ENCODE_TYPE
     * @property {object} catchRect - {"left":xx,"top":xx,"width":xx,"height":xx}用于实现区域共享
     * @property {number} catchWnd - 共享窗口的窗口句柄，用于实现窗口共享
     * @property {number} maxFPS - 最大帧率, 缺省为8 (当网络发不动时，帧率会自动下降)
     * @property {number} maxKbps - 最大码率，缺省800kbps
     */
    /**
     * 获取当前屏幕共享配置
     * @access public
     * @returns {CRVideo_ScreenShareCfgObj} 屏幕共享配置
     */
    CRVideo_GetScreenShareCfg = function() {
        return JSON.parse(CRVideo._crSdk.getScreenShareCfg())
    }
    /**
     * 设置屏幕共享配置
     * @access public
     * @param {CRVideo_ScreenShareCfgObj} jsonCfg 屏幕共享配置
     */
    CRVideo_SetScreenShareCfg = function(jsonCfg) {
        CRVideo._crSdk.setScreenShareCfg(JSON.stringify(jsonCfg))
    }
    /**
     * 开启屏幕共享
     * 操作完成则回调CRVideo_StartScreenShareRslt
     * @access public
     */
    CRVideo_StartScreenShare = function() {
        CRVideo._crSdk.startScreenShare()
    }
    /**
     * 停止屏幕共享
     * @access public
     */
    CRVideo_StopScreenShare = function() {
        CRVideo._crSdk.stopScreenShare()
    }
    /**
     * 开始屏幕标注
     * @access public
     */
    CRVideo_StartScreenMark = function() {
        CRVideo._crSdk.startScreenMark()
    }
    /**
     * 停止屏幕标注
     * @access public
     */
    CRVideo_StopScreenMark = function() {
        CRVideo._crSdk.stopScreenMark()
    }
    /**
     * 获取屏幕共享解码图像
     * @access public
     * @returns {CRVideo_VideoImgObj}
     */
    CRVideo_GetShareScreenDecodeImg = function() {
        return CRVideo._crSdk.getShareScreenDecodeImg()
    }
    /**
     * 设置自定义的抓屏图像数据
     * @access public
     * @param {CRVideo_VIDEO_FORMAT} format - 视频格式
     * @param {number} width - 图像的宽度
     * @param {number} heigh - 图像的高度
     * @param {string} dat - 承载argb数据,base64编码
     */
    CRVideo_SetCustomizeScreenImg = function(format, width, heigh, dat) {
        return CRVideo._crSdk.getShareScreenDecodeImg(format, width, heigh, dat)
    }
    /**
     * 赋予控制权限
     * @access public
     * @param {string} userID -  用户ID
     */
    CRVideo_GiveCtrlRight = function(userID) {
        return CRVideo._crSdk.giveCtrlRight(userID)
    }
    /**
     * 收回控制权限
     * @access public
     * @param {string} userID -  用户ID
     */
    CRVideo_ReleaseCtrlRight = function(userID) {
        return CRVideo._crSdk.releaseCtrlRight(userID)
    }
    /**
     * 发送鼠标控制消息
     * @access public
     * @param {CRVideo_MOUSE_MSG_TYPE} msgType -  鼠标事件类型
     * @param {CRVideo_MOUSE_KEY_TYPE} mouseMsgType -  鼠标键类型
     * @param {number} x -  鼠标在屏幕中的横坐标
     * @param {number} y -  鼠标在屏幕中的纵坐标
     */
    CRVideo_SendMouseCtrlMsg = function(msgType, mouseMsgType, x, y) {
        return CRVideo._crSdk.sendMouseCtrlMsg(msgType, mouseMsgType, x, y)
    }
    /**
     * 发送键盘控制消息
     * @access public
     * @param {CRVideo_KEY_MSG_TYPE} keyMsgType -  键盘事件类型
     * @param {number} vk -   键盘虚拟键值
     * @param {number} bExtendedKey -
     */
    CRVideo_SendKeyCtrlMsg = function(keyMsgType, vk, extendedKey) {
        return CRVideo._crSdk.sendKeyCtrlMsg(keyMsgType, vk, extendedKey)
    }

    /**
     * 开始录制
     * @access public
     * @param {string} recordPath - 录像存储的路径
     * @param {number} frameRate - 帧率，建议不要太高；(取值1~24)
     * @param {number} recordWidth - 视频宽度
     * @param {number} recordHeight - 视频高度
     * @param {number} bitRate - 录制的最高码率，当图像变化小时，实际码率会低于此值。建议：640*360: 500000; (500kbps)，1280*720：1000000; (1mbps)，1920*1080: 2000000; (2mbps)
     * @param {number} defaultQP - 目标质量(推荐:36, 中:28,  高:22)
     * @param {CRVideo_REC_DATATYPE} recDataType - 录制内容类型（视频+音频）
     * @param {number} isUploadOnRecording - 是否录制的同时上传 1为是，0为否
     */
    CRVideo_StartRecordIng2 = function(local_recordCfgObj) {
        if (local_recordCfgObj.serverPathFileName == undefined) {
            local_recordCfgObj.serverPathFileName = "";
        }
        CRVideo._crSdk.startRecording(JSON.stringify(local_recordCfgObj));

    }
    /**
     * @typedef {object} CRVideo_RecordVideoInfo - 需要录制的视频信息
     * @property {number} left - 左
     * @property {number} top - 上
     * @property {number} width - 宽
     * @property {number} height - 高
     * @property {object} param - 附加参数
     * @property {CRVideo_REC_VCONTENT_TYPE} param.type - 录制类型
     * @property {number} keepAspectRatio - 1、表示内容保持比例居中显示，0、表示内容拉伸
     * @property {string} param.camid - 用户id.摄像头id,示例中c90d98e2-e50d-4abe-a318-104271a47cb6为用户id，1为摄像头id
     */

    /**
     * 开始云端录制
     * @access public
     * @param {json} jsonRecordCfg 录制参数，定义见RecordCfgObj
     * @jsonContents 录制内容，定义见RecordContentObj
     * @returns  无返回参数
     */
    CRVideo_StartSvrRecording = function(jsonRecordCfg, jsonContents) {
        CRVideo._crSdk.startSvrRecording(JSON.stringify(jsonRecordCfg), JSON.stringify(jsonContents));
    }
    /**
     * 更新云端录制内容
     * @access public
     * @param {json} jsonContents 录制内容，定义见RecordContentObj
     * @returns  无返回参数
     */
    CRVideo_UpdateSvrRecordContents = function(jsonContents) {
        CRVideo._crSdk.updateSvrRecordContents(JSON.stringify(jsonContents));
    }
    /**
     * 停止云端录制
     * @access public
     * @returns  无返回参数
     */
    CRVideo_StopSvrRecording = function() {
        CRVideo._crSdk.stopSvrRecording()
    }

    /* 获取当前云端录制的状态
     * @access public
     * @returns  返回值 录制状态，定义见RECORD_STATE
     */
    CRVideo_GetSvrRecordState = function() {
        return CRVideo._crSdk.getSvrRecordState()
    }

    /**
     * @typedef {object} CRVideo_RecordFileInfo - 录制文件信息
     * @property {string} fileName - 文件名，全路径
     * @property {number} state - 0 没有上传，1上传中，2 上传完毕
     * @property {number} size - 文件大小
     * @property {number} uploadPercent - 上传进度，state为1时关注此字段
     * @property {string} httpUrl - 文件的http访问地址（只有上传到云屋服务器此字段才有效）
     */
    /**
     * 取得所有录制文件信息
     * @access public
     * @return {CRVideo_RecordFileInfo[]} - 返回含多个录制文件信息
     */
    CRVideo_GetAllRecordFiles = function() {
        return JSON.parse(CRVideo._crSdk.getAllRecordFiles());
    }
    /**
     * 第三方录制文件调用此接口后可进行本地回放和上传到服务器record下
     * @access public
     * @return {CRVideo_AddFileToRecordMgr[]} - -1：本地文件不存在，0：成功，1：文件已经被添加过
     * @typedef {object} CRVideo_AddFileToRecordMgr - 添加本地文件到录制文件管理中
     * @property {string} fileName - 文件名，不含路径
     * @property {string} filePath - 文件路径，不含文件名
     */
    CRVideo_AddFileToRecordMgr = function(fileName, filePath) {
        return JSON.parse(CRVideo._crSdk.addFileToRecordMgr(fileName, filePath));
    }

    /**
     * 上传文件在默认位置
     * @access public
     * @param {string} filename - 文件名
     */
    CRVideo_UploadRecordFile = function(fileName) {
        CRVideo._crSdk.uploadRecordFile(fileName);
    }
    /**
     * 上传文件到服务器指定位置
     * @access public
     * @param {string} filename - 文件名
     * @param {string} svrPathFileName - 服务器路径文件名
     */
    CRVideo_UploadRecordFile2 = function(fileName, svrPathFileName) {
        CRVideo._crSdk.uploadRecordFile2(fileName, svrPathFileName);
    }

    /**
     * 取消上传录像文件
     * @access public
     * @param {string} filename - 文件名
     */
    CRVideo_CancelUploadRecordFile = function(fileName) {
        CRVideo._crSdk.cancelUploadRecordFile(fileName);
    }

    /**
     * 回放录制文件
     * @access public
     * @param {number} filename - 文件名
     */
    CRVideo_PlaybackRecordFile = function(filename) {
        CRVideo._crSdk.playbackRecordFile(filename)
    }
    /**
     * 发送IM消息
     * 响应事件CRVideo_SendIMmsgRlst
     * @access public
     * @param {string} text - 发送的文本消息
     * @param {string} UserID - 目标用户，如果用户ID为空，消息发送给会议内所有用户
     * @param {string} cookie - 自定义用户数据
     * @returns {string} - 任务id
     */
    CRVideo_SendIMmsg = function(text, UserID, cookie) {
        if (cookie == undefined) {
            cookie = "";
        }
        return CRVideo._crSdk.sendIMmsg(text, UserID, cookie);
    }
    /**
     * 功能切换
     * @access public
     * @param {number} mainPage -功能类型
     * @param {string} pageID - 子页面标识（如创建白板时返回的boardID）
     */
    CRVideo_Switchtopage = function(mainPage, pageID) {
        if (CRVideo.ie) {
            CRVideo.mediaHideObject.focus();
        }
        CRVideo._crSdk.switchToPage(mainPage, pageID)
    }
    /**
     * 获取当前主功能区
     * @access public
     * @returns {CRVideo_MAIN_PAGE_TYPE} 功能区
     */
    CRVideo_Getcurrentmainpage = function() {
        return CRVideo._crSdk.getCurrentMainPage()
    }
    /**
     * 获取当前子功能区
     * @access public
     * @returns pageID -页面ID
     */
    CRVideo_Getcurrentsubpage = function() {
        return CRVideo._crSdk.getCurrentSubPage()
    }
    /**
     * 设置视频墙分屏模式
     * @access public
     * @param {CRVideo_VIDEOLAYOUTMODE} videoWallMode - 分屏模式
     */
    CRVideo_Setvideowallmode = function(videoWallMode) {
        CRVideo._crSdk.setVideoWallMode(JSON.stringify(videoWallMode))
    }
    /**
     * 获取视频墙当前分屏模式
     * @access public
     * @returns {CRVideo_VIDEOLAYOUTMODE} videoWallMode - 分屏模式
     */
    CRVideo_GetVideoWallMode = function() {
        return CRVideo._crSdk.getVideoWallMode()
    }
    /**
     * 创建白板 其他参会者会收到：notifyCreateBoard事件;同时后台会记录下白板数据，新入会者会收到：notifyInitBoards事件.注意：创建完白板后，一定要及尽快调用initBoardPageDat初始化各页数据
     * @param {string} title -白板名称
     * @param {number} width - 白板宽度
     * @param {number} height - 白板高度
     * @param {number} pageCount - 白板内有多个页（一般空白板1页，文档白板为实际页数）
     * @returns {CRVideo_SubPage} - 白板信息
     */
    CRVideo_Createboard = function(title, width, height, pageCount) {
        return CRVideo._crSdk.createBoard(title, width, height, pageCount)
    }
    /**
     * 初始化白板指定页数据 1. 关于imgID:imgID非空时, 代表背景的图片ID(建议为uuid)。（对应的文件应通uploadNetDiskFile(imgID, 本地文件名)上传到服务器；）2.其他参会者将收到notifyInitBoardPageDat事件；3.后台会记录下白板的页数据，在新用户入会时，也会收到notifyInitBoardPageDat事件
     * @access public
     * @param {string} boardID - 白板标识
     * @param {number} boardPageNo - 白板第几页（0:代表第一页）
     * @param {string} imgID - 白板的背景图片标识(空代表无背影图)
     * @param {string} elemets - 白板的初始图元（空代表无图元，一般在导入历史文件才用到）
     */
    CRVideo_InitBoardPageDat = function(boardID, boardPageNo, imgID, elemets) {
        CRVideo._crSdk.initBoardPageDat(boardID, boardPageNo, imgID, elemets)
    }
    /**
     * 关闭白板 其他参会者将收到notifyCloseBoard事件；同时后台会移除对应白板的所有信息；
     * @access public
     * @param {string} boardID - 白板标识
     */
    CRVideo_Closeboard = function(boardID) {
        CRVideo._crSdk.closeBoard(boardID)
    }
    /**
     * 创建一个符合云层要求的图元id 说明：本地操作;所有白板图元id，必须由此接口创建；（历史文件存储的图元id，在会议内不能再使用，应重新创建）
     * @access public
     * @returns {string} 图元id
     */
    CRVideo_CreateElementID = function() {
        CRVideo._crSdk.createElementID()
    }
    /**
     * 添加图元信息 说明：其他参会者会收到：notifyAddBoardElement事件;同时后台会保存图元，新入会者会在notifyInitBoardPageDat中得到这些图元
     * @access public
     * @param {string} boardID - 白板标识
     * @param {number} boardPageNo - 白板的页序号(0为第一页)
     * @param {string} element - 图元信息，参见json格式之BoardElementObj
     * @returns {string} elementID图元标识
     */
    CRVideo_Addboardelement = function(boardID, boardPageNo, element) {
        return CRVideo._crSdk.addBoardElement(boardID, boardPageNo, JSON.stringify(element))
    }
    /**
     * 修改图元信息 说明：其他参会者会收到：notifyModifyBoardElement事件;同时后台会覆盖对应图元的数据，新入会者会在notifyInitBoardPageDat中得到这些图元
     * @access public
     * @param {string} boardID - 白板标识
     * @param {number} boardPageNo - 白板的页序号(0为第一页)
     * @param {string} element - 图元信息，参见json格式之BoardElementObj
     * @returns {string} elementID图元标识
     */
    CRVideo_ModifyBoardElement = function(boardID, boardPageNo, element) {
        CRVideo._crSdk.modifyBoardElement(boardID, boardPageNo, JSON.stringify(element))
    }
    /**
     * 删除图元 说明：其他参会者会收到：notifyDelBoardElement事件;同时后台会移除这些图元，新入会者会在notifyInitBoardPageDat中将不包含这些图元
     * @access public
     * @param {string} boardID - 白板标识
     * @param {number} boardPageNo - 白板的页序号(0为第一页)
     * @param {string} elementIDs - 图元id列表，多值时，以“;”分隔，如：“id1;id2”
     */
    CRVideo_Delboardelement = function(boardID, boardPageNo, elementIDs) {
        CRVideo._crSdk.delBoardElement(boardID, boardPageNo, JSON.stringify(elementIDs))
    }
    /**
     * 设置鼠标热点消息
     * @access public
     * @param {string} boardID - 白板标识
     * @param {number} boardPageNo - 白板的页序号(0为第一页)
     * @param {number} x - 屏幕横坐标
     * @param {number} y - 屏幕纵坐标
     */
    CRVideo_Setmousehotspot = function(boardID, boardPageNo, x, y) {
        CRVideo._crSdk.setMouseHotSpot(boardID, boardPageNo, x, y)
    }
    /**
     * 获取会议网盘的容量信息 说明：调用结果请见事件getNetDiskSummaryRslt
     * @access public
     */
    CRVideo_GetNetDiskSummary = function() {
        CRVideo._crSdk.getNetDiskSummary()
    }
    /**
     * 获取网盘用户共享文件列表，即使用makeNetDiskFileID中参数fileType为0的生成的fileID上传的文件
     * @access public
     */
    CRVideo_GetNetDiskFileList = function() {
        CRVideo._crSdk.getNetDiskFileList()
    }
    /**
     * 生成网盘文件全局唯一ID
     * @access public
     * @param {number} fileType - 文件类型，0:用户共享文件，1:程序使用文件
     * @param {string} newFileName - 传入的全局唯一文件名，建议带文件后缀
     * 说明：1.fileType等于0时，为会议网盘共享文件，上传的文件可通过;
     * 		 2.getNetDiskFileList获取到文件列表详情
     * 		 3.fileType等于1时，用户程序内资源文件，如白板的背景图片，无法获取文件详情
     * 		 4.两种文件类型都要调用uploadNetDiskFile和downloadNetDiskFile进行上传和下载
     */
    CRVideo_MakeNetDiskFileID = function(fileType, newFileName) {
        return CRVideo._crSdk.makeNetDiskFileID(fileType, newFileName)
    }
    /**
     * 上传文件到网盘
     * @access public
     * @param {string} fileID - 网盘文件ID
     * @param {string} localFilePath - 本地文件路径,含文件名
     */
    CRVideo_Uploadnetdiskfile = function(fileID, localFilePath) {
        CRVideo._crSdk.uploadNetDiskFile(fileID, localFilePath)
    }
    /**
     * 设置网盘文件传输暂停或继续
     * @access public
     * @param {string} fileID - 网盘文件ID
     * @param {bool} bTranPause - 是否暂停
     */
    CRVideo_SetNetDiskTransportPause = function(fileID, bTranPause) {
        CRVideo._crSdk.setNetDiskTransportPause(fileID, bTranPause)
    }
    /**
     * 从网盘中下载文件
     * @access public
     * @param {string} fileID - 网盘文件ID
     * @param {string} localFilePath - 本地文件路径，全路径
     */
    CRVideo_Downloadnetdiskfile = function(fileID, localFilePath) {
        CRVideo._crSdk.downloadNetDiskFile(fileID, localFilePath)
    }
    /**
     * 取消网盘文件操作（上传/下载）
     * @access public
     * @param {string} fileID - 网盘文件ID
     */
    CRVideo_Canclenetdiskfile = function(fileID) {
        CRVideo._crSdk.cancleNetDiskFile(fileID)
    }
    /**
     * 删除网盘文件
     * @access public
     * @param {string} fileID - 网盘文件ID
     */
    CRVideo_Deletenetdiskfile = function(fileID) {
        CRVideo._crSdk.deleteNetDiskFile(fileID)
    }
    /**
     * 配置远程影音共享时，图像质量参数
     * @access public
     * @param {string} jsonCfg - json格式的字符串，详见VideoCfgOjb说明
     */
    CRVideo_SetMediacfg = function(jsonCfg) {
        return CRVideo._crSdk.setMediaCfg(JSON.stringify(jsonCfg))
    }
    /**
     * 暂无描述
     * @access public
     * @returns {string}
     */
    CRVideo_GetMediacfg = function() {
        return CRVideo._crSdk.getMediaCfg()
    }
    /**
     * 开始播放影音
     * @access public
     * 响应事件 如果播放成功，请关注通知事件notifyMediaOpened 如果播放失败，请关注通知事件notifyMediaStop
     * @param {string} filename  - 媒体文件名（本地全路径文件名，或网络流媒体，支持的协议有：http, rtmp, rtsp)
     * @param {number} locPlay  - 是否仅仅本地播放（1:本地播放，0：会议内播放）
     * @param {number} bPauseWhenFinished  - 是否播放完毕自动暂停在最后一帧
     */
    CRVideo_StartPlayMedia = function(filename, locPlay, bPauseWhenFinished) {
        if (bPauseWhenFinished == undefined) {
            bPauseWhenFinished = 0
        }
        if (locPlay == undefined) {
            locPlay = 0
        }
        CRVideo._crSdk.startPlayMedia(filename, locPlay, bPauseWhenFinished)
    }
    /**
     * 停止播放影音
     * @access public
     */
    CRVideo_StopPlayMedia = function() {
        CRVideo._crSdk.stopPlayMedia()
    }
    /**
     * 暂停或恢复播放影音
     * @access public
     * @param {bool} bPause - ture为暂停，false为恢复
     */
    CRVideo_PausePlayMedia = function(bPause) {
        CRVideo._crSdk.pausePlayMedia(bPause)
    }
    /**
     * 设置播放进度
     * @access public
     * @param {number} pos - 设置播放位置，单位：毫秒
     */
    CRVideo_SetMediaplaypos = function(pos) {
        CRVideo._crSdk.setMediaPlayPos(pos)
    }
    /**
     * @typedef {object} CRVideo_MediaInfoObj - 影音文件信息
     * @property {string} userID - 用户id
     * @property {number} state - 播放状态 0:播放 1:暂停 2:未播放
     * @property {string} mediaName - 影音文件名
     */
    /**
     * 取得影音文件信息
     * @access public
     * @param {string} userID - 用户id
     * @returns {CRVideo_MediaInfoObj} - 影音文件信息
     */
    CRVideo_Getmediainfo = function(userID) {
        return CRVideo._crSdk.getMediaInfo(userID)
    }
    /**
     * 取得影音帧信息
     * @access public
     * @param {string} userID - 用户id
     * @returns {CRVideo_VideoImgObj} - 帧信息
     */
    CRVideo_Getmediaimg = function(userID) {
        return CRVideo._crSdk.getMediaImg(userID)
    }
    /**
     * 取得播放路径下的所有可播放文件
     * @access public
     * @return {string[]} - 文件名列表；
     */
    CRVideo_GetAllFilesInMediaPath = function() {
        return CRVideo._crSdk.getAllFilesInMediaPath().split("\n");
    }
    /**
     * 是否正在文档转换
     * @access public
     * @return {bool}
     */
    CRVideo_IsCovering = function() {
        return CRVideo._crSdk.isCovering();
    }
    /**
     * 转换文档
     * @access public
     * @param {string} srcFilePathName - 本地需要转换的文件（包含路径）
     * @param {string} jsonParam - 保留字段
     */
    CRVideo_CoverFile = function(srcFilePathName, jsonParam) {
        CRVideo._crSdk.coverFile(srcFilePathName, jsonParam);
    }
    /**
     * 取消转换
     * @access public
     */
    CRVideo_CancelCover = function() {
        CRVideo._crSdk.cancelCover();
    }
    /**
     * @typedef {object} CRVideo_VideoAttributesObj - 视频设备私有属性 
     * @property {number} disabled  - 取值0:不禁用此设备(默认值)，1：禁用此设备；
     * @property {string} size  - 参见VideoCfgObj的描述，未配置时采用全局配置VideoCfgObj
     * @property {number} fps  - 参见VideoCfgObj的描述，未配置时采用全局配置VideoCfgObj
     * @property {number} maxbps   - 参见VideoCfgObj的描述，未配置时采用全局配置VideoCfgObj
     * @property {number} qp_min    - 参见VideoCfgObj的描述，未配置时采用全局配置VideoCfgOb
     * @property {number} qp_max   - 参见VideoCfgObj的描述，未配置时采用全局配置VideoCfgOb
     * @property {number} qp_max   - 第二档质量配置，支持的属性有：size, maxbps, qp_min, qp_max
     * @property {number} qp_max   - 第三档质量配置，支持的属性有：size, maxbps, qp_min, qp_max
     */
    /**
	 * 设置某个摄像头私有参数（未设置的参数，使用全局参数）
	 * @access public
	 * @param {string} videoID - 本地摄像头id
	 * @param {CRVideo_VideoAttributesObj} jsonAttributes - json格式，支持的参数有：
{"disabled": 取值0/1}，1:代表不启用此摄像头；
	 */
    CRVideo_SetLocVideoAttributes = function(videoID, jsonAttributes) {
        CRVideo._crSdk.setLocVideoAttributes(videoID, JSON.stringify(jsonAttributes));
    }
    /**
     * 获取某个摄像头私有参数
     * @access public
     * @param {string} videoID - 本地摄像头id
     * @return {CRVideo_VideoAttributesObj} - 私有参数, json格式
     */
    CRVideo_GetLocVideoAttributes = function(videoID) {
        return JSON.parse(CRVideo._crSdk.getLocVideoAttributes(videoID));
    }
    /**
     * 设置白板当前页号
     * @access public
     * @param {string} boardID - 当前白板ID
     * @param {number} pageNo - 当前白板的当前页号
     * @param {number} pagePos1 - 扩展参数1（设置页内X方向滚动条的滚动位置）
     * @param {number} pagePos2 - 扩展参数2（设置页内Y方向滚动条的滚动位置）
     */
    CRVideo_SetBoardCurPageNo = function(boardID, pageNo, pagePos1, pagePos2) {
        CRVideo._crSdk.setBoardCurPageNo(boardID, pageNo, pagePos1, pagePos2);
    }
    /**
     *创建自定义摄像头（sdk最大支持5个).添加成功后与本地摄像头处理一致；getAllVideoInfo接口可以识别摄像头类型。
     * @access public
     * @param {string} camName - 摄像头名称
     * @param {number} pixFmt - 参见VIDEO_FORMAT定义
     * @param {number} width - 图像宽度
     * @param {number} height - 图像高度
     * @param {string} extParams - 扩展参数，没有为空
     * @return {number} -  <0 ,失败, >=0, 为videoID(摄像头ID)
     */
    CRVideo_CreateCustomVideoDev = function(camName, pixFmt, width, height, extParams) {
        return CRVideo._crSdk.createCustomVideoDev(camName, pixFmt, width, height, extParams);
    }
    /**消毁自定义摄像头
     * @access public
     * @param {number} videoID - 摄像头id
     */
    CRVideo_DestroyCustomVideoDev = function(videoID) {
        CRVideo._crSdk.destroyCustomVideoDev(videoID);
    }
    /**
     * 输入摄像头图像数据
     * @access public
     * @param {number} videoID - 摄像头id
     * @param {string} base64Dat -  图像数据，base64编码。（请保证格式、和尺寸与摄像头匹配）
     * @param {number} timeStamp - 保留字段，请填0，
     */
    CRVideo_InputCustomVideoDat = function(videoID, base64Dat, timeStamp) {
        CRVideo._crSdk.inputCustomVideoDat(videoID, base64Dat, timeStamp);
    }
    /**
     * 输入摄像头图像数据2
     * @access public
     * @param {number} videoID - 摄像头id
     * @param {string} base64Dat -  图像数据，base64编码。（请保证格式、和尺寸与摄像头匹配）
     * @param {number} timeStamp - 保留字段，请填0，
     */
    CRVideo_InputCustomVideoDat2 = function(videoID, base64Dat, timeStamp) {
        CRVideo._crSdk.inputCustomVideoDat2(videoID, base64Dat, timeStamp);
    }
    /**
     *  请求某人开启屏幕共享
     * @access public
     * @param {number} sharerId - 需要开启共享的用户ID
     * @param {string} p_param -  自定义参数，可传空
     */
    CRVideo_RequestShare = function(sharerId, p_param) {
        CRVideo._crSdk.requestShare(sharerId, p_param);
    }
    /**
     *取消屏幕共享请求
     * @access public
     * @param {number} sharerId -需要取消的共享者ID,与CRVideo_RequestShare的参数对应
     */
    CRVideo_CancelShareRequestion = function(sharerId) {
        CRVideo._crSdk.cancelShareRequestion(sharerId);
    }
    /**
     *拒绝分享请求
     * @access public
     * @param {number} requesterId - 请求者ID
     * @param {string} param - 自定义参数，可传空
     */
    CRVideo_RejectShareRequestion = function(requesterId, param) {
        CRVideo._crSdk.rejectShareRequestion(requesterId, param);
    }
    /**
     * 创建桌面摄像头(sdk最大支持5个)
     * @access public
     * @param {string} camName - 摄像头名称
     * @param {number} monitor - 显示器序号，与系统显示编号一致，-1代表主屏。(创建时对应monitorID不存在时将失败， 运行中monitorID对应的屏关闭时显示全黑，开启后恢复正常工作）
     * @return {number}  - <0,  失败,  >=0, 为videoID(摄像头ID)
     */
    CRVideo_CreateScreenCamDev = function(camName, monitor) {
        return CRVideo._crSdk.createScreenCamDev(camName, monitor);
    }
    /**
     * 更新桌面摄像头
     * @access public
     * @param {number} videoID - 摄像头id
     * @param {number} monitor -  显示器序号，与系统显示编号一致，-1代表主屏。(monitorID不存在时将失败）
     * @return {bool}  - false失败, true成功
     */
    CRVideo_UpdateScreenCamDev = function(videoID, monitor) {
        return CRVideo._crSdk.updateScreenCamDev(videoID, monitor);
    }
    /**
     *  消毁桌面摄像头
     * @access public
     * @param {number} videoID - 摄像头id
     */
    CRVideo_DestroyScreenCamDev = function(videoID) {
        CRVideo._crSdk.destroyScreenCamDev(videoID);
    }


    /**
     *  查询服务器指定目录下的内容（子目录名、上传的文档源文件及文档转换状态）
     * @access public
     * @param {string} dir - 要查询的目录，空或"/"时，代表查询根目录下的内容；
     */
    CRVideo_ListNetDiskDocFile = function(dir) {
        CRVideo._crSdk.listNetDiskDocFile(dir);
    }
    /**
     *  上传并转换文档
     * @access public
     * @param {string} svrPathFileName - 服务器的路径文件名，包含目录时，服务器自动创建对应目录
     * @param {string} locPathFileName - 要上传文件的本地的路径文件名
     */
    CRVideo_UploadDocFileToNetDisk = function(svrPathFileName, locPathFileName) {
        CRVideo._crSdk.uploadDocFileToNetDisk(svrPathFileName, locPathFileName);
    }
    /**
     *  下载源始文档 
     * @access public
     * @param {string} svrPathFileName - 服务器的路径文件名，包含目录时，服务器自动创建对应目录
     * @param {string} locPathFileName - 要上传文件的本地的路径文件名
     */
    CRVideo_DownloadNetDiskDocFile = function(svrPathFileName, locPathFileName) {
        CRVideo._crSdk.downloadNetDiskDocFile(svrPathFileName, locPathFileName);
    }
    /**
     *  取消文档传输
     * @access public
     * @param {string} svrPathFileName - 服务器的路径文件名
     */
    CRVideo_CancelTransforNetDiskDocFile = function(svrPathFileName) {
        CRVideo._crSdk.cancelTransforNetDiskDocFile(svrPathFileName);
    }
    /**
     *  删除文档
     * @access public
     * @param {string} svrPathFileName - 服务器的路径文件名
     */
    CRVideo_DeleteNetDiskDocFile = function(svrPathFileName) {
        CRVideo._crSdk.deleteNetDiskDocFile(svrPathFileName);
    }
    /**
     *   获取文档的转换信息
     * @access public
     * @param {string} svrPathFileName - 服务器的路径文件名
     */
    CRVideo_GetNetDiskDocFilePageInfo = function(svrPathFileName) {
        CRVideo._crSdk.getNetDiskDocFilePageInfo(svrPathFileName);
    }
    /**
     *   下载文档转换后的页文件
     * @access public
     * @param {string} pagePathFileName - 页文件在服务器的路径文件名
     * @param {string} locPathFileName - 文件下载后存放的本地的路径文件名，目录不存在时自动创建
     */
    CRVideo_DownloadNetDiskDocFilePage = function(pagePathFileName, locPathFileName) {
        CRVideo._crSdk.downloadNetDiskDocFilePage(pagePathFileName, locPathFileName);
    }

    /**
     * 设置当前哪个用户为主视频
     * @access public
     * @param {string} userID - 用户ID
     */
    CRVideo_SetMainVideo = function(userID) {
        CRVideo._crSdk.mainVideo = userID;
    }
    /**
     * 获取当前哪个用户为主视频
     * @access public
     */
    CRVideo_GetMainVideo = function() {
        return CRVideo._crSdk.mainVideo;
    }
    /**
     * 调出摄像头驱动的高级配置（只对真实物理摄像头有效）
     * @access public
     * @param {number} videoID  - 摄像头id
     * @param {number} hParenWnd  - 高级配置界面的父窗口, 没有特别需求传0即可
     * @returns {bool} 返回 true/false
     * 
     */
    CRVideo_ShowVideoAdvCfgDlg = function(videoID, hParenWnd) {
        return CRVideo._crSdk.showVideoAdvCfgDlg(videoID, hParenWnd);
    }
    /**
     * @typedef {object} CRVideo_MixerCfgObj -  获混图器规格配置的参数,json结构体
     * @property {number} width - 图像宽度
     *  @property {number} height  - 图像高度
     * @property {number} frameRate  - 图像帧率，取值范围:1-30(值越大,cpu要求更高，录像推荐15帧，直播推存25帧)
     *@property {number} bitRate  - 录制视频文件的最高码率，当图像变化小时，实际码率会低于此值。
     *@property {number} defaultQP  - 录制视频文件的缺省质量，缺省值：26。取值范围：0~51，0表示完全无损, 51表示质量非常差，推荐高质量取值18，中质量26， 低质量34。
     *@property {number} gop  - I帧周期(I帧越少码率越小，但直播延时会越大）； 文件录制建议15秒一个I帧取值：fpsx15； 直播建议4秒一个I帧取值: fpsx4;
     */
    /**
     * @typedef {[{},{}]} CRVideo_MutiMixerCfgsObj -  混图器规格配置列表,json结构体数组。[
{"id":"1", "cfg":{"width":640,"height":320,"frameRate":8,"bitRate":500000,"defaultQP":28,"gop":120}}]
     * @property {number} id  - 混图器编号
	 * @property {CRVideo_MixerCfgObj} cfg  - CRVideo_MixerCfgObj
     */
    /**
     * @typedef {object} CRVideo_MixerContentObj -  获混图器内容配置的参数,json结构体数组
     * @property {number} left - 在混图画面中的区域（相对于混图器尺寸）
     * * @property {number} top - 在混图画面中的区域（相对于混图器尺寸）
     * * @property {number} width - 在混图画面中的区域（相对于混图器尺寸）
     * * @property {number} height - 在混图画面中的区域（相对于混图器尺寸）
     * @property {number} type  - 类型 CRVideo_MIXER_VCONTENT_TYPE
     * @property {number} keepAspectRatio - 内容保持原始比例，0不保持，1保持
     * @property {{}}} param - ":{"camid":"usr2.1"}}
     */
    /**
     * @typedef {object} CRVideo_MutiMixerContentsObj -  获混图器内容配置的参数,json结构体数组
     * @property  {number} id  - 混图器编号
     * @property {[{},{}]} content 混图器内容配置，参见CRVideo_MixerContentObj
     */
    /**
     * 创建本地混图器
     * @access public
     * @param {string} mixerID  - 混图器唯一标识
     * @param {CRVideo_MixerCfgObj} mixerCfg  - 混图器规格配置，json格式,详见CRVideo_MixerCfgObj
     * @param {CRVideo_MixerContentObj} mixerContent  - 混图器内容配置，json格式,详见CRVideo_MixerContentObj
     * @returns {number} 返回 错误码
     * 
     */
    CRVideo_CreateLocMixer = function(mixerID, mixerCfg, mixerContent) {
        return CRVideo._crSdk.createLocMixer(mixerID, JSON.stringify(mixerCfg), JSON.stringify(mixerContent));
    }
    /**
     * 更新本地混图器内容
     * @access public
     * @param {string} mixerID  - 混图器唯一标识
     * @param {CRVideo_MixerContentObj} mixerContent  - 混图器内容配置，json格式的字符串,详见CRVideo_MixerContentObj
     * @returns {number} 返回 错误码
     * 
     */
    CRVideo_UpdateLocMixerContent = function(mixerID, mixerContent) {
        return CRVideo._crSdk.updateLocMixerContent(mixerID, JSON.stringify(mixerContent));
    }
    /**
     * 消毁本地混图器
     * @access public
     * @param {string} mixerID  - 混图器唯一标识
     * @returns 无
     * 
     */
    CRVideo_DestroyLocMixer = function(mixerID) {
        CRVideo._crSdk.destroyLocMixer(mixerID);
    }
    /**
     * 获取本地混图器状态 
     * @access public
     * @param {string} mixerID  - 混图器唯一标识
     * @returns {number}  详见 CRVideo_MIXER_STATE
     * 
     */
    CRVideo_GetLocMixerState = function(mixerID) {
        return CRVideo._crSdk.getLocMixerState(mixerID);
    }
    /**
     * @typedef {object} CRVideo_MixerOutputObj -  本地输出对象,json结构体数组
     * @property {string} type  - 输出类型 CRVideo_MIXER_OUTPUT_TYPE
     * @property {string} filename - 录像路径文件名（本地录像名格式如：d:\1.mp4，服务器录像名格式如：/2018-11-21/1.mp4），支持的文件格式为mp4/ts/flv/avi，其中flv和ts两种格式在程序异常结束时产生的录制文件仍可用。
     * @property {number} encryptType   - 录像文件是否加密，0:不加密，1:加密；
     * @property {number} isUploadOnRecording  - 录像文件是否边录边传，0:不上传，1:边录边传; (此参数仅本地录像有效） 
     * @property {string} serverPathFileName - 边录边传时，上传到服务器的路径文件名； (此参数仅本地录像有效）
     * @property {string} liveUrl  - 直播推流地址，支持rtmp/rtsp
     * @property {number} errRetryTimes   - 直播推流异常时，重试次数
     */
    /**
     * @typedef {object} CRVideo_MutiMixerOutputsObj -  获混图器内容配置的参数,json结构体数组
     * @property  {number} id  - 混图器编号
     * @property {[{},{}]} output 混图器内容配置，参见CRVideo_MixerOutputObj
     */
    /**
     * 开启本地录制、直播推流
     * @access public
     * @param {string} mixerID  - 混图器唯一标识,，请确保创建了有效的混图器createLocMixer
     * @param {CRVideo_MixerOutputObj} mixerOutput  - 本地输出对象，json格式,CRVideo_MixerOutputObj
     * @returns {number} 返回 错误码
     * 
     */
    CRVideo_AddLocMixerOutput = function(mixerID, mixerOutput) {
        return CRVideo._crSdk.addLocMixerOutput(mixerID, JSON.stringify(mixerOutput));
    }
    /**
     * 停止本地录制、直播推流 
     * @access public
     * @param {string} mixerID  - 混图器唯一标识
     * @param {string} nameOrUrl - 要停止的录制文件名或直播url，支持多值，以";"分隔；
     * @returns 无
     */
    CRVideo_RmLocMixerOutput = function(mixerID, nameOrUrl) {
        CRVideo._crSdk.rmLocMixerOutput(mixerID, nameOrUrl);
    }
    /**
     * 开始云端录制、云端直播 
     * @access public
     *@param {CRVideo_MutiMixerCfgsObj} mutiMixerCfgs  - 服务器混图配置，定义见CRVideo_MutiMixerCfgsObj
     * @param {CRVideo_MutiMixerContentsObj} mutiMixerContents  - 服务器混图内容，定义见CRVideo_MutiMixerContentsObj
     *@param {CRVideo_MutiMixerOutputsObj} mutiMixerOutputs  - 服务器输出，定义见CRVideo_MutiMixerOutputsObj
     * @returns {number} 返回 错误码
     * 
     */
    CRVideo_StartSvrMixer = function(mutiMixerCfgs, mutiMixerContents, mutiMixerOutputs) {
        return CRVideo._crSdk.startSvrMixer(JSON.stringify(mutiMixerCfgs), JSON.stringify(mutiMixerContents), JSON.stringify(mutiMixerOutputs));
    }
    /**
     * 更新云端录制、云端直播内容 
     * @access public
     * @param {CRVideo_MutiMixerContentsObj} mutiMixerContents  - 服务器混图内容，定义见MutiMixerContentsObj
     * @returns {number} 返回 错误码
     * 
     */
    CRVideo_UpdateSvrMixerContent = function(mutiMixerContents) {
        return CRVideo._crSdk.updateSvrMixerContent(JSON.stringify(mutiMixerContents));
    }
    /**
     *  停止云端录制、云端直播 
     * @access public
     * 参数 无
     * @returns 无 
     */
    CRVideo_StopSvrMixer = function() {
        CRVideo._crSdk.stopSvrMixer();
    }
    /**
     * 获取云端录制、云端直播状态
     * @access public
     * @returns {number} 详见 CRVideo_MIXER_STATE
     * 
     */
    CRVideo_GetSvrMixerState = function() {
        return CRVideo._crSdk.getSvrMixerState();
    }
    /**
     * 设置某个用户的昵称
     * @access public
     * @param {string} userid  - 用户ID
     * @param {string} strNickName  - 新的用户昵称 
     * @returns 无
     * 
     */
    CRVideo_SetNickName = function(userid, strNickName) {
        CRVideo._crSdk.setNickName(userid, strNickName);
    }

    /**
     * 设置视频墙分屏模式2
     * @access public
     * @param {CRVideo_VIDEOLAYOUTMODE} videoWallMode - 分屏模式
     */
    CRVideo_SetVideoWallMode2 = function(videoWallMode) {
        CRVideo._crSdk.setVideoWallMode2(videoWallMode);
    }
    /**
     * 设置视频墙分屏模式2
     * @access public
     * @return {CRVideo_VIDEOLAYOUTMODE} videoWallMode - 分屏模式
     */
    CRVideo_GetVideoWallMode2 = function() {
        return CRVideo._crSdk.getVideoWallMode2();
    }
    /**
     * 获取录制文件信息
     * @access public
     * @param {string} fileName - 文件名， 不含路径
     * @return {CRVideo_RecordFileInfo} json格式,详见CRVideo_RecordFileInfo
     */
    CRVideo_GetRecordFileInfo = function(fileName) {
        return JSON.parse(CRVideo._crSdk.getRecordFileInfo(fileName));
    }
    /**
     * 剔出用户
     * @access public
     * @param {string} userId - 用户id
     */
    CRVideo_Kickout = function(userId) {
        CRVideo._crSdk.kickout(userId);
    }
    /**
     * 从录制管理器删除文件
     * @access public
     * @param {string} filename - 文件名
     * @return {number}
     */
    CRVideo_RemoveFromRecordMgr = function(filename) {
        return CRVideo._crSdk.removeFromRecordMgr(filename);
    }
    /**
     * 获取会议所有属性
     * @access public
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无
     */
    CRVideo_GetMeetingAllAttrs = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.getMeetingAllAttrs(cookie);
    }
    /**
     * 获取会议属性
     * @access public
     * @param {string} keys string数组，keys示例：["name","time"],
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无
     */
    CRVideo_GetMeetingAttrs = function(keys, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.getMeetingAttrs(keys, cookie);
    }
    /** 
     *@typedef {object} CRVideo_MeetingAttrObjs - 会议属性列表
    [
    	{"key":"x1", "value":"y1"},
    	{"key":"x2", "value":"y2"}
    ]
     * @property {string} key - 
     * @property {string} value - 
    *
    */
    /**
     * :设置会议属性
     * @access public
     * @param {json} attrs 会议属性,json结构体请参见 CRVideo_MeetingAttrObjs
     * @param {json} options "notifyAll"：是否发送通知消息（有此选项且值为1时发出通知消息，参见：notifyMeetingAttrsChanged）
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无
     */
    CRVideo_SetMeetingAttrs = function(attrs, options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.setMeetingAttrs(JSON.stringify(attrs), JSON.stringify(options), cookie);
    }
    /**
     * 增加或者更新会议属性
     * @access public
     * @param {string} attrs 会议属性,json结构体请参见 CRVideo_MeetingAttrObjs
     * @param {json} options "notifyAll"：是否发送通知消息（有此选项且值为1时发出通知消息，参见：notifyMeetingAttrsChanged）
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无
     */
    CRVideo_AddOrUpdateMeetingAttrs = function(attrs, options, cookie) {

        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.addOrUpdateMeetingAttrs(JSON.stringify(attrs), JSON.stringify(options), cookie);
    }
    /**
     * 删除会议属性
     * @access public
     * @param {string} keys string数组，keys示例：["name","time"],该数组包含了需要查询的会议属性关键字
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_DelMeetingAttrs = function(keys, options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.delMeetingAttrs(keys, JSON.stringify(options), cookie);
    }
    /**
     * 清除所有会议信息
     * @access public
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_ClearMeetingAttrs = function(options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.clearMeetingAttrs(JSON.stringify(options), cookie);
    }
    /**
     * 获取指定用户的指定属性
     * @access public 
     * * @param {string} uids string数组，uids示例：["lucy","Drake"...]  包含了即将要获取的用户的id，最多包含50个
     * * @param {string} keys string数组，
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无 
     * 例如想要查询lucy和Drake的是否允许聊天、用户身份等信息，uids:["lucy","Drake"...], keys:["","",...] 
     */
    CRVideo_GetUserAttrs = function(uids, keys, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.getUserAttrs(uids, keys, cookie);
    }

    /**
     * 设置用户属性
     * @access public 
     * * @param {string} uid 将被设置属性的用户名
     * *@param {json} attrs 用户属性,json结构体请参见 MeetingAttrObjs
     * * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_SetUserAttrs = function(uid, attrs, options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.setUserAttrs(uid, JSON.stringify(attrs), JSON.stringify(options), cookie);
    }
    /**
     * :增加或更新用户属性
     * @access public 
     * * @param {string} uid 将被设置属性的用户名
     * *@param {json} attrs 用户属性,json结构体请参见 UserAttrObjs
     * * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_AddOrUpdateUserAttrs = function(uid, attrs, options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.addOrUpdateUserAttrs(uid, JSON.stringify(attrs), JSON.stringify(options), cookie);
    }
    /**
     * :删除用户的特定属性
     * @access public 
     * * @param {string} uid 将被设置属性的用户名
     * *@param {string}keys string数组，，该数组包含了需要删除的用户属性关键字
     * * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_DelUserAttrs = function(uid, keys, options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.delUserAttrs(uid, keys, JSON.stringify(options), cookie);
    }
    /**
     * :清除所有用户属性
     * @access public 
     * * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_ClearAllUserAttrs = function(options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.clearAllUserAttrs(JSON.stringify(options), cookie);
    }
    /**
     * :清除特定用户属性
     * @access public 
     * @param {string}  uid
     * * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_ClearUserAttrs = function(uid, options, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.clearUserAttrs(uid, JSON.stringify(options), cookie);
    }
    /**
     * 发送房间内自定义广播消息
     * @access public 
     * @param {string}  msg 用户自定义消息
     * @param {string} cookie 可为空字符串。详细介绍见 关键词
     * @return 无  
     */
    CRVideo_SendMeetingCustomMsg = function(msg, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.sendMeetingCustomMsg(msg, cookie);
    }
    //----------------------------------------
    //
    //排队接口
    //
    //---------------------------------------
    /**
     * 初始化用户队列功能数据。
     * 操作完成回调CRVideo_InitQueueDatRslt，初始化成功后才可获取队列队列相关信息。
     * @access public
     * @param {string} cookie -自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_InitQueueDat = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.initQueueDat(cookie);
    }
    /**
     * 刷新所有队列状态信息。
     * 操作完成则触发CRVideo_QueueStatusChanged（当前排队的队列，或服务的队列，sdk自动有状态变化回调； 其它队列则需要此函数来查询）。
     * @access public
     */
    CRVideo_RefreshAllQueueStatus = function() {
        CRVideo._crSdk.refreshAllQueueStatus();
    }
    /**
     * @typedef {object} CRVideo_QueueStatusObj - 队列状态 {"queID":0,"agent_num":12,"wait_num":3,"srv_num":11}
     * @property {string} queID - 队列ID
     * @property {string} agent_num - 坐席数
     * @property {string} wait_num - 等待人数
     * @property {number} srv_num - 正在服务人数 
     */
    /**
     * 获取所有队列信息
     * @access public
     * @returns {CRVideo_QueueInfo[]} 返回所有队列信息
     */
    CRVideo_GetAllQueueInfo = function() {
        return JSON.parse(CRVideo._crSdk.getAllQueueInfo());
    }
    /**
     * @typedef {object} CRVideo_QueueInfo - 队列信息 {"queID":0,"name":"aaa","desc":"this is desc","prio":1}
     * @property {string} queID - 队列ID
     * @property {string} name - 队列名称
     * @property {string} desc - 队列描述
     * @property {number} prio - 优先级，值越小优先级越高 
     */
    /**
     * 获取队列状态
     * @access public
     * @param {string} queID  - 队列ID
     * @returns {CRVideo_QueueStatusObj} 
     */
    CRVideo_GetQueueStatus = function(queId) {
        return JSON.parse(CRVideo._crSdk.getQueueStatus(queId));
    }
    /**
     * @typedef {object} CRVideo_QueuingInfo - 排队信息
     * @property {string} queID - 队列ID 我排的队列(-1:代表我没有排队；-2:代表我正在会话中,通过GetSessionInfo可获取相关信息)
     * @property {string} position - 我的位置
     * @property {string} queuingTime - 我排队的时长(单位s)
     */
    /**
     * 获取我的排队信息
     * @access public
     * @returns {CRVideo_QueuingInfo} 返回排队信息
     */
    CRVideo_GetQueuingInfo = function() {
        return JSON.parse(CRVideo._crSdk.getQueuingInfo());
    }
    /**
     * 获取我服务的所有队列
     * @access public
     * @returns {string[]} 返回我服务的队列列表
     */
    CRVideo_GetServingQueues = function() {
        return CRVideo._crSdk.getServingQueues().split("\n");;
    }
    /**
     * @typedef {object} CRVideo_SessionInfo - 排队信息
     * @property {string} callID - 会话的呼叫ID
     * @property {string} peerID - 会话的目标用户ID
     * @property {string} peerName - 会话的目标用户昵称
     * @property {number} bCallAccepted - 呼叫是否被对方接受 0:暂未接受，1:已接受
     * @property {number} meetingID - 呼叫接受后，分配的会议ID
     * @property {string} meetingPswd - 会议密码
     * @property {number} duration - 会议持续的时长(单位s)
     */
    /**
     * 获取我的会话信息
     * @access public
     * @returns {CRVideo_SessionInfo} info - 返回会话信息

     */
    CRVideo_GetSessionInfo = function() {
        return JSON.parse(CRVideo._crSdk.getSessionInfo());
    }
    /**
     * 客户开始排队
     * 操作完成回调CRVideo_StartQueuingRslt
     * @access public
     * @param {string} queID  - queID 队列ID
     * @param {string} cookie - cookie自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_StartQueuing = function(queID, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.startQueuing(queID, cookie);
    }
    /**
     * 客户开始排队
     * 操作完成回调CRVideo_StartQueuingRslt
     * @access public
     * @param {number} queID  - queID 队列ID
     * @param {string} usrExtDat - 自定义扩展参数
     * @param {string} cookie - cookie自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_StartQueuing2 = function(queID, usrExtDat, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        if (usrExtDat === undefined) {
            usrExtDat = "";
        }
        CRVideo._crSdk.startQueuing2(queID, usrExtDat, cookie);
    }
    /**
     * 客户停止排队
     * 操作完成回调CRVideo_StopQueuingRslt
     * @access public
     * @param {string} cookie - cookie自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_StopQueuing = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.stopQueuing(cookie);
    }
    /**
     * 开始服务某个队列(可以多次调用，开启对多个队列的服务)
     * 操作回调CRVideo_StartServiceRslt
     * 开启成功后：
     * a. 如果没有开启免打挽，那么系统会自动分配客户：VideoCall_Queue_CallBack::autoAssignUser；
     * b. 如果开启免打挽，系统就不会分配客户，如需服务客户可调用：reqAssignUser。
     * @access public
     * @param {number} queID  - 队列ID
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_StartService = function(queID, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.startService(queID, cookie);
    }
    /**
     * 开始服务某个队列(可以多次调用，开启对多个队列的服务)，可以设置优先级
     * 操作回调CRVideo_StartServiceRslt
     * 开启成功后：
     * a. 如果没有开启免打挽，那么系统会自动分配客户：VideoCall_Queue_CallBack::autoAssignUser；
     * b. 如果开启免打挽，系统就不会分配客户，如需服务客户可调用：reqAssignUser。
     * @access public
     * @param {number} queID  - 队列ID
     * @param {number} priority - 优先级，设置优先级，数字越小，优先级越高
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_StartService2 = function(queID, priority, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        if (priority === undefined) {
            priority = 2;
        }
        CRVideo._crSdk.startService2(queID, priority, cookie);
    }
    /**
     * 停止服务某个队列
     * 操作完成回调CRVideo_StopServiceRslt
     * @access public
     * @param {string} queID  - queID 队列ID
     * @param {string} cookie - cookie自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_StopService = function(queID, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.stopService(queID, cookie);
    }
    /**
     * 接受系统安排的客户
     * @access public
     * @param {string} queID  - 队列ID
     * @param {string} userID - 队列中的用户ID
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_AcceptAssignUser = function(queID, userID, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.acceptAssignUser(queID, userID, cookie);
    }
    /**
     * 拒绝系统安排的客户
     * @access public
     * @param {string} queID  - 队列ID
     * @param {string} userID - 队列中的用户ID
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_RejectAssignUser = function(queID, userID, cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.rejectAssignUser(queID, userID, cookie);
    }
    /**
     * 请求分配一个客户
     * 当关闭免打扰时，系统将自动分配客户，无需调用此函数；
     * 当开启免打扰时，系统不再自动分配客户，座席如需服务客户可使用此函数分配；
     * @access public
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_ReqAssignUser = function(cookie) {
        if (cookie === undefined) {
            cookie = "";
        }
        CRVideo._crSdk.reqAssignUser(cookie);
    }
    /**
     * 获取队列用户列表
     * @access public
     * @property {string} queID - 队列ID
     */
    CRVideo_GetQueueUsers = function(queID) {
        return CRVideo._crSdk.getQueueUsers(queID);
    }
    /**
     * 请求分配一个指定的客户
     * @access public
     * @param {string} queID  - 队列ID
     * @param {string} userID - 队列中的用户ID
     * @param {string} cookie - 自定义数据 (在回调时，回传给调用者)
     */
    CRVideo_ReqAssignUser2 = function(queID, userID, cookie) {
        if (cookie === undefined) cookie = "";
        CRVideo._crSdk.reqAssignUser2(queID, userID, cookie);
    }
     /**
     * 检查是否支持对应虚拟背景功能 
     * @access public
     * @param {number} type  -  0 不启用虚拟背景功能,1	绿幕模式,2 人像模式 
     * @return true:支持，false:不支持
     */
    CRVideo_BSupportVirtualBackground= function(type) {
       
        return CRVideo._crSdk.bSupportVirtualBackground(type);
    }

     /**
     * 配置虚拟背景参数 
     * @access public
     * @param {VirtualBkCfg} cfg json结构字符串  - 虚拟背景参数
     * @return true:成功，false:失败
     */
    CRVideo_SetVirtualBackground= function(cfg) {
       
       return CRVideo._crSdk.setVirtualBackground(JSON.stringify(cfg));
    }
    /**
     * 获取虚拟背景参数 
     * @access public
     * @return VirtualBkCfg json,虚拟背景参数
     */ 
    CRVideo_GetVirtualBackground= function() {
       
        return JSON.parse(CRVideo._crSdk.getVirtualBackground());
     }

    // /**
    //  * 
    //  * @access public
    //  * @return {number} 
    //  */
    // CRVideo_GetLocMicDevEnergy = function() {
    //     return CRVideo._crSdk.getLocMicDevEnergy();
    // }

    //----------------------------
    //
    //http上传下载管理
    //
    //-------------------------------------------
    /**
     * @typedef {object} CRVideo_FileInfo - Http文件传输信息(params详细说明：decodeCREEFile：取值0或1。此参数仅上传有效，为0时上传原始文件，为1时上传解密的文件)
     * @property {number} bUploadType - 传输类型，0:下载类型，1:上传类型
     * @property {string} filePathName - 本地完整路径文件名(路径中要求有“CloudroomVideoSDK”)
     * @property {string} fileVersion - 文件版本（可以填版本号，也可以md5，也可以为空）
     * @property {string} httpUrl - 目标URL
     * @property {object} params - 特殊参数，字典数据。
     * @property {object} extHeaders - http头部扩展信息，字典数据。
     * @property {number} fileSize - 文件大小
     * @property {number} finishedSize - 已传输大小
     * @property {CRVideo_HTTP_TRANSFER_STAT} state - 文件传输状态，详见：HTTP_TRANSFER_STATE
     */
    /**
     * 启动http文档上传下载功能
     * @access public
     */
    CRVideo_StartMgr = function() {
        CRVideo._crSdk.startMgr();
    }
    /**
     * 启动http文档上传下载功能
     * @access public
     */
    CRVideo_StartHttpMgr = function() {
        CRVideo._crSdk.startMgr();
    }
    /* 停止http文档上传下载功能
     * @access public
     */
    CRVideo_StopMgr = function() {
        CRVideo._crSdk.stopMgr();
    }
    /* 停止http文档上传下载功能
     * @access public
     */
    CRVideo_StopHttpMgr = function() {
        CRVideo._crSdk.stopMgr();
    }
    /**
     * 获取本地所有上传、下载文件信息
     * @access public
     * @returns {CRVideo_HttpFileInfoObjs} filelist - 返回文件信息列表
     */
    CRVideo_GetAllTransferInfos = function() {
        return JSON.parse(CRVideo._crSdk.getAllTransferInfos());
    }
    /**
     * 获取本地上传、下载文件信息
     * @access public
     * @property {string} filePathName - 本地完整路径文件名(路径中要求有“CloudroomVideoSDK”)
     * @returns {CRVideo_HttpFileInfoObj} fileinfo - 返回文件信息
     */
    CRVideo_GetTransferInfo = function(filePathName) {
        return JSON.parse(CRVideo._crSdk.getTransferInfo(filePathName));
    }
    /**
     * 开始下载/上传文件
     * @access public
     * @property {CRVideo_HttpReqInfoObj} fileinfo - 格式的文件信息
     */
    CRVideo_StartTransferFile = function(fileinfo) {
        CRVideo._crSdk.startTransferFile(JSON.stringify(fileinfo));
    }
    /**
     * 取消传输，取消时，只是停止了传输任务，不清理记录及断点文件。
     * @access public
     * @property {string} fileName - 本地路径文件名
     */
    CRVideo_CancelFileTransfer = function(fileName) {
        CRVideo._crSdk.cancelFileTransfer(fileName);
    }
    /**
     * 删除传输记录及相关文件
     * @access public
     * @property {string} fileName - 本地路径文件名
     * @property {number} bRemoveLocFile - 是否移除本地文件,为1时， 那么上传的源始文件、下载的临时文件或结果文件都将被移除。
     */
    CRVideo_RmTransferInfo = function(fileName, bRemoveLocFile) {
        CRVideo._crSdk.rmTransferInfo(fileName, bRemoveLocFile);
    }


    //----------------------------
    //
    //视频、媒体、共享控件相关接口
    //
    //-------------------------------------------


    /**
     * 创建video对象
     * @access public
     */
    CRVideo_CreatVideoObj = function() {
        var handler;
        if (CRVideo_Is_ActiveXObject) {
            if (CRVideo.ie && CRVideo.v == 8.0) {
                handler = document.createElement("<object classid=\"clsid:8A6BBBDC-C6BE-4a47-92F3-F9581C3FB95E\" ></object>")
            } else {
                handler = document.createElement("object")
                handler.classid = "clsid:8A6BBBDC-C6BE-4a47-92F3-F9581C3FB95E";
            }
        } else {
            handler = document.createElement("object")
            handler.type = "application/x-cloudroom-videoui"
        }

        var video = new CRVideo.VideoContainer();
        video.handler(handler)
        video.dblClickFullScreen(CRVideo.dblClickFullScreen);
        return video;
    }
    /**
     * 创建media对象
     * @access public
     */
    CRVideo_CreatMediaObj = function() {
        var handler;
        if (CRVideo_Is_ActiveXObject) {
            if (CRVideo.ie && CRVideo.v == 8.0) {
                handler = document.createElement("<object classid=\"clsid:93A618D5-2535-42d0-B72B-95705263F398\" ></object>")
            } else {
                handler = document.createElement("object")
                handler.classid = "clsid:93A618D5-2535-42d0-B72B-95705263F398";
            }

        } else {
            handler = document.createElement("object")
            handler.type = "application/x-cloudroom-mediaui"
        }

        var media = new CRVideo.MediaContainer();
        media.handler(handler)
        media.dblClickFullScreen(CRVideo.dblClickFullScreen);
        return media;
    }
    /**
     * 创建screenShare对象
     * @access public
     */
    CRVideo_CreatScreenShareObj = function() {
        var handler;
        if (CRVideo_Is_ActiveXObject) {
            if (CRVideo.ie && CRVideo.v == 8.0) {
                handler = document.createElement("<object classid=\"clsid:6FF142C5-8A36-49d7-B627-D60B803550FC\" ></object>")
            } else {
                handler = document.createElement("object");
                handler.classid = "clsid:6FF142C5-8A36-49d7-B627-D60B803550FC";
            }
        } else {
            handler = document.createElement("object");
            handler.type = "application/x-cloudroom-screenshareui"
        }

        var screenShare = new CRVideo.ScreenShareContainer();
        screenShare.handler(handler);
        return screenShare;
    }
    /**
     * 创建whiteBoard 白板对象
     * @access public
     */
    CRVideo_CreatBoardObj = function() {
        var handler;
        if (CRVideo_Is_ActiveXObject) {
            if (document.getElementById("crBoardObj")) {
                handler = document.getElementById("crBoardObj");
            }
        } else {
            if (document.getElementById("crBoardObjG")) {
                handler = document.getElementById("crBoardObjG")
            }
        }
        var board = new CRVideo.BoardContainer();
        board.handler(handler);
        return board;
    }
}
window["000a0180686911e78dd0a45d36bb8c5c"] = true